<?php

namespace App\Http\Controllers;
use Illuminate\Foundation\Auth\AuthenticatesUsers;
use Illuminate\Http\Request;
use DB;
use Auth;
use Illuminate\Support\Facades\Redirect;
use App\Models\User;
use PDF;
use Illuminate\Support\Str;
use Illuminate\Support\Facades\Hash;
use GuzzleHttp\Client as GuzzleClient;
use GuzzleHttp\Client;

class RevenueshareController extends Controller
{
    public function link(Request $request)
    {
      $uniqueIdentifier = Str::random(10); 
      $link = route('revenueshareforms', ['key' => $uniqueIdentifier]);
     $values = array('unique_identifier_value' => $uniqueIdentifier);
     DB::table('comm_unique_identifier')->insert($values);
     return response()->json(['link' => $link]);
    }

    public function form(Request $request)
    {   
        $fullUrl = $request->fullUrl();
        $parsedUrl = parse_url($fullUrl, PHP_URL_PATH);

        // Isolate the word before the '?'
        $path = strtok($parsedUrl, '?');

        // Extract the last part of the path
        $segments = explode('/', $path);
        $formname = end($segments);

        $key = $request['key'];
     
        $data = DB::table('comm_unique_identifier')->select('created_at')->where('unique_identifier_value',$request['key'])->get();    
        $formattedDate = $data[0]->created_at;
 
        return view('form',compact('formattedDate','key','formname'));
    }
    public function forms(Request $request,$key,$username)
    {     

  
        $data = DB::table('comm_revenue_form')->where('keys1',$key)->get();

        $users = DB::table('users')->where('name',$username)->first();
       $uid =  $users->uid;
        $data1 = DB::table('users')->select('uid','name')->get();
        $data2 = DB::table('release_table')->select('upc')->where('uid',$uid)->get();

        $upcValues = $data2->pluck('upc')->toArray();

        // Query the 'audio' table using the 'upc' values retrieved from 'release_table'
        $data3 = DB::table('audio')
            ->select('upc', 'isrc')
            ->whereIn('upc', $upcValues)  // Use 'whereIn' to filter by 'upc'
            ->get();
    
	  //  $data3 = DB::table('audio')->select('upc', 'isrc')->get();
 		$upcToIsrcMap = [];
foreach ($data3 as $row) {
    $upcToIsrcMap[$row->upc][] = $row->isrc;
}
      
        if(count($data) >= 1){
            $data = 0;
            return view('revenueform',compact('data','key','users','data1','data2','upcToIsrcMap'));
        }
        $data=1;
        return view('revenueform',compact('data','key','users','data1','data2','upcToIsrcMap'));

    }
    public function getallvalues_revenue(Request $request)
    {
        $data = DB::table('comm_revenue_form_multiple')->where('sid',$request['formid'])->get();

        $data1 = DB::table('comm_revenue_form')->where('id',$request['formid'])->get();
        $uid = $data1[0]->userid;
        $data2 = DB::table('user_referral_percentage')->where('uid',$uid)->get();

        $data3 = DB::table('artist_percentage')->where('uid',$uid)->get();
      
        return response()->json(['data' => $data,'data2' => $data2,'data3' => $data3]);
    }
    public function formdetails()
    {     
 
        $data = DB::table('comm_revenue_form')->get();
  
$getmessages = '';

//FSA
//Standard payment list
//registeredmail
//associated mail

$data1 = DB::table('comm_subtask')->get();

//request from the email
$data2 = DB::table('comm_unique_identifier')->get();

$data3 = DB::table('comm_slack')->get();
$data4 = DB::table('comm_form_status')->get();

        return view('revenueshare',compact('data','getmessages','data1','data2','data3','data4'));

    }
    public function revenueasanaapprove(Request $request)
    { 
        $result = DB::table('comm_revenue_form')->where('id',$request['formid'])->update([
            "asana_confirm" => '1'

        ]);
    }
    public function revenueslackapprove(Request $request)
    { 
        $result = DB::table('comm_revenue_form')->where('id',$request['formid'])->update([
            "slack_confirm" => '1'

        ]);
    }
    
    public function getcomments(Request $request)
    {     
 
        $ASANA_ACCESS_TOKEN = "2/1208316400186719/1208316769447199:421ee9aae5a8b4111046340e7dbf4a5f";
        //$ASANA_ACCESS_TOKEN = "2/1207778564029631/1207918270167868:216b00a985ab0fc07541c83514ff4038";

        $guzzleClient = new GuzzleClient(['base_uri' => 'https://app.asana.com/api/1.0/']);
        $headers = ['Authorization' => 'Bearer ' . $ASANA_ACCESS_TOKEN, 'Content-Type' => 'application/json',];

        if ($ASANA_ACCESS_TOKEN === false) {
            echo "Please set the ASANA_ACCESS_TOKEN environment variable.\n";
            exit;
        }


        $subtaskId = $request['subtaskid'];
        $response = $guzzleClient->request('GET', "tasks/$subtaskId/stories", [
            'headers' => [
                'Authorization' => 'Bearer ' . $ASANA_ACCESS_TOKEN,
                'Content-Type' => 'application/json',
            ]
        ]);

        $comments = json_decode($response->getBody(), true);

        return response()->json(['comments' => $comments]);
  

    }
   

    public function subtaskcreate(Request $request)
    {  
      
            $taskid = $request->input('taskid');
            $mail = $request->input('mail');
             
            $data = DB::table('comm_revenue_form')->where('id',$taskid)->get();


         //   $ASANA_ACCESS_TOKEN = "2/1207778564029631/1207918270167868:216b00a985ab0fc07541c83514ff4038";
         $ASANA_ACCESS_TOKEN = "2/1208316400186719/1208316769447199:421ee9aae5a8b4111046340e7dbf4a5f";

            $guzzleClient = new GuzzleClient(['base_uri' => 'https://app.asana.com/api/1.0/']);
            $headers = ['Authorization' => 'Bearer ' . $ASANA_ACCESS_TOKEN, 'Content-Type' => 'application/json',];

            if ($ASANA_ACCESS_TOKEN === false) {
                echo "Please set the ASANA_ACCESS_TOKEN environment variable.\n";
                exit;
            }

    

            // $projectId='1207778564029665';
           
        
            // $response = $guzzleClient->request('GET', "projects/$projectId/tasks", [
            //     'headers' => [
            //         'Authorization' => 'Bearer ' . $ASANA_ACCESS_TOKEN,
            //         'Content-Type' => 'application/json',
            //     ]
            // ]);
        
            // // Decode the response
           // $tasks = json_decode($response->getBody(), true);
        
            // foreach ($tasks['data'] as $task) {
            //     echo "Task ID: " . $task['gid'] . " - " . $task['name'] . PHP_EOL;
            // }

            $taskId='1208316751155307';
            $newProject = $guzzleClient->request('POST', "tasks/".$taskId."/subtasks", [
                'headers' => $headers,
                'json' => [
                    'data' => [
                        'name' => $data[0]->username.'('.$data[0]->userid.')',
                        'assignee' => 'mcldev24@gmail.com', 
                        'notes' => 'Can you please check the userid('.$data[0]->userid.') for the FSA Payment Tracker?'
                    ]
                ],
            ]);
            

            $projectPlan = json_decode($newProject->getBody(), true)['data'];
            $user = Auth::user();

            $message = '';
            if($projectPlan['gid'] && $projectPlan['gid'] != '') {
                $message .= "Asana Subtask Created Successfully...!";
                $result = DB::table('comm_subtask')->insert([
                    "userid" => $taskid,
                    "gid" => $projectPlan['gid'],
                    "type" => 'revenueform'

                ]);
            }

            $subtaskId = $projectPlan['gid'];
            $response = $guzzleClient->request('GET', "tasks/$subtaskId/stories", [
                'headers' => [
                    'Authorization' => 'Bearer ' . $ASANA_ACCESS_TOKEN,
                    'Content-Type' => 'application/json',
                ]
            ]);

            $comments = json_decode($response->getBody(), true);

            return response()->json(['details' => json_encode($projectPlan), 'message' => $message,'comments' => $comments,'gid'=>$subtaskId]);
      
        }
  
        public function postcomments(Request $request)
        {  
            $ASANA_ACCESS_TOKEN = "2/1208316400186719/1208316769447199:421ee9aae5a8b4111046340e7dbf4a5f";


               // $ASANA_ACCESS_TOKEN = "2/1207778564029631/1207918270167868:216b00a985ab0fc07541c83514ff4038";
    
                $guzzleClient = new GuzzleClient(['base_uri' => 'https://app.asana.com/api/1.0/']);
                $headers = ['Authorization' => 'Bearer ' . $ASANA_ACCESS_TOKEN, 'Content-Type' => 'application/json',];
    
                if ($ASANA_ACCESS_TOKEN === false) {
                    echo "Please set the ASANA_ACCESS_TOKEN environment variable.\n";
                    exit;
                }
                $subtaskId = $request['gid'];
                $requestData = [
                    'data' => [
                        'text' => $request['comment']
                    ]
                ];
            
                // Post a new comment to the subtask
                $postResponse = $guzzleClient->request('POST', "tasks/$subtaskId/stories", [
                    'headers' => [
                        'Authorization' => 'Bearer ' . $ASANA_ACCESS_TOKEN,
                        'Content-Type' => 'application/json',
                    ],
                    'json' => $requestData
                ]);
            
                // Decode the response to check the status of the new comment
                $newCommentResponse = json_decode($postResponse->getBody(), true);
            
            
 
                
                $response = $guzzleClient->request('GET', "tasks/$subtaskId/stories", [
                    'headers' => [
                        'Authorization' => 'Bearer ' . $ASANA_ACCESS_TOKEN,
                        'Content-Type' => 'application/json',
                    ]
                ]);
    
                $comments = json_decode($response->getBody(), true);
    
                return response()->json(['comments' => $comments]);
          
            }
        public function commentinslack(Request $request)
        { 
            

        $client = new Client();

         $endpoint = 'https://slack.com/api/chat.postMessage';
         $token = "xoxb-6898630061328-6861380470567-sBJdnLKIuImJcnsh2jMipbO1";
         $channelId = 'C06U5U7PPTL';
        $response = $client->post($endpoint, [
            'form_params' => [
                'channel' => $channelId,
                'token' => $token,
                "text" => $request['comment'],
            ],
            'headers' => [
                'Authorization' => 'Bearer ' . $token,
                'Content-Type' => 'application/x-www-form-urlencoded',
            ]
        ]);
        $body = $response->getBody();
        $responseArray = json_decode($body, true);
        
        if (isset($responseArray['ok']) && $responseArray['ok']) {
            // Successfully posted the message
            $ts = $responseArray['message']['ts']; // Timestamp of the posted message
        
        
           DB::table('comm_slack')->insert([
                "form_id" => $request['formid'],
                "message_ts" => $ts
            ]);
        }



    
        $getmsg = DB::table('comm_slack')->where('form_id',$request['formid'])->get();
        $result = '';
        if($getmsg != ''){
            $result=[];
            foreach($getmsg as $getmsgs){
                $messageTs = $getmsgs->message_ts;
            
            $client = new Client();
            
            $token = "xoxb-6898630061328-6861380470567-sBJdnLKIuImJcnsh2jMipbO1";
            $channelId = 'C06U5U7PPTL';
            $response = $client->request('GET', 'https://slack.com/api/conversations.history', [
                'headers' => [
                    'Authorization' => 'Bearer ' . $token,
                ],
                'query' => [
                    'channel' => $channelId,
                    'latest' => $messageTs, // Use the message's ts as the latest time boundary
                    'oldest' => $messageTs, // Use the message's ts as the oldest time boundary
                    'inclusive' => true, // Include messages with latest or oldest timestamp
                ],
            ]);
            
            $result[] = $response->getBody()->getContents();
            
            
            
            
            }
        }
        
        $userData='';
        $replymessages='';
        $getmessages='';
        
        $response=[];
        $replymessages=[];
        $userData=[];
        $getmessages=[];
            foreach ($result as $results) {
               
                                            
                $response = json_decode($results, true);
             
           
                foreach ($response['messages'] as $message) {
                    $getmessages[]= $message;
               
                }
               }
                  
         if($getmessages!=''){
            foreach($getmessages as $replymsg)
            {
                if (isset($replymsg['reply_count']) && $replymsg['reply_count'] > 0) {
                    // Fetch replies for this message
                    $repliesResponse = $client->request('GET', 'https://slack.com/api/conversations.replies', [
                        'headers' => [
                            'Authorization' => 'Bearer ' . $token,
                        ],
                        'query' => [
                            'channel' => $channelId,
                            'ts' => $replymsg['ts'], // Timestamp of the message
                        ],
                    ]);
                
                    $replymessages[] = json_decode($repliesResponse->getBody(), true);
                  
                     
                    
                
                }   
            }
        
            if(!(empty($replymessages))){
            foreach($replymessages as $reply)
        {
            foreach($reply['messages'] as $replies){
                if (isset($replies['user'])) {
                  
                    // Retrieve user information using 'users.info' method
                    $userResponse = $client->request('GET', 'https://slack.com/api/users.info', [
                        'headers' => [
                            'Authorization' => 'Bearer ' . $token,
                        ],
                        'query' => [
                            'user' => $replies['user'],
                        ],
                    ]);
                
                    $userData[] = json_decode($userResponse->getBody(), true);
                
                   
                }
            }
           
            
        }  
            }else{
            foreach($getmessages as $replymsg)
            {
                
                if (isset($replymsg['user'])) {
                    // Retrieve user information using 'users.info' method
                    $userResponse = $client->request('GET', 'https://slack.com/api/users.info', [
                        'headers' => [
                            'Authorization' => 'Bearer ' . $token,
                        ],
                        'query' => [
                            'user' => $replymsg['user'],
                        ],
                    ]);
                
                    $userData[] = json_decode($userResponse->getBody(), true);
                
                   
                }
            }
        }
        
    }

         return response()->json(['ts'=>$ts,'getmessages' => $getmessages,'replymessages'=>$replymessages,'userData'=>$userData]);

    }
    public function getcommentslack(Request $request)
    { 
        $getmsg = DB::table('comm_slack')->where('form_id',$request['formid'])->get();
        $result = '';
        if($getmsg != ''){
            $result=[];
            foreach($getmsg as $getmsgs){
                $messageTs = $getmsgs->message_ts;
            
            $client = new Client();
            
            $token = "xoxb-6898630061328-6861380470567-sBJdnLKIuImJcnsh2jMipbO1";
            $channelId = 'C06U5U7PPTL';
            $response = $client->request('GET', 'https://slack.com/api/conversations.history', [
                'headers' => [
                    'Authorization' => 'Bearer ' . $token,
                ],
                'query' => [
                    'channel' => $channelId,
                    'latest' => $messageTs, // Use the message's ts as the latest time boundary
                    'oldest' => $messageTs, // Use the message's ts as the oldest time boundary
                    'inclusive' => true, // Include messages with latest or oldest timestamp
                ],
            ]);
            
            $result[] = $response->getBody()->getContents();
            
            
            
            
            }
        }
        
        $userData='';
        $replymessages='';
        $getmessages='';
        
        $response=[];
        $replymessages=[];
        $userData=[];
        $getmessages=[];
            foreach ($result as $results) {
               
                                            
                $response = json_decode($results, true);
             
           
                foreach ($response['messages'] as $message) {
                    $getmessages[]= $message;
               
                }
               }
                  
         if($getmessages!=''){
            foreach($getmessages as $replymsg)
            {
                if (isset($replymsg['reply_count']) && $replymsg['reply_count'] > 0) {
                    // Fetch replies for this message
                    $repliesResponse = $client->request('GET', 'https://slack.com/api/conversations.replies', [
                        'headers' => [
                            'Authorization' => 'Bearer ' . $token,
                        ],
                        'query' => [
                            'channel' => $channelId,
                            'ts' => $replymsg['ts'], // Timestamp of the message
                        ],
                    ]);
                
                    $replymessages[] = json_decode($repliesResponse->getBody(), true);
                  
                     
                    
                
                }   
            }
        
            if(!(empty($replymessages))){
            foreach($replymessages as $reply)
        {
            foreach($reply['messages'] as $replies){
                if (isset($replies['user'])) {
                  
                    // Retrieve user information using 'users.info' method
                    $userResponse = $client->request('GET', 'https://slack.com/api/users.info', [
                        'headers' => [
                            'Authorization' => 'Bearer ' . $token,
                        ],
                        'query' => [
                            'user' => $replies['user'],
                        ],
                    ]);
                
                    $userData[] = json_decode($userResponse->getBody(), true);
                
                   
                }
            }
           
            
        }  
            }else{
            foreach($getmessages as $replymsg)
            {
                
                if (isset($replymsg['user'])) {
                    // Retrieve user information using 'users.info' method
                    $userResponse = $client->request('GET', 'https://slack.com/api/users.info', [
                        'headers' => [
                            'Authorization' => 'Bearer ' . $token,
                        ],
                        'query' => [
                            'user' => $replymsg['user'],
                        ],
                    ]);
                
                    $userData[] = json_decode($userResponse->getBody(), true);
                
                   
                }
            }
        }
        
    }

         return response()->json(['getmessages' => $getmessages,'replymessages'=>$replymessages,'userData'=>$userData]);
    }


    public function revenueformsubmit(Request $request)
    {    



        // $values = [
        //     'email' => $request['email1'],
        //     'username' => $request['username1'],
        //     'userid' => $request['userid'],
        //     'upc' => $request['upc'],
        //     'isrc' => $request['isrc'],
        //     'percentage_userid' => implode(',',$request['shareUPC']),
        //     'percentage_username' => implode(',',$request['sharename']),
        //     'percentage' => implode(',',$request['percentage']),
        // ];
    
        // // Insert the data into the database
        // DB::table('comm_revenue_form')->insert($values);
        // return redirect()->back()->with('success', 'Revenue Share Request form submitted Successfully.');


    //}

   

        DB::beginTransaction();
        $numberOfInputs = intval($request->input('hid-vls')); // Convert to integer

        // Array to store dynamically created values
        $values = [];

        $values1 = [
            'email' => $request->input('email1'),
            'username' => $request->input('username1'),
            'userid' => $request->input('userid'),
            'keys1' => $request->input('key'),
        ];
        $result = DB::table('comm_revenue_form')->insertGetId($values1);

// echo $result;
// echo "<br/> --------------";

        // Loop through the number of inputs
        for ($j = 1; $j <= $numberOfInputs; $j++) {
            // Construct the name of the input field
            $inputName = "json-input-$j";

            // Example of fetching the input value (assuming the input names are coming from a form)
            $inputValue = $request->input($inputName);

            // Store the value in an array
            $values[$inputName] = $inputValue;


            $result1 = DB::table('comm_revenue_form_multiple')->insertGetId([
               "sid" => $result,
               "RevenueShareTo" => json_encode($inputValue)
            ]);

            // echo $result;
            // echo "<br/>  --------------";
        }

      

        // Start a database transaction
        // DB::beginTransaction();

        // $values = [
        //     'email' => $request->input('email1'),
        //     'username' => $request->input('username1'),
        //     'userid' => $request->input('userid'),
        //     // 'RevenueShareTo' => json_encode($request->input($name)),
        //     // 'upc' => $request->input('upcInput'),
        //     // 'isrc' => $request->input('isrc'),
        //     // 'percentage_userid' => implode(',', $request->input('shareUPC')),
        //     // 'percentage_username' => implode(',', $request->input('sharename')),
        //     // 'percentage' => implode(',', $request->input('percentage')),
        // ];
        // $formId = DB::table('comm_revenue_form')->insertGetId($values);

        // dd( $formId);

        // for ($j = 1; $j <= number_format($request->input('hid-vls')); $j++) {
            
        //     $name = "json-input-".$j;
        //         // comm_revenue_form_mul
        //         $result = DB::table('comm_revenue_form')->insert([
        //             'sid' => $formId,
        //             'RevenueShareTo' => json_encode($request->input($name))
        //         ]);
        //         // $result = DB::select("INSERT INTO `comm_revenue_form_mul`(`sid`, `RevenueShareTo`) VALUES ('".$formId."', ".json_encode($request->input($name)).")");
        //         if($result) {
        //             dd($result);
        //         }else {
        //             dd($result);
        //         }
        //         // echo "INSERT INTO `comm_revenue_form`(`userid`, `username`, `email`, `RevenueShareTo`) VALUES ('".$request->input('userid')."','".$request->input('username1')."','".$request->input('email1')."', ".json_encode($request->input($name)).")";
        //         // $formId = DB::table('comm_revenue_form')->insertGetId($values);
        //         // // $formId = DB::table('comm_revenue_form')->insertGetId($values);
        //         // if($formId) {
        //         //     echo "done";
        //         //     dd($formId);
        //         // }else {
        //         //     dd($formId);
        //         // }
        //     };
           
            //     print_r($values);
            // };
            // exit;
                // Insert the data into 'comm_revenue_form' and get the inserted ID
                // $formId = DB::table('comm_revenue_form')->insertGetId($values);
            

            // Prepare data for 'comm_revenue_additional'
            // $additionalData = [];
            // $shareUPC = $request->input('shareUPC');
            // $sharename = $request->input('sharename');
            // $percentage = $request->input('percentage');

            // // Ensure that all arrays have the same length
            // if (count($shareUPC) !== count($sharename) || count($shareUPC) !== count($percentage)) {
            //     throw new \Exception('Mismatch in the length of input arrays.');
            // }

            // // Loop through each item and prepare data for 'comm_revenue_additional'
            // for ($i = 0; $i < count($shareUPC); $i++) {
            //     $additionalData[] = [
            //         'revenue_id' => $result,
            //         'upc' => $request->input('upcInput', null), // Default to null if not provided
            //         'isrc' => $request->input('isrc', null), // Default to null if not provided
            //         'percentage_userid' => $shareUPC[$i],
            //         'percentage_username' => $sharename[$i],
            //         'percentage' => $percentage[$i],
            //     ];
            // }

            // // Insert the data into 'comm_revenue_additional' table
            // DB::table('comm_revenue_additional')->insert($additionalData);
         // Commit the transaction
            DB::commit();
    //    }
    

        return redirect()->back()->with('success', 'Thanks for submitting your revenue sharing request! This has been received successfully and you will be contacted via email soon with any updates.');
    // } catch (\Exception $e) {
    //     // Rollback the transaction in case of error
    //     DB::rollBack();

     
        //return redirect()->back()->withErrors(['error' => 'An error occurred while submitting the form.']);
    //}
}


    public function exportform3(Request $request)
    {       

       $data = DB::table('comm_revenue_form')
 ->where('id',$request['id'])->get();
 $data1 = DB::table('comm_revenue_form_multiple')
 ->where('sid',$request['id'])->get();
 $pdf = PDF::loadView('exportform3',compact('data','data1'));
        return $pdf->download('exportform.pdf'); 
        
    }


 
  
}



