<?php

namespace App\Http\Controllers;
use Illuminate\Foundation\Auth\AuthenticatesUsers;
use Illuminate\Http\Request;
use DB;
use Auth;
use Illuminate\Support\Facades\Redirect;
use App\Models\User;
use PDF;
use Illuminate\Support\Str;
use Illuminate\Support\Facades\Hash;
use GuzzleHttp\Client as GuzzleClient;
use GuzzleHttp\Client;

class YoutubeController extends Controller
{
    public function link(Request $request)
    {
      $uniqueIdentifier = Str::random(10); 
      $link = route('youtubeoac', ['key' => $uniqueIdentifier]);
     $values = array('unique_identifier_value' => $uniqueIdentifier);
     DB::table('comm_unique_identifier')->insert($values);
     return response()->json(['link' => $link]);
    }

    public function form(Request $request)
    {   
        $fullUrl = $request->fullUrl();
        $parsedUrl = parse_url($fullUrl, PHP_URL_PATH);

        // Isolate the word before the '?'
        $path = strtok($parsedUrl, '?');

        // Extract the last part of the path
        $segments = explode('/', $path);
        $formname = end($segments);

        $key = $request['key'];
     
        $data = DB::table('comm_unique_identifier')->select('created_at')->where('unique_identifier_value',$request['key'])->get();    
        $formattedDate = $data[0]->created_at;
 
        return view('form',compact('formattedDate','key','formname'));
    }
    public function forms(Request $request,$key,$username)
    {     


        $data = DB::table('comm_oac_form')->where('keys1',$key)->get();
        $users = DB::table('users')->where('name',$username)->first();
       
        $upclist = DB::table('release_table')->where('uid',$users->uid)->get();
        $upcDetails = [];  // This will hold the final result with the concatenated string

        foreach ($upclist as $upc) {
            // Get album name
            $album = DB::table('album_metadata')
                        ->select('value')
                        ->where('upc_id', $upc->upc) // Use $upc->upc to access the UPC
                        ->where('tag', 'album')
                        ->first(); // Use first() instead of get()
        
            // Get album version
            $albumver = DB::table('album_metadata')
                          ->select('value')
                          ->where('upc_id', $upc->upc)
                          ->where('tag', 'albumversion')
                          ->first(); // Use first() instead of get()
        
            // Get artist title
            $artist = DB::table('album_metadata')
                        ->select('value')
                        ->where('upc_id', $upc->upc)
                        ->where('tag', 'artist')
                        ->first(); // Use first() instead of get()
        
            // Concatenate the values to form the desired string
            if ($album && $albumver && $artist) {
                // Form the desired format: "album + version, artist"
                $upcDetails[] = $upc->upc .' - '. $album->value . ' + ' . $albumver->value . ' , ' . $artist->value;
            }
        }
    
       
        if(count($data) >= 1){
            $data = 0;
          
        
            return view('oacform',compact('data','key','users','upcDetails'));
        }
        $data=1;
        return view('oacform',compact('data','key','users','upcDetails'));

    }

    public function formdetails()
    {     
 
        $data = DB::table('comm_oac_form')->get();

        $data1 = DB::table('comm_oacidslack')->get();




$data2 = DB::table('comm_form_status')->get();


        return view('oac',compact('data','data1','data2'));

    }

    public function fsacheck(Request $request)
{
    $sel_fra_count = DB::table('flag_comment')
    ->where('uid', $request['uid'])
    ->whereIn('flagtype', ['FraudStrike', 'fraud_streaming'])
    ->count();

if ($sel_fra_count != 0) {
    // Check the count of users records
    $sel_fra_sdt_count = DB::table('users')
        ->where('possible_fraud', 0)
        ->where('under_investigation', 0)
        ->where('paypal_issue', 0)
        ->where('indianpaypal', 0)
        ->where('fraud_streaming', 0)
        ->where(function ($query) {
            $query->whereNull('bank_transfer')
                  ->orWhere('bank_transfer', 0);
        })
        ->where('uk_vat_flag', 0)
        ->where('uid',$uid)
        ->count();

    if ($sel_fra_sdt_count != 0) {
        $fsacheck = '0';
    } else {
        $fsacheck = '1';
    }
} else {
    $fsacheck = '0';
}

$upc = $request['upc'];

$sql1 = DB::table('moderation_hub_log')
    ->where('upc', $upc)
    ->orderBy('id', 'desc')
    ->first();

if ($sql1) {
    $upc1 = $sql1->upc;
    $admin_name = $sql1->admin_name;
    $admin_uid = $sql1->admin_uid;
    $action = $sql1->action;

    if ($admin_uid == '1201527' && $action == 'Assigned by') {
        echo "This $upc1 has a peterRN hub page.";
    } else {
        // Fetch from moderation_log if the first condition is not met
        $sql2 = DB::table('moderation_log')
            ->where('upc', $upc)
            ->orderBy('id', 'desc')
            ->first();

        if ($sql2) {
            $upc2 = $sql2->upc;
            $admin_uid2 = $sql2->admin_uid;
            $action2 = $sql2->action;

            if ($admin_uid2 == '1201527' && $action2 == 'Assigned by (Moderate)') {
                $petermod = '1';
            } else {
                $petermod = '0';
            }
        } else {
            $petermod = '0';
        }
    }
} else {
    $petermod = '0';
}



return response()->json(['fsacheck'=>$fsacheck,'petermod'=>$petermod]);

}
    public function verifyupc(Request $request)
    { 
        $result = DB::table('comm_oac_form')->where('id',$request['id'])->update([
            "upc_verified" => '1'

        ]);
    }
 
    public function verifyslack(Request $request)
    { 
        $result = DB::table('comm_oac_form')->where('id',$request['id'])->update([
            "slack_verified" => '1'

        ]);
    }
 
 
      
       
        public function commentslack(Request $request)
        { 
            

        $client = new Client();

         $endpoint = 'https://slack.com/api/chat.postMessage';
         $token = "xoxb-6898630061328-6861380470567-sBJdnLKIuImJcnsh2jMipbO1";
         $channelId = 'C06U5U7PPTL';
         if($request->has('cmts')){
            $response = $client->post($endpoint, [
                'form_params' => [
                    'channel' => $channelId,
                    'token' => $token,
                    "text" => $request['cmts'],
                ],
                'headers' => [
                    'Authorization' => 'Bearer ' . $token,
                    'Content-Type' => 'application/x-www-form-urlencoded',
                ]
            ]);
            $body = $response->getBody();
            $responseArray = json_decode($body, true);
            
            if (isset($responseArray['ok']) && $responseArray['ok']) {
                $ts = $responseArray['message']['ts']; // Timestamp of the posted message
            
            
               DB::table('comm_oacidslack')->insert([
                    "formid" => $request['id'],
                    "message_ts" => $ts
                ]);
            }

         }
       

    
     
        $getmsg = DB::table('comm_oacidslack')->where('formid',$request['id'])->get();
        $result = '';
        if($getmsg != ''){
            $result=[];
            foreach($getmsg as $getmsgs){
                $messageTs = $getmsgs->message_ts;
            
            $client = new Client();
            
            
            $response = $client->request('GET', 'https://slack.com/api/conversations.history', [
                'headers' => [
                    'Authorization' => 'Bearer ' . $token,
                ],
                'query' => [
                    'channel' => $channelId,
                    'latest' => $messageTs, // Use the message's ts as the latest time boundary
                    'oldest' => $messageTs, // Use the message's ts as the oldest time boundary
                    'inclusive' => true, // Include messages with latest or oldest timestamp
                ],
            ]);
            
            $result[] = $response->getBody()->getContents();
            
            
            
            
            }
        }
        
        $userData='';
        $replymessages='';
        $getmessages='';
        
        $response=[];
        $replymessages=[];
        $userData=[];
        $getmessages=[];
            foreach ($result as $results) {
               
                                            
                $response = json_decode($results, true);
             
           
                foreach ($response['messages'] as $message) {
                    $getmessages[]= $message;
               
                }
               }
                  
         if($getmessages!=''){
            foreach($getmessages as $replymsg)
            {
                if (isset($replymsg['reply_count']) && $replymsg['reply_count'] > 0) {
                    // Fetch replies for this message
                    $repliesResponse = $client->request('GET', 'https://slack.com/api/conversations.replies', [
                        'headers' => [
                            'Authorization' => 'Bearer ' . $token,
                        ],
                        'query' => [
                            'channel' => $channelId,
                            'ts' => $replymsg['ts'], // Timestamp of the message
                        ],
                    ]);
                
                    $replymessages[] = json_decode($repliesResponse->getBody(), true);
                  
                     
                    
                
                }   
            }
        
            if(!(empty($replymessages))){
            foreach($replymessages as $reply)
        {
            foreach($reply['messages'] as $replies){
                if (isset($replies['user'])) {
                  
                    // Retrieve user information using 'users.info' method
                    $userResponse = $client->request('GET', 'https://slack.com/api/users.info', [
                        'headers' => [
                            'Authorization' => 'Bearer ' . $token,
                        ],
                        'query' => [
                            'user' => $replies['user'],
                        ],
                    ]);
                
                    $userData[] = json_decode($userResponse->getBody(), true);
                
                   
                }
            }
           
            
        }  
            }else{
            foreach($getmessages as $replymsg)
            {
                
                if (isset($replymsg['user'])) {
                    // Retrieve user information using 'users.info' method
                    $userResponse = $client->request('GET', 'https://slack.com/api/users.info', [
                        'headers' => [
                            'Authorization' => 'Bearer ' . $token,
                        ],
                        'query' => [
                            'user' => $replymsg['user'],
                        ],
                    ]);
                
                    $userData[] = json_decode($userResponse->getBody(), true);
                
                   
                }
            }
        }
        
         }
      
   
    if($request->has('cmts')){
         return response()->json(['ts'=>$ts,'getmessages' => $getmessages,'replymessages'=>$replymessages,'userData'=>$userData]);
    }else{
        return response()->json(['getmessages' => $getmessages,'replymessages'=>$replymessages,'userData'=>$userData]);

    }
    }
    public function getoacslack(Request $request)
    { 
        $ts = $request['ts'];
        $client = new Client();
        $token = "xoxb-6898630061328-6861380470567-sBJdnLKIuImJcnsh2jMipbO1";
        $channelId = 'C06U5U7PPTL';
        $response = $client->request('GET', 'https://slack.com/api/conversations.history', [
            'headers' => [
                'Authorization' => 'Bearer ' . $token,
            ],
            'query' => [
                'channel' => $channelId,
                'latest' => $ts, // Use the message's ts as the latest time boundary
                'oldest' => $ts, // Use the message's ts as the oldest time boundary
                'inclusive' => true, // Include messages with latest or oldest timestamp
            ],
        ]);
        
        $result = $response->getBody()->getContents();
        
        $userData='';
        $replymessages='';
        $getmessages='';
        $response = json_decode($result, true);
        $replymessages='';


        
           
        $token = "xoxb-6898630061328-6861380470567-sBJdnLKIuImJcnsh2jMipbO1";
        //$channelId = 'C06S4EV5Y9F';
        $channelId = 'C06U5U7PPTL';
        //$messageTs = '1712723834.404199';
        $getmsg = DB::table('comm_oacidslack')->get();
        $result = '';
        if($getmsg != ''){
            $result=[];
            foreach($getmsg as $getmsgs){
                $messageTs = $getmsgs->message_ts;
            
            $client = new Client();
            
            
            $response = $client->request('GET', 'https://slack.com/api/conversations.history', [
                'headers' => [
                    'Authorization' => 'Bearer ' . $token,
                ],
                'query' => [
                    'channel' => $channelId,
                    'latest' => $messageTs, // Use the message's ts as the latest time boundary
                    'oldest' => $messageTs, // Use the message's ts as the oldest time boundary
                    'inclusive' => true, // Include messages with latest or oldest timestamp
                ],
            ]);
            
            $result[] = $response->getBody()->getContents();
            
            
            
            
            }
        }
        
        
        $userData='';
        $replymessages='';
        $getmessages='';
        
        
            foreach ($result as $results) {
               
                                            
                $response = json_decode($results, true);
                $replymessages=[];
                $userData=[];
                $getmessages=[];
                foreach ($response['messages'] as $message) {
                    $getmessages[]= $message;
               
                }
               }
               
         if($getmessages!=''){
            foreach($getmessages as $replymsg)
            {
                if (isset($replymsg['reply_count']) && $replymsg['reply_count'] > 0) {
                    // Fetch replies for this message
                    $repliesResponse = $client->request('GET', 'https://slack.com/api/conversations.replies', [
                        'headers' => [
                            'Authorization' => 'Bearer ' . $token,
                        ],
                        'query' => [
                            'channel' => $channelId,
                            'ts' => $replymsg['ts'], // Timestamp of the message
                        ],
                    ]);
                
                    $replymessages[] = json_decode($repliesResponse->getBody(), true);
                  
                     
                    
                
                }   
            }
        
            if(!(empty($replymessages))){
            foreach($replymessages as $reply)
        {
            foreach($reply['messages'] as $replies){
                if (isset($replies['user'])) {
                  
                    // Retrieve user information using 'users.info' method
                    $userResponse = $client->request('GET', 'https://slack.com/api/users.info', [
                        'headers' => [
                            'Authorization' => 'Bearer ' . $token,
                        ],
                        'query' => [
                            'user' => $replies['user'],
                        ],
                    ]);
                
                    $userData[] = json_decode($userResponse->getBody(), true);
                
                   
                }
            }
           
            
        }  
            }else{
            foreach($getmessages as $replymsg)
            {
                
                if (isset($replymsg['user'])) {
                    // Retrieve user information using 'users.info' method
                    $userResponse = $client->request('GET', 'https://slack.com/api/users.info', [
                        'headers' => [
                            'Authorization' => 'Bearer ' . $token,
                        ],
                        'query' => [
                            'user' => $replymsg['user'],
                        ],
                    ]);
                
                    $userData[] = json_decode($userResponse->getBody(), true);
                
                   
                }
            }
        }
        
         }

         return response()->json(['getmessages' => $getmessages,'replymessages'=>$replymessages,'userData'=>$userData]);
    }


    public function oacformsubmit(Request $request)
    {    



$image = $request->file('file');
$directoryPath = 'uploadfiles/';
$image->move(public_path($directoryPath),$image->getClientOriginalName());
$filepath = url($directoryPath).'/'.$image->getClientOriginalName();

$data = DB::table('comm_tbl_smthub_ticket')->where('keys1', $request->input('key'))->get();

$values = [
            'id' => $data[0]->id,
            'email' => $request['email1'],
            'username' => $request['username1'],
            'userid' => $request['userid'],
            'artist_name' => $request['thrid_in'],
            'country' => $request['four_in'],
            'artist_channel_url' => $request['five_in'],
            'artist_channel_id' => $request['six_in'],
            'video_url' => $request['seven_in'],
            'topic_channel_url' => $request['eitie_in'],
            'topic_video_url' => $request['ninen_in'],
            'upc' => $request['ten_in'],
            'dashboard' => $filepath,
            'keys1' =>  $request['key']
            
        ];
        DB::table('comm_tbl_smthub_ticket')->where('keys1', $request->input('key'))->update(['status' => "Admin Action Needed"]);
        // Insert the data into the database
        DB::table('comm_oac_form')->insert($values);
        return redirect()->back()->with('success', 'YouTube Official Artist Channel Request Form Submitted Successfully.');


    }

    public function exportform1(Request $request)
    {       

       $data = DB::table('comm_oac_form')->where('id',$request['id'])->get();
      
        $pdf = PDF::loadView('exportform1',compact('data'));
        return $pdf->download('export.pdf'); 
        
    }



  
}



