<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Session;

class ChatbotController extends Controller
{
    // public function getResponse(Request $request)
    // {
    //     $userMessage = strtolower($request->input('message'));

    //     // Query the database for the bot response
    //     $response = DB::table('comm_chatbot')->where('userMessage', $userMessage)->first();

    //     if ($response) {
    //         return response()->json(['reply' => $response->botResponse]);
    //     }

    //     return response()->json(['reply' => "Sorry, I don't understand."]);
    // }

    public function getResponse(Request $request){
        
        // Connect to the database and fetch results
        try {
            
            $text = json_encode($request->input('message'));
            $text = str_replace("?", "", $text);
            $text = str_replace(",", "", $text);
            $text = str_replace(".", "", $text);

            $greetings_keywords = [
                "what's up today", "hello", "helo", "hi", "hey", "good morning", 
                "good evening", "greetings", "good", "Hello, good evening", 
                "Hello good evening", "hello, good evening", "hello good evening",
                "hi there", "hey there", "yo", "howdy", "good day", 
                "good afternoon", "how's it going", "what's going on", 
                "how are you", "howdy-do", "g'day", "hey there, how are you", 
                "what's up", "what's good", "salutations", "hiya", "morning", 
                "evening", "sup", "hey y'all", "g'day mate", 
                "hola", "bonjour", "ciao", "konbanwa", "namaste", "how's everything", 
                "how are you doing", "what's happening", "what's new", "hey hey", 
                "how's life", "aloha", "yo yo", "how's it hanging", "hey there, what's up", 
                "peace", "hiya there", "what's cracking", "how are things", "greetings to you", 
                "top of the morning", "what's up with you", "yo what's up", "salut", 
                "how's your day", "how’s your day going", "all good", "what's the word", 
                "how you doing", "morning sunshine", "hey buddy", "hey friend", 
                "sup bro", "what’s cooking", "how’s everything going", "what’s the vibe","what is doing","what are you doing"
            ];

            $entertainment_keywords = [
                "movie", "film", "entertainment", "concert", "cricket", "football", 
                "sports", "news", "photos", "ai", "television", "tv show", "series", 
                "music", "album", "singer", "band", "theater", "musical", "actor", 
                "actress", "director", "producer", "documentary", "comedy", "drama", 
                "action", "romance", "thriller", "horror", "scifi", "anime", "cartoon", 
                "gaming", "video game", "e-sports", "streaming", "podcast", "live show", 
                "festival", "art", "photography", "dance", "poetry", "novel", "book", 
                "literature", "comic", "graphic novel", "pop culture", "celebrity", 
                "red carpet", "award show", "Oscars", "Emmy", "Grammy", "MTV", 
                "live performance", "fashion", "style", "tech", "gadgets", "apps", 
                "virtual reality", "augmented reality", "cybersecurity", "youtube", 
                "tiktok", "social media", "streaming service", "Netflix", "HBO", "Disney+", 
                "Prime Video", "Apple TV", "Hulu", "gaming console", "PC gaming", 
                "VR gaming", "arcade", "board games", "tabletop games", "vlogs", 
                "DIY", "lifestyle", "beauty", "makeup", "skincare", "cooking", 
                "fitness", "health", "travel", "adventure", "reality show", "talk show", 
                "quiz show", "live event", "celebration", "party", "barbecue", 
                "concert tour", "music video", "celebration", "soundtrack"
            ];           
            $thanks_keywords = [
                "How's your day going so far", "thank", "thankyou", "thank you", "thanks", 
                "thank you", "appreciate", "cheers", "great", "Brilliant", "brilliant", 
                "cool", "Cool", "Great", "much appreciated", "many thanks", "thanks a lot", 
                "thanks so much", "thanks a million", "thanks a bunch", "thanks indeed", 
                "appreciated", "I'm grateful", "I'm thankful", "thanks heaps", "thanks kindly", 
                "I appreciate it", "really appreciate it", "I can't thank you enough", 
                "you’re the best", "you rock", "you're amazing", "you're awesome", 
                "I owe you one", "forever grateful", "I’m so thankful", "kudos", "props", 
                "hats off", "big thanks", "heartfelt thanks", "thank you so much", 
                "much obliged", "thankful", "appreciation", "appreciative", "I’m touched", 
                "sincere thanks", "gratitude", "that means a lot", "that’s so kind of you", 
                "thank you from the bottom of my heart", "you’ve been a huge help", 
                "you have my gratitude", "I’m indebted to you", "you’re too kind", 
                "super grateful", "so grateful", "immense thanks", "deeply appreciate"
            ];

            
            $analyst_name = [
                "What's your name", "who are you", "whats ur name", "who r u", 
                "what's your name again", "may I know your name", "who is this", 
                "who's this", "what do they call you", "what's your name please", 
                "can I know your name", "how should I call you", "what do you go by", 
                "who am I talking to", "what's your handle", "who is this speaking", 
                "can you tell me your name", "what's your full name", "can you introduce yourself", 
                "what's your identity", "who might I be speaking to", "what is your name", 
                "may I ask your name", "who are you exactly", "what's your title", 
                "what should I call you", "what do people call you", "tell me your name", 
                "name please", "could you tell me your name", "can you share your name"
            ];

            $what_do_for = [
                "What can you do for me", "What you do for me", "what can do for me", "what you do", 
                "what can I ask you to do", "what can you help me with", "what do you offer", 
                "how can you assist me", "how can you help me", "what services do you provide", 
                "what's your role", "what's your purpose", "what can you assist with", 
                "what are your capabilities", "what are you capable of", "how can you help", 
                "what can you help me with today", "what are you able to do", "what do you offer me", 
                "what tasks can you handle", "what can I request from you", "what can you provide", 
                "how can you be of service", "what can I get from you", "how can you be useful", 
                "what do you have to offer", "how can you make my life easier", "what do you do best", 
                "how can I benefit from you", "what's in it for me", "how can you improve things for me", 
                "what help can you offer", "what will you do for me", "how can you make a difference for me", 
                "what can you bring to the table", "what value can you provide", "what do you do exactly", 
                "what's your function", "what's your contribution", "how can you assist me with this", 
                "what help can I expect from you"
            ];

            $sorry_text = [
                "sorry", "Sorry", "sry", "Sry", "my apologies", "apologies", 
                "I’m sorry", "I apologize", "I’m so sorry", "I’m truly sorry", 
                "sorry about that", "sorry for that", "sorry for the inconvenience", 
                "I beg your pardon", "pardon me", "excuse me", "oops", "whoops", 
                "my bad", "didn’t mean to", "forgive me", "please forgive me", 
                "I didn’t mean to", "I didn’t intend to", "I didn’t mean it", 
                "I didn’t know", "I regret that", "I feel bad", "I feel sorry", 
                "I’m at fault", "I was wrong", "I’m sorry for that", "please accept my apologies", 
                "I’m sorry for any trouble", "please excuse me", "sorry if I caused any issues", 
                "forgive my mistake", "I take full responsibility", "I’m deeply sorry", 
                "so sorry about that", "I feel awful", "I’m sorry for the confusion", 
                "I truly regret that", "I’m so embarrassed", "please accept my sincerest apologies", 
                "I apologize for the delay", "apologies for the misunderstanding", 
                "sorry for any inconvenience caused"
            ];

            $check = ['text', 'test', 'check'];

            $help = [
                "What’s new with you", "What's good today", "how can I help", 
                "need help", "what can I do for you", "how can I assist", 
                "anything I can do", "what’s up", "how can I support", 
                "how’s it going", "how’s everything", "what’s happening", 
                "anything new", "what's going on", "how are you doing", 
                "can I help you with something", "anything I can assist with", 
                "anything you need", "what's going on today", "how can I be of help", 
                "need anything", "how can I make it easier for you", 
                "what do you need help with", "anything I can do to assist", 
                "do you need help with something", "can I offer any assistance", 
                "anything on your mind", "what’s the situation", "how are things", 
                "anything to discuss", "need any help", "what do you need", 
                "what do you want to talk about", "what's the latest", 
                "what can I do to make your day better", "how can I make this easier", 
                "what’s been happening", "can I assist with anything", "how’s everything going"
            ];

            if (in_array(strtolower($text), $greetings_keywords)) {
                return response()->json(['reply' => "Hello! How can I assist you today?"]);
            
            }elseif(in_array(strtolower($text), $entertainment_keywords)){
                return response()->json(['reply' => "To better assist you, please narrow down your inquiry by providing the form ID, user ID, ticket ID, or UPC ID along with your question. This will help ensure I offer the most relevant assistance."]);
            }
            elseif(in_array(strtolower($text), $analyst_name)){
                return response()->json(['reply' => "I'm Assistly AI."]);
            }
            elseif(in_array(strtolower($text), $thanks_keywords)){
                return response()->json(['reply' => "I appreciate your kind words! How can I assist you further?"]);
            }elseif(in_array(strtolower($text), $what_do_for)){
                return response()->json(['reply' => "I can provide you with detailed information about Support Tickets & OTL forms."]);
            }
            elseif(in_array(strtolower($text), $sorry_text)){
                return response()->json(['reply' => "I appreciate your kind words! How can I assist you further?"]);
            }
            elseif(in_array(strtolower($text), $check)){
                return response()->json(['reply' => "To better assist you, please narrow down your inquiry by providing the form ID, user ID, ticket ID, or UPC ID along with your question. This will help ensure I offer the most relevant assistance."]);
            }
            elseif(in_array(strtolower($text), $help)){
                return response()->json(['reply' => "I can provide you with detailed information about Support Tickets & OTL forms."]);
            }
            else {

                $text_quest = json_encode($request->input('message'));

                if (preg_match('/help/i', $text)) {
                    return response()->json(['reply' => "I’m here to help you with support tickets and OTL forms. Whether you need details about users, tickets/inbox/mails, or anything else, I’ve got your back to make sure things run smoothly—so you can focus on what matters most."]);

                }

               // $text_quest = json_encode(str_replace("'", "", $request->input('message')));
               // return response()->json(['reply' => $text_quest]);
              // $text_quest = json_encode(str_replace("?", "", $request->input('message')));

               
            //    if (session()->has('text_quest')) {
            //     if(session('text_quest') == ''){
            //         $old_quest = null; 
            //     }else{
            //         $old_quest = session('text_quest');
            //     }
              
            //     } else {
                
            //         $old_quest = null; 
            //     }
               
               
        
        //         $scriptPath = base_path('public/superaiq.py');
        //         $command = escapeshellcmd("python3 $scriptPath '$old_quest' '$text_quest'");
        //         $output_step1 = shell_exec($command . " 2>&1");
                
        //         $text = str_replace("\n", " ", $output_step1);
            
        //         session(['text_quest' => $text]);


        //  return response()->json(['reply' => $text]);

            $text = $text_quest;
             
            $text = json_encode($request->input('message'));
            $text = str_replace(",", " ", $text);
            $text = str_replace(".", " ", $text);

    $scriptPath = base_path('public/superai.py');
    $command = escapeshellcmd("python3 $scriptPath '$text'");
    $output_step1 = shell_exec($command . " 2>&1");
    
    $text = str_replace("\n", " ", $output_step1);

    $output = trim(str_replace(['```sql ', '```'], '', $text));

   //return response()->json(['reply' => $output]);
   if (preg_match('/Hello! How can I assist you today?/i', $output)) {
    return response()->json(['reply' => "Hello! How can I assist you today? "]);

}
if (preg_match("/I'm Assistly AI./i", $output)) {
    return response()->json(['reply' => "I'm Assistly AI."]);

} 
if (preg_match("/help/i", $output)) {
    return response()->json(['reply' => "I’m here to help you with support tickets and OTL forms. Whether you need details about users, tickets/inbox/mails, or anything else, I’ve got your back to make sure things run smoothly—so you can focus on what matters most."]);

}

                if (preg_match('/INVALID REQUEST/i', $output)) {
                    return response()->json(['reply' => "To better assist you, please narrow down your inquiry by providing the form ID, user ID, ticket ID, or UPC ID along with your question. This will help ensure I offer the most relevant assistance."]);

                }

                // if (preg_match('/help/i', $output)) {
                //     return response()->json(['reply' => "help"]);

                // }

                // if (preg_match("/I'm sorry, as AI Assistly, I can only assist you providing data related to Support Tickets & OTL forms. How can I help you today?/i", $output)) {
                //     return response()->json(['reply' => "I'm sorry, as AI Assistly, I can only assist you providing data related to Support Tickets & OTL forms. How can I help you today?"]);

                // }
                // if (preg_match("/I'm Assistly AI./i", $output)) {
                //     return response()->json(['reply' => "I'm Assistly AI."]);

                // }
                // if (preg_match("/NO tickets have been escalated./i", $output)) {
                //     return response()->json(['reply' => "NO tickets have been escalated."]);

                // }
                // if (preg_match("/No issues have been reported./i", $output)) {
                //     return response()->json(['reply' => "No issues have been reported."]);

                // }
                // if (preg_match("/Hello! How can I assist you today?./i", $output)) {
                //     return response()->json(['reply' => "Hello! How can I assist you today?"]);

                // }

                // if (preg_match("/I’m here to help you with support tickets and OTL forms. Whether you need details about users, tickets, or anything else, I’ve got your back to make sure things run smoothly—so you can focus on what matters most./i", $output)) {
                //     return response()->json(['reply' => "I’m here to help you with support tickets and OTL forms. Whether you need details about users, tickets, or anything else, I’ve got your back to make sure things run smoothly—so you can focus on what matters most."]);


                // }
                // if (preg_match("/You're welcome! Feel free to ask anything else./i", $output)) {
                //     return response()->json(['reply' => "You're welcome! Feel free to ask anything else."]);

                // }
                
              
                $res = DB::select($output);
           
                $text_quest_1 = json_encode($res);
                //return response()->json(['reply' => $output]);
                if ($text_quest_1 == [] || empty($text_quest_1)) {
                    return response()->json(['reply' => "No results were found for your search criteria."]);
                
                }else{


                    $scriptPath_1 = base_path('public/humanitic.py');
                    $command_1 = escapeshellcmd("python3 $scriptPath_1 '$text_quest_1' '$text'");
                    $output_step1_1 = shell_exec($command_1 . " 2>&1");
                    
                    //return response()->json(['reply' => $output_step1_1]);
                    //dd($output_step1_1);
                    $output_1 = trim(str_replace(['```sql ', '```'], '', $output_step1_1));
    
    
                    if (preg_match('/cloud.google/i', $output_1)) {
                        return response()->json(['reply' => "To better assist you, please narrow down your inquiry by providing the form ID, user ID, ticket ID, or UPC ID along with your question. This will help ensure I offer the most relevant assistance."]);
    
                    }
    
                    if (!empty($output_1)) {
                        $html = nl2br(htmlspecialchars($output_step1_1)); 
                        $html = preg_replace('/• (.+?)\s*(?=\•|$)/', '<li>$1</li>', $html);
                        $html = '<ul>' . $html . '</ul>';
                        $html = preg_replace('/\*\*(.+?)\*\*/', '<strong>$1</strong>', $html);
                        $html = str_replace("•", "", $html);
                        $html = str_replace('/<br /><br />/', '', $html); 
    
                     
                        return response()->json(['reply' => $html,'dbresult' => $text_quest_1,'query' => $output]);
                     }
                    // else {
                    //     return response()->json(['reply' => "No results were found for your search criteria."]);
                    // }
                }
                
            }
        } catch (\Exception $e) {


           // return response()->json(['reply' =>"To better assist you, please narrow down your inquiry by providing the form ID, user ID, ticket ID, or UPC ID along with your question. This will help ensure I offer the most relevant assistance."]);
            $scriptPath_1 = base_path('public/humanitic.py');
                $command_1 = escapeshellcmd("python3 $scriptPath_1 '' '$text'");
                $output_step1_1 = shell_exec($command_1 . " 2>&1");
                $output_1 = trim(str_replace(['```sql ', '```'], '', $output_step1_1));

                if (!empty($output_1)) {
                    $html = nl2br(htmlspecialchars($output_step1_1)); 
                    $html = preg_replace('/• (.+?)\s*(?=\•|$)/', '<li>$1</li>', $html);
                    $html = '<ul>' . $html . '</ul>';
                    $html = preg_replace('/\*\*(.+?)\*\*/', '<strong>$1</strong>', $html);
                    $html = str_replace("•", "", $html);
                    $html = str_replace('/<br /><br />/', '', $html); 

                 
                    return response()->json(['reply' => $html]);
                } 
                
                // else {
                //     return response()->json(['reply' => "No results found."]);
                // }
           // return response()->json(['reply' => "I'm sorry, as AI Assistly, I can only assist you providing data related to Support Tickets & OTL forms. How can I help you today?"]);

           // return response()->json(['reply' => "Error: " . $e->getMessage()]);
        }
    }

    public function addBookmark(Request $request) {
        $text = $request->input('message');
        $userid = $request->input('userid');

        $res = DB::table('comm_chatbot')->insert([
            'userid' => $userid,
            'userMessage' => $text
        ]);
        if($res) {
            return response()->json(['result' => 'Successfully']);
        }else {
            return response()->json(['result' => 'Error']);
        }
    }
    public function trashBooklist(Request $request) {
        $res = DB::table('comm_chatbot')->where('id', $_POST['id'])->update([
            'blocklist' => 1
        ]);
        if($res) {
            return response()->json(['result' => 'Successfully']);
        }else {
            return response()->json(['result' => 'Error']);
        }
    }

    public function EditBooklist(Request $request) {
        $res = DB::table('comm_chatbot')->where('id', $request->input('id'))->update([
            'userMessage' => $request->input('content')
        ]);
        if($res) {
            return response()->json(['result' => 'Successfully']);
        }
    }
    

    public function getAllData(Request $request)
    {
        // Example table names; adjust as necessary
        $tables = ['users', 'posts'];
        $data = [];

        foreach ($tables as $table) {
            $data[$table] = DB::table($table)->get()->toArray();
        }

        return response()->json($data);
    }
}