import sys
from google.oauth2 import service_account
import vertexai
from vertexai.generative_models import GenerativeModel, Part, SafetySetting, FinishReason

def generate_sql(question):
    creds = service_account.Credentials.from_service_account_file("/var/www/html/smart-hub/public/futurefous-b541452ac5cf.json")
    vertexai.init(project="futurefous", location="europe-west1", credentials=creds)
    model = vertexai.generative_models.GenerativeModel("gemini-1.5-flash-002")
    generation_config = {
        "max_output_tokens": 8192,
        "temperature": 0,
        "top_p": 0.95,
    }

    safety_settings = [
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HATE_SPEECH,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_DANGEROUS_CONTENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_SEXUALLY_EXPLICIT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HARASSMENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    ]
    return model.generate_content(question,generation_config=generation_config,safety_settings=safety_settings).text.strip()



if __name__ == "__main__":
    if len(sys.argv) > 2:

        text = sys.argv[1]
        subject = text.replace('\\"', '')
        text1 = sys.argv[2]
        body = text1.replace('\\"', '')

        prompt =f"""


identify subject and body which is related to what type of email

Email types are

availabe tag_name are 

1 Account Closures 
2 	Content Mapping 
3 	YouTube 	
4 	Revenue Share 	
6 	403 Error 
7 	Allow List 
8 	Artwork 		
9 	Audio Issue 		
10 	Bank Transfer 		
12 	Copyright Infringement 		
13 	Facebook/Instagram Verification 		
14 	Facebook/Instagram/CID 		
15 	Failed Upload/ Failed Takedown 		
16 	Mod Delay 		
17 	New Feature Feedback 		
18 	Password 		
19 	Payments & Pay Updates 		
20 	Refund 		
21 	RN Advance 		
22 	Stats & Reports 		
23 	Takedown or Closure 		
24 	Disapprove all pending releases 		
25 	Delete all unfinished releases 		
26 	Adds a note to all RFS releases 	
27 	Adds a flag to the account 
28 	Takedown for all stores 	
30 	Manual Account Activation 	
31 	RFS all active releases 	
32 	PayPal

		
find what type of email and return only the it's id

if subject and body doesnot match with any email types , then return 'Match not found'

{subject} {body} 


       """
     
        print(generate_sql(prompt))
    else:
        print("Provide input as command-line argument")




			# "403 Error", "Account Closures", "Adds a flag to the account", "RFS all active releases",
			# 		"Allow List", "Artwork", "Audio Issue", "Bank Transfer", "Content Mapping", "Copyright Infringement",
			# 		"Delete all unfinished releases", "Disapprove all pending releases", "Facebook/Instagram Verification",
			# 		"Facebook/Instagram/CID", "Failed Upload/ Failed Takedown", "Manual Account Activation", "Mod Delay",
			# 		"New Feature Feedback", "Password", "Payments & Pay Updates", "PayPal", "Refund", "Revenue Share", "Adds a note to all RFS releases","RN Advance","Stats & Reports","Takedown for all stores","Unlinks all YT channels","YouTube"




