import sys
from google.oauth2 import service_account
import vertexai
from vertexai.generative_models import GenerativeModel, Part, SafetySetting, FinishReason

def generate_sql(question):
    creds = service_account.Credentials.from_service_account_file("/var/www/html/smart-hub/public/futurefous-b541452ac5cf.json")
    vertexai.init(project="futurefous", location="europe-west1", credentials=creds)
    model = vertexai.generative_models.GenerativeModel("gemini-1.5-flash-002")
    generation_config = {
        "max_output_tokens": 8192,
        "temperature": 0,
        "top_p": 0.95,
    }

    safety_settings = [
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HATE_SPEECH,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_DANGEROUS_CONTENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_SEXUALLY_EXPLICIT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HARASSMENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    ]
    return model.generate_content(question,generation_config=generation_config,safety_settings=safety_settings).text.strip()



if __name__ == "__main__":
    if len(sys.argv) > 2:

        text1 = sys.argv[1]
        result1 = text1.replace('\\"', '')

        text = sys.argv[2]
        result2 = text.replace('\\"', '')


        base_prompt = f"""

  comm_staffs are Superadmin, Admin1, Admin2, and the staff types are Admin and Staff.

Tickets have a "priority" column with values: Easy, Moderate, High, and Very High.

Available action names and their IDs:
1. Account Closure
2. Content Mapping
3. Youtube OAC
4. Revenue Share
5. Disapprove all pending releases
6. Delete all unfinished releases
7. Add a note to all RFS releases
8. Add a flag to the account
9. RFS all active releases
10. Takedown for all stores
11. Unlinks all YT channels
12. Manual Account Activation
14. Close Thread

Ticket Context:

{result1}: Details of a specific ticket.  
{result2}: Details of other tickets.

For {result1}, suggest the most suitable staff member (Superadmin, Admin1, Admin2) to handle the ticket based on the following criteria:

1. **Subject & Body Analysis**: Review the subject and body of the ticket. Provide a recommendation based on the content and tone of the request.
   
2. **Tone**:  
   - If the tone is **urgent**, suggest an Admin (Superadmin, Admin1, or Admin2) based on priority and urgency.  
   - If the tone is more **neutral** or **friendly**, a **Staff** member may be more appropriate.

3. **Priority Matching**:  
   - Use the priority levels (Easy, Moderate, High, Very High) to determine the staff member who is best suited to handle the ticket, considering their workload and urgency.

**IMPORTANT**:
- **Uncompleted Tickets**: Provide **all** relevant suggestions, including the most appropriate staff member and their suitability.
- **Completed Tickets**: If the ticket has been completed, **only** provide a suggestion regarding the tone of the request. Do not suggest a staff member.

**Additional Notes**:
- If the staff member suggested already has **more than 2 uncompleted tickets assigned**, include a note to inform the user of their current workload.
- Always refer to {result2} for trends or staff expertise related to the ticket.
- Suggest only one Staff Member 

### Example Suggestions:
- Tone: [description of tone]  if tone is not friendly just mention what type of it. just in one word

AI Suggestion:
-Experience: [Staff's experience with similar tasks or tickets]


**Suggest only one Staff Member** 
assigned_to Admin1 id 72568	and Admin2 id 72569	
don't mention in it instead of use #
describe tone in one word like 
Urgent
Frustrated
Neutral
Friendly
Polite
Formal
Casual
Professional
Confident
Apologetic
Disappointed
Assertive
Grateful
Sympathetic
Respectful
Aggressive
Helpful
Empathetic
Optimistic

Provide a response in **seconds**. Ensure that you avoid making any queries or modifications to the database.

{result1}  
{result2}

  """
       # print(generate_sql(prompt))  

        # Combine base prompt with the condition
        # final_prompt = f"{base_prompt}\n{condition}\nPlease give select query for below questions - only query without explanation\n{question}"
        
        print(generate_sql(base_prompt))


          







