import sys
from google.oauth2 import service_account
import vertexai
from vertexai.generative_models import GenerativeModel, Part, SafetySetting, FinishReason

def generate_sql(question):
    creds = service_account.Credentials.from_service_account_file("/var/www/html/smart-hub/public/futurefous-b541452ac5cf.json")
    vertexai.init(project="futurefous", location="europe-west1", credentials=creds)
    model = vertexai.generative_models.GenerativeModel("gemini-1.5-flash-002")
    generation_config = {
        "max_output_tokens": 8192,
        "temperature": 0,
        "top_p": 0.95,
    }

    safety_settings = [
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HATE_SPEECH,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_DANGEROUS_CONTENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_SEXUALLY_EXPLICIT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HARASSMENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    ]
    return model.generate_content(question,generation_config=generation_config,safety_settings=safety_settings).text.strip()



if __name__ == "__main__":
    if len(sys.argv) > 2:

        text1 = sys.argv[1]
        result1 = text1.replace('\\"', '')

        text = sys.argv[2]
        result2 = text.replace('\\"', '')


        base_prompt = f"""
Ticket Context:

{result1}: Details of a specific ticket.  
{result2}: Details of other tickets.

For {result1}, analyze the tone of the ticket and suggest an appropriate staff member:

1. **Subject & Body Analysis**: Review the content and tone of the ticket (subject and body). Provide a recommendation based on the nature of the request.

2. **Tone**:  
   - If the tone appears **urgent** or **high-priority**, suggest an **Admin** (Admin1 or Admin2) based on their current workload and the ticket's urgency.  
   - If the tone seems **neutral**, **friendly**, or **less pressing**, suggest a **Staff** member instead.

### Additional Notes:
- If the assigned staff member for this ticket has **more than 2 uncompleted tickets**, include a note to inform the user about the staff member's current workload.
- Always check {result2} for trends or staff expertise related to the ticket.
- **Suggest only one staff member** for handling the ticket.

**Output Example**: 
--> Tone: [description of tone, e.g., Neutral, Urgent, Friendly, Frustrated]
--> Suggestion: If you need any guidance or assistance, please feel free to contact [Other Staff Name], who possesses extensive experience in managing similar ticket requests.
- Need help reach out: [Staff Name]

**no need to change my text in Suggestion only add staff name**

**Important**:
-** No need to show admin id**Reference for id Admin1 - 72568 Admin2 - 72569 (No need to show any admin id just for reference only)
-**no need to change my text in Suggestion only add staff name**[If you need any guidance or assistance, please feel free to contact [Other Staff Name], who possesses extensive experience in managing similar ticket requests.]

**Example of Staff Assignment**:
- If **no staff is assigned**: Suggest a staff member such as Admin1 or Admin2.
- If a staff member is **already assigned** (e.g., Admin1,or  Admin2), inform them that they can seek assistance from another staff member with relevant expertise if needed. The format should mention **#** for staff ID (e.g., Admin1, #72568) instead of "ID".

**Don't use the word "id"; instead, use "#" for the staff number.**

Only suggest **Admins** (Admin1 or Admin2) — do not suggest Superadmin.

describe tone in one word like 
Urgent
Frustrated
Neutral
Friendly
Polite
Formal
Casual
Professional
Confident
Apologetic
Disappointed
Assertive
Grateful
Sympathetic
Respectful
Aggressive
Helpful
Empathetic
Optimistic

output format:
--> Tone: <tone>
--> Suggestion: <suggestion>
- Need help reach out: <Staff Name>

Provide a response in **seconds**. Do **not** modify or query the database.

{result1}  
{result2}


  """
       # print(generate_sql(prompt))  

        # Combine base prompt with the condition
        # final_prompt = f"{base_prompt}\n{condition}\nPlease give select query for below questions - only query without explanation\n{question}"
        
        print(generate_sql(base_prompt))


          







