import sys
from google.oauth2 import service_account
import vertexai
from vertexai.generative_models import GenerativeModel, Part, SafetySetting, FinishReason

def generate_sql(question):
    creds = service_account.Credentials.from_service_account_file("/var/www/html/smart-hub/public/futurefous-b541452ac5cf.json")
    vertexai.init(project="futurefous", location="europe-west1", credentials=creds)
    model = vertexai.generative_models.GenerativeModel("gemini-1.5-flash-002")
    generation_config = {
        "max_output_tokens": 8192,
        "temperature": 0,
        "top_p": 0.95,
    }

    safety_settings = [
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HATE_SPEECH,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_DANGEROUS_CONTENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_SEXUALLY_EXPLICIT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HARASSMENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    ]
    return model.generate_content(question,generation_config=generation_config,safety_settings=safety_settings).text.strip()



if __name__ == "__main__":
    if len(sys.argv) > 2:

        text1 = sys.argv[1]
        result1 = text1.replace('\\"', '')

        text = sys.argv[2]
        result2 = text.replace('\\"', '')


        base_prompt = f"""

  

comm_staffs name are Superadmin,Admin1,Admin2 and type has Admin and Staff.
 

Tickets have priority column having values Easy,Moderate,High and Very High

Availabe action names and its id are
1 	Account Closure 
2 	Content Mapping 	
3 	Youtube OAC 
4 	Revenue Share
5 	Disapprove all pending releases 
6 	Delete all unfinished releases 
7 	Adds a note to all RFS releases 
8 	Adds a flag to the account 
9 	RFS all active releases 
10 	Takedown for all stores 
11 	Unlinks all YT channels 
12 	Manual Account Activation 
14 	Close Thread


Ticket Context:

{result1}: Details for a particular ticket.
{result2}: Details for other tickets.
For {result1}, suggest which staff member (Superadmin, Admin1, Admin2) would be the best fit to handle this ticket. Pay attention to the following:

Subject & Body Analysis: Review the subject and body of the ticket and provide a suggestion based on the content and tone of the request.

Tone: If the tone is urgent, recommend an Admin with a higher priority. If the tone is more neutral or friendly, a Staff member might be better suited.

Priority Matching: Use the priority levels (Easy, Moderate, High, Very High) to determine which staff might be most appropriate based on workload and urgency.

IMPORTANT:
    - Only give all type of suggestions if ticket is not yet completed. If its completed except who is fit to handle this ticket ,give all other suggestions.
    - for completed tickets, only suggest the tone.
Example Suggestions:

"This ticket has a high priority and is related to YouTube. Given the urgency, Admin2, who specializes in YouTube-related actions, would be ideal for the task."
"The subject indicates a complex account issue with revenue share concerns. Admin1, who has experience with revenue-related tickets, should handle it."
Additional Reference:

Check {result2} for related ticket trends or staff expertise.
Suggestion for {result1} only (based on the analysis above). Please avoid making any queries or changes to the database.

give response in within seconds.

{result1}{result2}
  """
       # print(generate_sql(prompt))  

        # Combine base prompt with the condition
        # final_prompt = f"{base_prompt}\n{condition}\nPlease give select query for below questions - only query without explanation\n{question}"
        
        print(generate_sql(base_prompt))


          







