import sys
from google.oauth2 import service_account
import vertexai
from vertexai.generative_models import GenerativeModel, Part, SafetySetting, FinishReason

def generate_lang(question):
    creds = service_account.Credentials.from_service_account_file("/var/www/html/smart-hub/public/futurefous-b541452ac5cf.json")
    vertexai.init(project="futurefous", location="europe-west1", credentials=creds)
    model = vertexai.generative_models.GenerativeModel("gemini-1.5-flash-002")
    generation_config = {
        "max_output_tokens": 8192,
        "temperature": 0,
        "top_p": 0.95,
    }

    safety_settings = [
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HATE_SPEECH,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_DANGEROUS_CONTENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_SEXUALLY_EXPLICIT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HARASSMENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    ]
    return model.generate_content(question,generation_config=generation_config,safety_settings=safety_settings).text.strip()



if __name__ == "__main__":
    if len(sys.argv) > 1:

        text1 = sys.argv[1]
        #result1 = text1.replace('\\"', '')

        with open(text1, 'r', encoding='utf-8') as file:
            text = file.read()

        # Print the contents of the file (for debugging)
       # print(f"File content: {text}")

# Now you can process 'text' (the content of the file) as needed, e.g., language detection

       #     print(f"Received text: {text1}")  # Print the received text to debug

# Continue with your existing logic (e.g., language detection, etc.)
        # Enhance the following text by converting it into a professional and polished format. Maintain clarity, formality, and a respectful tone. Ensure grammatical accuracy, proper sentence structure, and a refined vocabulary while keeping the original intent intact."

        base_prompt = f"""
        Enhance the following text by converting it into a professional and polished format. Maintain clarity, formality, and a respectful tone. Ensure grammatical accuracy, proper sentence structure, and a refined vocabulary while keeping the original intent intact. If the text contains words with a negative connotation (e.g., 'bad,' 'worst,' 'angry'), reframe them into a neutral or positive tone where applicable.

Input:
{text}

Guidelines for Output:

Use professional and formal language.
Ensure clarity and conciseness.
Maintain a respectful and business-appropriate tone.
Correct any grammatical errors or awkward phrasing.
correct the spelling mistakes
It should be ethical and not be biased
no need to remove html tags and style in that only translate the text 
if they say like you are responsible.. or political issue -- these are biased content 

only enhance it if needed else no need to change it.

Analyze the following text and identify any potential biases. Check for gender, racial, age, political, socioeconomic, religious, nationality, disability, language, occupational, name, regional/accent, appearance, confirmation, anchoring, negativity, and authority biases.

Provide a structured analysis, including:

Output format:
converted language: <translated text> 
Bias Detection:List the type(s) of bias found. if no bias detect, then return No bias detected

In bias detection
Positive:<Merits in original {text}>
Negative: <What kind of bias and demerits in {text}>


Bias Detection value in single word no need to be sentence
explain positvive and negative in one word for each positive and neagative

no need any further explanation , just return the converted text

{text}
"""

#         base_prompt = f"""
# Analyze the following text and identify any potential biases. Check for gender, racial, age, political, socioeconomic, religious, nationality, disability, language, occupational, name, regional/accent, appearance, confirmation, anchoring, negativity, and authority biases.

# Provide a structured analysis, including:
# Positive: <Merits in the {text}>
# Detected Bias Type(s): List the type(s) of bias found.
# Explanation: Describe why the text may be biased.
# Suggested Correction: Provide a neutral, unbiased revision of the text.



# """




#         base_prompt = f"""
# Detect the language of this text and convert into chinese

# in text : after Dear consider the word as name (Dear <name>,)so consider this as name no need to change name return as it is 
# Positive: <in one word explain it, grammer is not correct like that>
# Negative: <in one word explain it, Speling mistake.. like that>

# IMPORTANT:
# **if text contains  below words
# Many Warm Regards,
# The RouteNote Team
# no need to these change words , return as it is **

# output should be
# converted language:<converted text>



# no need any further explanation , just return the converted text
# {text}
#   """
        print(generate_lang(base_prompt))  

        # Combine base prompt with the condition
        # final_prompt = f"{base_prompt}\n{condition}\nPlease give select query for below questions - only query without explanation\n{question}"
        
       # print(text1)

        
          







