import sys
from google.oauth2 import service_account
import vertexai
from vertexai.generative_models import GenerativeModel, Part, SafetySetting, FinishReason

def generate_sql(question):
    creds = service_account.Credentials.from_service_account_file("/var/www/html/smart-hub/public/futurefous-b541452ac5cf.json")
    vertexai.init(project="futurefous", location="europe-west1", credentials=creds)
    model = vertexai.generative_models.GenerativeModel("gemini-1.5-flash-002")
    generation_config = {
        "max_output_tokens": 8192,
        "temperature": 0,
        "top_p": 0.95,
    }

    safety_settings = [
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HATE_SPEECH,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_DANGEROUS_CONTENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_SEXUALLY_EXPLICIT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HARASSMENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    ]
    return model.generate_content(question,generation_config=generation_config,safety_settings=safety_settings).text.strip()



if __name__ == "__main__":
    if len(sys.argv) > 1:

        text = sys.argv[1]
        question = text.replace('\\"', '')

        greeting_keywords = [
        "hello", "hi", "hai", "hey", "hey", "helo", "good morning", "good evening",
        "greetings", "good", "hii", "hiii", "hay", "hiya", "morning", "evening",
        "gud morning", "gud evening", "gretings", "heyyy", "yo", "wassup",
        "whats up", "hey there", "hello there", "gm", "ge", 
         "movie", "film", "entertainment", "concert",
        "cricket", "football", "sports", "news", "thanks", "thank you",
        "appreciate", "cheers", "great", "brilliant", "cool", "i like it",
        "sorry", "sry", "exit",
        "stop", "finish", "abort", "clear", "save", "store", "help",
        "why are you slow", "slow",
        "about yourself", "awesome", "amazing", "incredible", "fantastic", "wonderful",
        "magnificent", "astonishing", "fabulous", "extraordinary", "spectacular",
        "phenomenal", "breathtaking", "remarkable", "marvelous", "stunning", "superb",
        "excellent", "great", "fine", "decent", "nice", "pleasant",
        "satisfaction", "worthy","pleasure"
        ]

        greeting_keywords1 = [
        "what is your name", "whats your name", "what your name", "whats ur name", "what ur name","what's your name" ,"who are you", "who r u"

        ]
        greeting_keywords2 = [
         "what can you do for me", "what you do for me", "what can you do","how can you do for me"
        ]
        if any(word in greeting_keywords2 for word in question.lower().split()):
            print("help")
        elif any(word in greeting_keywords1 for word in question.lower().split()):
            print("I'm Assistly AI.")
        elif any(word in greeting_keywords for word in question.lower().split()):
            print("Hello! How can I assist you today?")

        else:
            prompt = f"""

             ONLY generate SQL queries for valid and coherent questions. If the input is nonsensical or gibberish, output: `INVALID REQUEST`.
    - For greetings or general words(e.g., hello, hi, good morning, thank you): `Hello! How can I assist you today?`
    - For thanks-related questions (e.g., thanks, thank you, appreciate,sorry): `I appreciate your kind words! How can I assist you further?`
    - For requests related to help (e.g., what can you do for me, how can you help me): `help`
    - For requests related to your name (e.g., what is your name, tell me your name): `I'm Assistly AI.`

use "name" as the prompt for any username-related requests.


DO NOT generate queries for the following:
- `UPDATE`, `DELETE`, `ALTER`, `ADD`, `CREATE`, or any database credentials (e.g., passwords, activation keys). Output: `INVALID REQUEST`.
- Requests column names, or database structure details. Output: `INVALID REQUEST`.
DO NOT generate nonsensical or gibberish,output: `INVALID REQUEST`.

**General Guidelines:**
- Only generate `SELECT` queries.
- Adhere to MySQL 5.6.51 syntax. Avoid modern constructs (e.g., `HAVING`).
- Only generate queries, no extra text or explanation.
- Identify input numbers: 
  - **13-digit** numbers = UPC.
  - Any other number = user ID (UID) or Ticket id .
- Include provided values in the query.

comm_tbl_smthub_ticket.status column have values stage by stage
    .Received 
    .Waiting For User Action
    .Admin Action Needed
    .Completed

--All group by elements must in select clause
--if group by used, all select elements must in group by
comm_tbl_smthub_ticket.priority column having values Easy,Moderate,High and Very High

comm_staffs name are Superadmin,Admin1,Admin2 and type has Admin and Staff.
 
if they ask otl forms/otl/forms which refers to all 4 forms 
Account Closures 
Content Mapping 
YouTube OAC 	
Revenue Share 	

Tickets have priority column having values Easy,Moderate,High and Very High

Availabe action names are
1 	Account Closure 
2 	Content Mapping 	
3 	Youtube OAC 
4 	Revenue Share
5 	Disapprove all pending releases 
6 	Delete all unfinished releases 
7 	Adds a note to all RFS releases 
8 	Adds a flag to the account 
9 	RFS all active releases 
10 	Takedown for all stores 
11 	Unlinks all YT channels 
12 	Manual Account Activation 
14 	Close Thread

Availabe tag_name are 
1 Account Closures 
2 	Content Mapping 
3 	YouTube 	
4 	Revenue Share 	
6 	403 Error 
7 	Allow List 
8 	Artwork 		
9 	Audio Issue 		
10 	Bank Transfer 		
12 	Copyright Infringement 		
13 	Facebook/Instagram Verification 		
14 	Facebook/Instagram/CID 		
15 	Failed Upload/ Failed Takedown 		
16 	Mod Delay 		
17 	New Feature Feedback 		
18 	Password 		
19 	Payments & Pay Updates 		
20 	Refund 		
21 	RN Advance 		
22 	Stats & Reports 				
32 	PayPal




if they ask tell me how many account closure request received in the last 7 days  refer the comm_tbl_smthub_ticket table.
if they ask about 'support request/request' refer the comm_tbl_smthub_ticket table.
if they ask 'all mails' list all tickets 
if 'user based tickets' where comm_tbl_smthub_ticket.upc_id is null or upc_id '' 
else if 'upc based tickets' where comm_tbl_smthub_ticket.upc_id not null 
else if 'uncategorised tickets' where comm_tbl_smthub_ticket.tag_id not null 
else if 'inbox tickets' where comm_tbl_smthub_ticket.tag_id in 1,2,3,4 

match the columns what i mention in each select query don't get anything .

-- payment task created/asana payament task/payment related questions get details only from comm_account_closure.payment_created_at no need use other tables.
any questions related to payments/asana payment task  get details only from comm_account_closure.payment_created_at
query:
  SELECT payment_created_at FROM comm_account_closure;

No need to join action or tag unless any input based on that.
Join action or tag based on the input no need to join both at the same time.

comm_staffs have column name not username.
users have column name not username.


For direct questions related to individual tables:
You can query the relevant table directly using the following individual queries:

comm_oac_form.country use like for this. 
example: comm_oac_form.country like '%<value>%'

NOTES:**Both otl forms and forms are same**
---------------------
otl refers comm_account_closure,comm_content_mapping,comm_revenue_form,comm_oac_form
comm_account_closure have column form_id not id.
---------------------
Always consider comm_tbl_smthub_ticket.id as ticket# 
smart_schedule column has datetime.when ticket was scheduled for that we use it.
check OTL forms /forms status using comm_tbl_smthub_ticket.status by passing it's id.

if they ask about category refers the action_name. if action_name empty then check tag_name.

SELECT id, keys1, uid, uname, upc_id, subject, from_name, from_addr, to_name, to_addr, body, action_id, notes, request_information, tickets_received, assigned_to, due_date, instant_action, smart_schedule, priority, tag_id, completed_at, status, internal_thread, commentry_assign, commentry_user, conf_email, last_cron_update FROM comm_tbl_smthub_ticket;

SELECT id, tag_name FROM comm_tag;

SELECT id, action_name FROM comm_action;

SELECT id, userid, username, email, keys1, action_needed, submitted_at, sent_store FROM comm_content_mapping;

SELECT id, userid, username, email, keys1, artist_name, country, artist_channel_url, artist_channel_id, video_url, topic_channel_url, dashboard, topic_video_url, upc, upc_verified, slack_verified, submitted_at FROM comm_oac_form;

SELECT id, userid, username, email, keys1, submitted_at, asana_confirm, slack_confirm FROM comm_revenue_form;


SELECT form_id, email, username, userID, keys1, would_you_like_to_wait, rating, reason, elaborate_reason, other_distrubutor, comments, submitted_at, verify_rfs, verify_disapprove, verify_artist, verify_paypal, verify_soundlink, confirmation_email, payment_created_at FROM comm_account_closure;

SELECT form_id, email, username, userID, keys1, would_you_like_to_wait, rating, reason, elaborate_reason, other_distrubutor, comments, submitted_at, verify_rfs, verify_disapprove, verify_artist, verify_paypal, verify_soundlink, confirmation_email, payment_created_at FROM comm_account_closure;

SELECT id, choose_store, tbl_content_mapping_id, upc, artist_name FROM comm_store_details;

SELECT id, sid, RevenueShareTo  FROM comm_revenue_form_multiple; 

SELECT uid, name, mail, email_verified_at, password, remember_token, created_at, updated_at, image, read_count, mail_signature, auto_suggest, type FROM comm_staffs;

SELECT uid , name, mail, FROM_UNIXTIME(created) AS formatted_created_date, picture AS profile_picture, fraud_streaming AS fraud_flag, created AS created_at FROM users;

SELECT id AS flag_id,uid,flagtype, comment AS comment_text, FROM_UNIXTIME(timestamp) AS formatted_timestamp, admin_id AS admin_user_id, Apply_status AS apply_status FROM flag_comment;

SELECT id AS account_report_id, uid , total_amount , outstand_amount, FROM_UNIXTIME(report_created) AS formatted_report_created FROM user_account_report;

SELECT rsa.rsid,rsa.upc,rsa.uid,rsa.user_percent,rsa.referrer_uid,rsa.percent as referrer_uid_percentage,rsa.referrar_percent, FROM referral_split_album as rsa;


For questions requiring values from multiple tables:

Use the following query to retrieve data from multiple related tables:

SELECT t.id AS `ticket#`, t.keys1, t.uid, t.uname, t.upc_id, t.subject, t.from_name, t.from_addr, t.to_name, t.to_addr, t.body, t.action_id, t.notes, t.request_information, t.tickets_received, t.assigned_to, t.due_date, t.instant_action, t.smart_schedule, t.priority, t.tag_id, t.completed_at, t.status, t.internal_thread, t.commentry_assign, t.commentry_user, t.conf_email, t.last_cron_update, tg.tag_name, a.action_name, cm.userid, cm.username, cm.email, cm.keys1 AS cm_keys1, cm.action_needed, cm.submitted_at AS cm_submitted_at, cm.sent_store, oac.artist_name, oac.country, oac.artist_channel_url, oac.artist_channel_id, oac.video_url, oac.topic_channel_url, oac.dashboard, oac.topic_video_url, oac.upc, oac.upc_verified, oac.slack_verified, oac.submitted_at AS oac_submitted_at, rf.isrc, rf.percentage_userid, rf.percentage_username, rf.percentage, rf.submitted_at AS rf_submitted_at, rf.asana_confirm, rf.slack_confirm, ac.would_you_like_to_wait, ac.rating, ac.reason, ac.elaborate_reason, ac.other_distrubutor, ac.comments, ac.submitted_at AS ac_submitted_at, ac.verify_rfs, ac.verify_disapprove, ac.verify_artist, ac.verify_paypal, ac.verify_soundlink, ac.confirmation_email, ac.payment_created_at, sd.choose_store, sd.tbl_content_mapping_id, sd.artist_name AS sd_artist_name, rfmp.RevenueShareTo, st.name AS staff_name, st.mail AS staff_mail, st.email_verified_at, st.password, st.remember_token, st.created_at AS staff_created_at, st.updated_at AS staff_updated_at, st.image, st.read_count, st.mail_signature, st.auto_suggest, st.type AS staff_type FROM comm_tbl_smthub_ticket t JOIN comm_tag tg ON tg.id = t.tag_id JOIN comm_action a ON a.id = t.action_id JOIN comm_content_mapping cm ON cm.id = t.id JOIN comm_oac_form oac ON oac.id = t.id JOIN comm_revenue_form rf ON rf.id = t.id JOIN comm_account_closure ac ON ac.form_id = t.id JOIN comm_store_details sd ON sd.tbl_content_mapping_id = cm.id JOIN comm_revenue_form_multiple rfmp ON rfmp.sid = rf.id JOIN comm_staffs st ON st.uid = t.assigned_to JOIN users uu ON uu.uid = t.uid JOIN flag_comment fc ON fc.uid = uu.uid JOIN user_account_report uac ON uac.uid = uu.uid JOIN referral_split_album rsa ON rsa.uid = uu.uid;


---------------------------------------------------------------------
To answer questions about  who submitted the most forms this month:
---------------------------------------------------------------------
Combine submissions from all form tables: Use UNION ALL to gather submission data from all relevant tables.
Filter by date range: Apply a WHERE clause with BETWEEN to specify the current month\'s start and end dates.
Aggregate by user: Use GROUP BY on the userid or username to calculate the total submissions per user.
Sort and fetch the top user: Use ORDER BY to rank users by submission count in descending order and limit the results
-----------------------------------------------------------------------

---------------------------------------------------------------------
To answer questions about  flags/flagtype:**Relation with users table not staffs**
---------------------------------------------------------------------
use flag_comment table join with users. 

flagtype defines the color of flag
 
        if flagtype = 'Approved' THEN 'Green'
        if flagtype = 'Warning' THEN 'Yellow'
        if flagtype = 'Suspicious' THEN 'Orange'
        if flagtype = 'Priority' THEN 'Purple'
        if flagtype = 'Blacklisted' THEN 'Black'
        if flagtype = 'FSA' THEN 'Pink'
        if flagtype = 'FraudStrike' THEN 'Red'
        if flagtype = 'YouTube Network Abuse' THEN 'YouTube Network Abuse' 
        if flagtype = 'Whitelisting YouTube channels' THEN 'Whitelisting YouTube channels' 
        if flagtype = 'Bulk actions' THEN 'Bulk actions' 
        if flagtype = 'Payments' THEN 'Payments' 
        if flagtype = 'Xpress' THEN 'Xpress' 
        if flagtype = 'Publishing Information' THEN 'Publishing Information' 
        if flagtype = 'Korean Account' THEN 'Korean Account' 
        if flagtype = 'Star artist' THEN 'Star artist' 
-----------------------------------------------------------------------

---------------------------------------------------------------------
To answer questions about  amount/earnings of user:**Relation with users table  not staffs**
---------------------------------------------------------------------
use user_account_report table join with users. 
users table join: Joins the users table to get the user's name (uname) based on the uid.
Second join with users table: Joins again to get the referrer's name based on the referrer_uid.
-----------------------------------------------------------------------

---------------------------------------------------------------------
If question similar like split/share/distribution or split/share/distribution:
**Relation with users table not staffs**
if they give any number check if it's 13 digit number then use upc column else use uid column
---------------------------------------------------------------------
use referral_split_album table join with users table. 
-----------------------------------------------------------------------

---------------------------------------------------------------------
To compare which type of form has the most submissions, follow these steps:
---------------------------------------------------------------------

Select form tables: Identify the relevant tables to compare (e.g., comm_content_mapping, comm_oac_form, comm_revenue_form, comm_account_closure).
Count submissions in each table: Use COUNT(*)
 to calculate the total number of rows in each table.
IMPORTANT RULE:Combine the counts: Use UNION ALL or separate subqueries to combine results from all tables.
Sort the results: Order by the total count in descending order to determine which form has the highest count.
---------------------------------------------------------------------


---------------------------------------------------------------------
To get the associated email, assuming that the associated email is stored in the comm_grouplist table (cg.me_email)
---------------------------------------------------------------------
users u:From users table to retrieve user details (e.g., uid, name, and mail).
LEFT JOIN comm_grouplist cg.userid: This join retrieves the me_email from the comm_grouplist table, which represents the associated email for the user.
COALESCE(cg.me_email): If there is no associated email in the comm_grouplist table.
This query will provide you with the associated email for each user
---------------------------------------------------------------------


---------------------------------------------------------------------
To generate the query based on your question "How many OTL forms have been submitted by the 'sellerrnn' in the last 30 days?", you would want to focus on the tables that store OTL forms. These are typically the comm_account_closure, comm_content_mapping, comm_revenue_form, and comm_oac_form tables in your case.
---------------------------------------------------------------------
Here’s how you can generate the SQL query:

Instructions for Query:
Condition: The username should be 'sellerrnn'.
Date Range: The submission date (submitted_at) should be in the last 30 days.
Tables Involved: All four tables mentioned above store OTL forms, so you need to check all of them.
Query Structure:
We are using UNION ALL to combine results from the four different tables: comm_account_closure, comm_content_mapping, comm_revenue_form, and comm_oac_form.
The condition submitted_at >= DATE_SUB(CURDATE(), INTERVAL 30 DAY) ensures we are only counting forms submitted in the last 30 days.
Counting Forms:
The query counts the total number of form IDs submitted by the user 'sellerrnn' in the last 30 days across all four OTL-related tables.
---------------------------------------------------------------------



Give query for mysql version 5.6
use like in where clause for matching upc_id 
Optimize the response and give within 4 seconds
---------------------------------------------------------------------
If question similar like any forms related to upc <upc> then 
---------------------------------------------------------------------

Query for UPC Related to Revenue Form:
Fetch data from comm_revenue_form where the UPC is linked through the RevenueShareTo field in comm_revenue_form_multiple.
Use a JOIN between comm_revenue_form and comm_revenue_form_multiple on id and sid.
Treat RevenueShareTo as the UPC field and return it in the query.
Filter with LIKE '%<upc>%' to find related UPC entries.
Query for UPC Related to Content Form:
Fetch data from comm_content_mapping where the UPC is linked through comm_store_details.
Use a JOIN between comm_content_mapping and comm_store_details on tbl_content_mapping_id to id.
Filter by csd.upc = '<upc>' to find exact UPC matches.
Query for UPC Related to OAC Form:
Fetch data directly from comm_oac_form where the UPC field matches the provided value.
Use a LIKE '%<upc>%' clause to find relevant UPCs.
Column Consistency:
Ensure all SELECT statements return the same columns in the same order: form_name, id, userid, username, email, upc, and submitted_at.
Use RevenueShareTo AS upc in the Revenue Form query to match the column count.
Add NULL AS upc in any cases where a UPC is not applicable to maintain consistency.
Combine Queries:
Use UNION ALL to merge results from all three forms (Revenue, Content, and OAC forms).
Add a form_name field to indicate the form type in the final output for easy identification.
- give as single query
---------------------------------------------------------------------
**make sure that group by elements must in select clause and select clause elements must be in group by.**
**consider that seller as name**
Please give select query for below questions - only query without explanation

  {question}
  """


            print(generate_sql(prompt))
    else:
        print("Provide input as a command-line argument.")






