import sys
from google.oauth2 import service_account
import vertexai
from vertexai.generative_models import GenerativeModel, Part, SafetySetting, FinishReason

def generate_sql(question):
    creds = service_account.Credentials.from_service_account_file("/var/www/html/smart-hub/public/futurefous-b541452ac5cf.json")
    vertexai.init(project="futurefous", location="europe-west1", credentials=creds)
    model = vertexai.generative_models.GenerativeModel("gemini-1.5-flash-002")
    generation_config = {
        "max_output_tokens": 8192,
        "temperature": 0,
        "top_p": 0.95,
    }

    safety_settings = [
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HATE_SPEECH,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_DANGEROUS_CONTENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_SEXUALLY_EXPLICIT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    SafetySetting(
        category=SafetySetting.HarmCategory.HARM_CATEGORY_HARASSMENT,
        threshold=SafetySetting.HarmBlockThreshold.OFF
    ),
    ]
    return model.generate_content(question,generation_config=generation_config,safety_settings=safety_settings).text.strip()



if __name__ == "__main__":
    if len(sys.argv) > 1:

        text = sys.argv[1]
        question = text.replace('\\"', '')

        prompt =f"""
        ONLY generate SQL queries for valid and coherent questions. Do not generate queries for gibberish or nonsensical inputs. output: `INVALID REQUEST`.

DO NOT generate queries for `UPDATE`, `DELETE`, `ALTER`, `ADD`, `CREATE`, or database details such as passwords or activation.output: `INVALID REQUEST`. 

Only generate queries of the type `SELECT` and ensure they align with the structure provided. If the question asks for table lists, column names, or other database-related details, DO NOT generate a query.

if they ask only related questions ,generate query else output output: `INVALID REQUESTe`.
if they ask like tell me/who are you/what your goal like that,output output: `INVALID REQUESTe`.

Don't generate query for greetings or entertainment or thanks words, output: `test`.

**Guidelines for Generating Queries:**

=>MySQL 5.6.51, you'll need to simplify your query significantly and avoid modern constructs.
=>Don't generate query using HAVING clause.
=>generate only query,no need any other text.
=>Must pass the value , they mention
=>If they mention any number it is uid but if it;s 13 digit number then it is upc.

- If the input is a **13-digit number**, it's a UPC. Otherwise, it’s a user ID or username.

1. **If they ask revenue split for 5054316798316/Split/Share/Revenue Share/Distribution/revenue split:** Use the `referral_split_album` table . if its 13 digit number pass upc else if number pass uid else name join with users.uid = referral_split_album.uid
 Column names for `referral_split_album`:			
upc 			
uid,user_percent			
referrer_uid,referrar_percent				
status 					
isrc 				
rn_percent			 	

2. **ISRC List:** Use the `audio` table and pass the `UPC` value.
3. **Paypal Information:** Use the `logger656834` table and pass username or userid if they mention join with users get the logger656834.gvnme.
4. **Release Status/Artist Name/release type:** Use the `discography_api_report` table and pass upc value get release_type,release_status,artist_name and. Add `LIMIT 10`.
    -artist name get from discography_api_report table and pass the uid or username join with users table
     artist name for user seller -->select artist_name from discography_api_report and pass the uid or username join with users table
    -Release status ->Approved or DELETED or Disapproved or In Review or Pending Moderation or Removed from Sale or Unfinished or Your Action Needed
5. **UPC Free or Premium:** Use the `upc_distribution` table and check the `main_dis_option` field.columns `upcid`
6. **Total Tracks for Users:** Use the `release_table` and it's  COUNT(*) AS total_tracks . if its 13 digit number pass upc else if number pass uid else name join with users.uid = release_table.uid
7. **If they ask user details without mentioning name or uid,add limit 10.
8. **If they ask color of flag or flagtype of any user:** Use the `flag_comment` table join users with that flag_comment.uid = users.uid
 - pass uid or uname in where condition if they mention.
 - If flagtype is Priority then the user called as artist service account or AS account or artist service manage account.
is seller an artist services account?/is 38 an artist services account?

 SELECT 
    u.name,
    u.mail,
    COUNT(fc.uid) AS total_users,
    fc.flagtype,
    fc.Apply_status,
    CASE 
        WHEN fc.flagtype = 'Approved' THEN 'Green'
        WHEN fc.flagtype = 'Warning' THEN 'Yellow'
        WHEN fc.flagtype = 'Suspicious' THEN 'Orange'
        WHEN fc.flagtype = 'Priority' THEN 'Purple//Artist Service Account'
        WHEN fc.flagtype = 'Blacklisted' THEN 'Black'
        WHEN fc.flagtype = 'FSA' THEN 'Pink'
        WHEN fc.flagtype = 'FraudStrike' THEN 'Red'
        WHEN fc.flagtype = 'YouTube Network Abuse' THEN 'N/A' 
        WHEN fc.flagtype = 'Whitelisting YouTube channels' THEN 'N/A' 
        WHEN fc.flagtype = 'Bulk actions' THEN 'N/A' 
        WHEN fc.flagtype = 'Payments' THEN 'N/A' 
        WHEN fc.flagtype = 'Xpress' THEN 'N/A' 
        WHEN fc.flagtype = 'Publishing Information' THEN 'N/A' 
        WHEN fc.flagtype = 'Korean Account' THEN 'N/A' 
        WHEN fc.flagtype = 'Star artist' THEN 'N/A' 
        ELSE 'Unknown' 
    END AS flag_color
FROM 
    flag_comment fc
JOIN 
    users u ON u.uid = fc.uid
WHERE 
    fc.flagtype IN ('Approved', 'Warning', 'Suspicious', 'Priority', 'Blacklisted', 'FSA', 'Fraud', 'YouTube Network Abuse', 'Whitelisting YouTube channels', 'Bulk actions', 'Payments', 'Xpress', 'Publishing Information', 'Korean Account', 'Star artist')
GROUP BY 
    u.uid, fc.flagtype, fc.Apply_status,u.name,u.mail
LIMIT 10;


9. **If they ask amount earnings/total amount/outstanding amount of any user:** Use the `user_account_report` table have columns uid`, `total_amount`, `outstand_amount`
     list out the earnings for 38 => select * from user_account_report and pass the uid or username join with users table
10. **If flagtype is priority, then its is artist service accounts/artist service managed accounts/AS.
11. **If they ask can you confirm whether mcldevtest@gmail.com email address is the registered email ?,then check users table the mail is there or not.

       

9. **If user donot mention usernmae or userid ,ALWAYS ADD LIMIT 10.**

- If the input is a **13-digit number**, it's a UPC. Otherwise, it’s a user ID or username.

**User Information:**
- For `username` queries, use: `WHERE u.name = '<username>'`.
- For `user_id` queries, use: `WHERE u.uid = '<user_id>'`.

**When to Use `UNION` Queries:**
- For **forms-related** questions: Only use `UNION` if it involves forms data.
- For **tickets-related** questions: Only use `UNION` if it involves ticket data.
- For both forms and tickets: Use `UNION` between them only if necessary.

**Base Query Structure (don't modify it.):**
->Don't change query structure ,return as it is.
account closure = comm_tbl_smthub_ticket.tag_id = 1
revenue share = comm_tbl_smthub_ticket.tag_id = 4
content mapping = comm_tbl_smthub_ticket.tag_id = 2
youtbe oac = comm_tbl_smthub_ticket.tag_id = 3

groups table have types like Premium User,Priority User,HP Account ( High Profile ).

pending payments related to comm_account_closure.payment_created_at

DONOT MODIFY THIS QUERY .Only add where addition ,don't add or use having clause like that


Get the full query structure and ensure that only the {question} section is modified based on the input, without altering the core structure

Do not remove or modify the above query structure: The key change is to provide the full query structure upfront and ensure that only the {question} section is modified based on the input, without altering the core structure.

MySQL 5.6.51, you'll need to simplify your query significantly and avoid modern constructs.


SELECT 
    'FORMS' AS 'FORM/TICKET',
    ac.form_id AS form_id,
    'account closure' AS form_name,
    ac.userID AS userid ,
    u.name AS username,
    u.mail AS email,
  COALESCE(cg.me_email, 'No Associated Email') AS associated_email, 
    COALESCE(cgs.groups, 'No Group') AS user_type,  
    ac.submitted_at AS form_submitted_at, NULL AS tickets_received_at,
    ac.payment_created_at AS payment_task,
    COUNT(CASE WHEN cfs.form_id IS NOT NULL THEN 1 END) AS completed_count,
    COUNT(CASE WHEN cfs.form_id IS NULL THEN 1 END) AS not_completed_count,
    cfs.closed_by AS closed_by_id,
    cs.name AS closed_by,
    cfs.submitted_at AS form_closed_at,NULL AS ticket_closed_at,
    CASE 
        WHEN cfs.status = 'approve' THEN 'Completed'
        WHEN cfs.status = 'reject' THEN 'Rejected'
        WHEN cfs.status = 'request' THEN 'Waiting for user information/waiting for user action'
        WHEN cfs.status IS NULL THEN 'Not Yet closed/Need Admin Action/Admin Action need'
        ELSE 'Unknown'  
    END AS form_status,NULL AS subject,NULL AS body
    FROM comm_account_closure ac
JOIN users u ON ac.userID = u.uid
LEFT JOIN comm_form_status cfs ON cfs.form_id = ac.form_id AND cfs.type = 'account'
LEFT JOIN comm_staffs cs ON cfs.closed_by = cs.uid
LEFT JOIN comm_grouplist cg ON cg.userid = u.uid
LEFT JOIN comm_groups cgs ON cgs.id = cg.groupid
GROUP BY ac.form_id,ac.userID, u.name, u.mail, ac.submitted_at, ac.payment_created_at, cfs.closed_by, cs.name, cfs.submitted_at, cfs.type, cfs.status,cg.me_email,cgs.groups

UNION ALL

SELECT 
    'FORMS' AS 'FORM/TICKET',
    cm.id AS form_id,
    'content mapping' AS form_name,
    cm.userid AS userid ,
    u.name AS username,
    u.mail AS email,
     COALESCE(cg.me_email, 'No Associated Email') AS associated_email, 
    COALESCE(cgs.groups, 'No Group') AS user_type,  
    cm.submitted_at AS form_submitted_at, NULL AS tickets_received_at,
    NULL AS payment_task,
    COUNT(CASE WHEN cfs.form_id IS NOT NULL THEN 1 END) AS completed_count,
    COUNT(CASE WHEN cfs.form_id IS NULL THEN 1 END) AS not_completed_count,
    cfs.closed_by AS closed_by_id,
    COALESCE(cs.name, 'Not Assigned') AS closed_by,  
    cfs.submitted_at AS form_closed_at,NULL AS ticket_closed_at,
    CASE 
        WHEN cfs.status = 'approve' THEN 'Completed'
        WHEN cfs.status = 'reject' THEN 'Rejected'
        WHEN cfs.status = 'request' THEN 'Waiting for user information/ waiting for user action'
        WHEN cfs.status IS NULL THEN 'Not Yet closed/Need Admin Action/Admin Action need'
        ELSE 'Unknown' 
    END AS form_status,NULL AS subject,NULL AS body
    FROM comm_content_mapping cm
JOIN users u ON cm.userid = u.uid
JOIN comm_store_details csd ON csd.tbl_content_mapping_id = cm.id
LEFT JOIN comm_form_status cfs ON cfs.form_id = cm.id AND cfs.type = 'content'
LEFT JOIN comm_staffs cs ON cfs.closed_by = cs.uid
LEFT JOIN comm_grouplist cg ON cg.userid = u.uid
LEFT JOIN comm_groups cgs ON cgs.id = cg.groupid
GROUP BY cm.id,cm.userid, u.name, u.mail, cm.submitted_at, cfs.closed_by, cs.name, cfs.submitted_at, cfs.type, cfs.status,cg.me_email,cgs.groups

UNION ALL

SELECT 
    'FORMS' AS 'FORM/TICKET',
    rf.id AS form_id,
    'revenue form' AS form_name,
    rf.userid AS userid ,
    u.name AS username,
    u.mail AS email,
   COALESCE(cg.me_email, 'No Associated Email') AS associated_email, 
    COALESCE(cgs.groups, 'No Group') AS user_type,  
    rf.submitted_at AS form_submitted_at, NULL AS tickets_received_at, NULL AS payment_task,
    COUNT(CASE WHEN cfs.form_id IS NOT NULL THEN 1 END) AS completed_count,
    COUNT(CASE WHEN cfs.form_id IS NULL THEN 1 END) AS not_completed_count,
    cfs.closed_by AS closed_by_id,
    COALESCE(cs.name, 'Not Assigned') AS closed_by,  
    cfs.submitted_at AS form_closed_at,NULL AS ticket_closed_at,
    CASE 
        WHEN cfs.status = 'approve' THEN 'Completed'
        WHEN cfs.status = 'reject' THEN 'Rejected'
        WHEN cfs.status = 'request' THEN 'Waiting for user information/waiting for user action'
        WHEN cfs.status IS NULL THEN 'Not Yet closed/Need Admin Action/Admin Action need'
        ELSE 'Unknown' 
    END AS form_status,NULL AS subject,NULL AS body
    FROM comm_revenue_form rf
JOIN users u ON rf.userid = u.uid
JOIN comm_revenue_form_multiple rfm ON rf.id = rfm.Sid
LEFT JOIN comm_form_status cfs ON cfs.form_id = rf.id AND cfs.type = 'revenue'
LEFT JOIN comm_staffs cs ON cfs.closed_by = cs.uid
LEFT JOIN comm_grouplist cg ON cg.userid = u.uid
LEFT JOIN comm_groups cgs ON cgs.id = cg.groupid
GROUP BY rf.id,rf.userid, u.name, u.mail, rf.submitted_at, cfs.closed_by, cs.name, cfs.submitted_at, cfs.type, cfs.status,cg.me_email,cgs.groups

UNION ALL

SELECT 
    'FORMS' AS 'FORM/TICKET',
    oac.id AS form_id,
    'oac form' AS form_name,
    oac.userid AS userid,
    u.name AS username,
    u.mail AS email,
    COALESCE(cg.me_email, 'No Associated Email') AS associated_email, 
    COALESCE(cgs.groups, 'No Group') AS user_type,  
    oac.submitted_at AS form_submitted_at,
    NULL AS tickets_received_at, 
    NULL AS payment_task, 
    COUNT(CASE WHEN cfs.form_id IS NOT NULL THEN 1 END) AS completed_count,  
    COUNT(CASE WHEN cfs.form_id IS NULL THEN 1 END) AS not_completed_count,   
    cfs.closed_by AS closed_by_id,
    COALESCE(cs.name, 'Not Assigned') AS closed_by,  
    cfs.submitted_at AS form_closed_at,
    NULL AS ticket_closed_at,
    CASE 
        WHEN cfs.status = 'approve' THEN 'Completed'
        WHEN cfs.status = 'reject' THEN 'Rejected'
        WHEN cfs.status = 'request' THEN 'Waiting for user information/waiting for user action'
        WHEN cfs.status IS NULL THEN 'Not Yet closed/Need Admin Action/Admin Action need'
        ELSE 'Unknown' 
    END AS form_status,
    NULL AS subject,
    NULL AS body
FROM comm_oac_form oac
JOIN users u ON oac.userid = u.uid
LEFT JOIN comm_form_status cfs ON cfs.form_id = oac.id AND cfs.type = 'oac'
LEFT JOIN comm_staffs cs ON cfs.closed_by = cs.uid
LEFT JOIN comm_grouplist cg ON cg.userid = u.uid
LEFT JOIN comm_groups cgs ON cgs.id = cg.groupid
GROUP BY oac.id, oac.userid, u.name, u.mail, oac.submitted_at, cfs.closed_by, cs.name, cfs.submitted_at, cfs.type, cfs.status, cg.me_email, cgs.groups

UNION ALL 

SELECT 
    'TICKETS' AS 'FORM/TICKET',
    st.id AS ticket_id,
    tt.tag_name AS form_name,
    st.uid AS userid,
    u.name AS username,
    st.from_addr AS email,
    COALESCE(cg.me_email, 'No Associated Email') AS associated_email,
    COALESCE(cgs.groups, 'No Group') AS user_type,
    NULL AS form_submitted_at,
    st.tickets_received AS tickets_received_at,
    NULL AS payment_task,
    COUNT(CASE WHEN st.completed_at IS NOT NULL AND st.completed_at != '' THEN 1 END) AS completed_count,
    COUNT(CASE WHEN st.completed_at IS NULL OR st.completed_at = '' THEN 1 END) AS not_completed_count,
    COALESCE(st.assigned_to, 'N/A') AS closed_by_id,
    COALESCE(cs.name, 'Not Assigned') AS closed_by,
    NULL AS form_closed_at,
    st.completed_at AS ticket_closed_at,
    CASE 
        WHEN st.completed_at IS NOT NULL AND st.completed_at != '' THEN 'Completed'
        ELSE 'Not Yet closed/Not Completed'
    END AS form_status,
    st.subject,
    st.body
FROM comm_tbl_smthub_ticket st
LEFT JOIN comm_tag tt ON tt.id = st.tag_id
LEFT JOIN users u ON st.uid = u.uid
LEFT JOIN comm_staffs cs ON cs.uid = st.assigned_to
LEFT JOIN comm_grouplist cg ON cg.userid = u.uid
LEFT JOIN comm_groups cgs ON cgs.id = cg.groupid
GROUP BY st.id, st.uid, tt.tag_name, st.tickets_received, st.completed_at, st.assigned_to, u.name, st.from_addr, cs.name, st.subject, st.body, cg.me_email, cgs.groups;



---If they ask upc in forms/upc related to any forms, generate below query--- 

example:
SELECT 
    'revenue form' AS form_name,
    rf.id, 
    rf.userid, 
    u.name AS username, 
    u.mail AS email, 
    rfm.RevenueShareTo, 
    rf.submitted_at 
FROM comm_revenue_form rf
JOIN users u ON rf.userid = u.uid
JOIN comm_revenue_form_multiple rfm ON rf.id = rfm.Sid
WHERE rfm.RevenueShareTo LIKE '%<upc>%'

UNION ALL 

SELECT 
    'Content form' AS form_name,
    cm.id, 
    cm.userid, 
    u.name AS username, 
    u.mail AS email, 
    cm.submitted_at, 
    csd.upc 
FROM comm_content_mapping cm
JOIN users u ON cm.userid = u.uid
JOIN comm_store_details csd ON csd.tbl_content_mapping_id = cm.id
WHERE csd.upc = '<upc>'

UNION ALL

SELECT 
    'oac form' AS form_name,
    oc.id, 
    oc.userid, 
    u.name AS username, 
    u.mail AS email, 
    oc.upc, 
    oc.submitted_at 
FROM comm_oac_form oc
JOIN users u ON oc.userid = u.uid
WHERE oc.upc LIKE '%<upc>%';


**Continue with UNION structure as needed for the form or ticket related queries.**


 {question} """
     
        print(generate_sql(prompt))
    else:
        print("Provide input as command-line argument")








