import React, { useEffect, useRef, useState } from "react";
import { Modelview } from "./Popup";
import { jsonvalues } from "./utils/getjson";
import { json, useParams } from "react-router-dom";
import { List, Spin } from "antd";
import { CardView } from "./card/progresscard";
import { Listview } from "./Listview";
import { Tableview } from "./Tableview";
import NameInitials from "./utils/NameInitials";

export default function Home() {

    const { id } = useParams();

    console.log('id', id || null)

    const [searchlist, setsearchlist] = useState(false);
    const [filopt, setfilopt] = useState(true);
    const inputRef = useRef(null);
    const [comlist, setcomlist] = useState(true);
    const [comlist1, setcomlist1] = useState(false);
    const [comlist2, setcomlist2] = useState(false);
    const [data, setData] = useState([{
        "id": "",
        "Maintask": "",
        "Subtask": "",
        "Datetime": ""
    }]);
    const [loading, setLoading] = useState(false);

    const [profile, setprofile] = useState(true);
    const [dashboard, setdashboard] = useState(false);
    const [settings, setsettings] = useState(false);
    const [lowfill, setlowfill] = useState(null);
    const [lowlogg, setlowlogg] = useState(false);
    const [Assig, setAssig] = useState(false);
    const [Assigfill, setAssigfill] = useState(null);
    const [srfrrfrt, setsrfrrfrt] = useState('');



    useEffect(() => {

        const fetchData = async () => {
            try {
                if (id == 0) {
                    setData([{
                        "id": "0",
                        "Maintask": "Moderation review time queries and complaints",
                        "Subtask": "",
                        "Datetime": "2024-06-13 10:41:53"
                    }])
                    setLoading(true);
                } else {
                    const response = await jsonvalues(id || null);
                    setData(response.data)
                    setLoading(true);
                    // console.log('response',response.data1)
                }
            } catch (error) {
                console.error('Error:', error);
            }
        };

        fetchData();



    }, [])


    useEffect(() => {

        const fetchData = async () => {
            try {
                if (id == 0) {
                    setData([{
                        "id": "0",
                        "Maintask": "Moderation review time queries and complaints",
                        "Subtask": "",
                        "Datetime": "2024-06-13 10:41:53"
                    }])
                    setLoading(true);
                } else {
                    const response = await jsonvalues(id || null);
                    setData(response.data)
                    setLoading(true);
                    // console.log('response',response.data1)
                }
            } catch (error) {
                console.error('Error:', error);
            }
        };

        fetchData();



    }, [lowfill])




    const data1 = [
        {
            "name": "New",
            "bg": "#f3f4f5",
            "color": "#282929",
            "flag": "#e8eaed",
            "taskicon": "#d1d5db",
            "users": "#be185d",
            id: 1
        },
        {
            "name": "IN progress",
            "bg": "#5f55ee26",
            "color": "#fff",
            "flag": "#5f55ee",
            "taskicon": "#fff",
            "users": "#4338ca",
            id: 2
        },
        {
            "name": "High Profile",
            "bg": "#f2f9fe",
            "color": "#fff",
            "flag": "#1090e0",
            "taskicon": "#fff",
            "users": "#0f766e",
            id: 3
        },
        {
            "name": "Resolved",
            "bg": "#f2f9f5",
            "color": "#fff",
            "flag": "#084",
            "taskicon": "#fff",
            "users": "#1d4ed8",
            id: 4
        },

    ]





    return (
        <>
            <div className={`w-full p-3 text-center ${loading ? 'hidden' : 'block'}`}>
                <Spin spinning={!loading} delay={500}></Spin>
            </div>
            <div className={`${!loading ? 'hidden' : 'block'}`}>
                <div>
                    <nav aria-label="breadcrumb" className="block w-full p-2">
                        <ol className="flex flex-wrap items-center w-full px-4 py-[6px] rounded-md bg-blue-gray-50 bg-opacity-60">
                            <li
                                className="flex items-center font-sans text-sm antialiased font-normal leading-normal transition-colors duration-300 cursor-pointer text-blue-gray-900 hover:text-light-blue-500">
                                <a className="opacity-60">
                                    {data[0].Maintask.length <= 30 ? data[0].Maintask : (data[0].Maintask.substring(0, 30) + "...")}
                                </a>0
                                <span
                                    className="mx-2 font-sans text-sm antialiased font-normal leading-normal pointer-events-none select-none text-blue-gray-500">
                                    /
                                </span>
                            </li>
                            <li
                                className="flex items-center font-sans text-sm antialiased font-normal leading-normal transition-colors duration-300 cursor-pointer text-blue-gray-900 hover:text-light-blue-500">
                                <a className="opacity-60">
                                    {data[0].Subtask}
                                </a>
                            </li>
                        </ol>
                    </nav>
                </div>
                <div className="mt-2 border-t border-gray-300">
                    <div className=" border-b border-gray-200 dark:border-gray-700">
                        <ul className="flex flex-wrap justify-between -mb-px text-sm font-medium text-center" id="default-tab" data-tabs-toggle="#default-tab-content" role="tablist">
                            <div className="flex flex-wrap -mb-px text-sm font-medium text-center" id="default-tab" data-tabs-toggle="#default-tab-content" role="tablist">
                                <li className="me-2" role="presentation">
                                    <button className={`inline-block p-2 border-b-2 outline-none rounded-t-lg ${profile && 'border-indigo-600 border-b-[3px]'}`} type="button" onClick={() => { setprofile(true); setdashboard(false); setsettings(false) }} aria-controls="profile" aria-selected="false">
                                        <div className="flex items-center gap-2 p-1 rounded-[4px] hover:bg-gray-100">
                                            <svg xmlns="http://www.w3.org/2000/svg" width="14" height="14" fill="currentColor" className="bi bi-view-list" viewBox="0 0 16 16">
                                                <path d="M3 4.5h10a2 2 0 0 1 2 2v3a2 2 0 0 1-2 2H3a2 2 0 0 1-2-2v-3a2 2 0 0 1 2-2m0 1a1 1 0 0 0-1 1v3a1 1 0 0 0 1 1h10a1 1 0 0 0 1-1v-3a1 1 0 0 0-1-1zM1 2a.5.5 0 0 1 .5-.5h13a.5.5 0 0 1 0 1h-13A.5.5 0 0 1 1 2m0 12a.5.5 0 0 1 .5-.5h13a.5.5 0 0 1 0 1h-13A.5.5 0 0 1 1 14" />
                                            </svg>
                                            <span>Board</span>
                                        </div>
                                    </button>
                                </li>
                                <li className="me-2" role="presentation">
                                    <button className={`inline-block p-2 outline-none border-b-2 ${dashboard && 'border-indigo-600 border-b-[3px]'} rounded-t-lg`} type="button" onClick={() => { setprofile(false); setdashboard(true); setsettings(false) }} aria-controls="dashboard" aria-selected="false">
                                        <div className="flex items-center gap-2 p-1 rounded-[4px] hover:bg-gray-100">
                                            <svg xmlns="http://www.w3.org/2000/svg" width="14" height="14" fill="currentColor" className="bi bi-list-ul" viewBox="0 0 16 16">
                                                <path fill-rule="evenodd" d="M5 11.5a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5m0-4a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5m0-4a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5m-3 1a1 1 0 1 0 0-2 1 1 0 0 0 0 2m0 4a1 1 0 1 0 0-2 1 1 0 0 0 0 2m0 4a1 1 0 1 0 0-2 1 1 0 0 0 0 2" />
                                            </svg>
                                            <span>List</span>
                                        </div>
                                    </button>
                                </li>
                                <li className="me-2" role="presentation">
                                    <button className={`inline-block p-2 outline-none border-b-2 rounded-t-lg ${settings && 'border-indigo-600 border-b-[3px]'}`} type="button" onClick={() => { setprofile(false); setdashboard(false); setsettings(true) }} aria-controls="settings" aria-selected="false">
                                        <div className="flex items-center gap-2 p-1 rounded-[4px] hover:bg-gray-100">
                                            <svg xmlns="http://www.w3.org/2000/svg" width="14" height="14" fill="currentColor" className="bi bi-table" viewBox="0 0 16 16">
                                                <path d="M0 2a2 2 0 0 1 2-2h12a2 2 0 0 1 2 2v12a2 2 0 0 1-2 2H2a2 2 0 0 1-2-2zm15 2h-4v3h4zm0 4h-4v3h4zm0 4h-4v3h3a1 1 0 0 0 1-1zm-5 3v-3H6v3zm-5 0v-3H1v2a1 1 0 0 0 1 1zm-4-4h4V8H1zm0-4h4V4H1zm5-3v3h4V4zm4 4H6v3h4z" />
                                            </svg>
                                            <span>Table</span>
                                        </div>
                                    </button>
                                </li>
                                <li className="me-2 py-3 text-gray-300" role="presentation">|</li>
                            </div>
                            <div className="flex items-center">
                                <li className="me-2" role="presentation">
                                    <div onClick={() => { inputRef.current.focus(); setfilopt(false) }} className="cursor-pointer flex items-center gap-1 text-[#656f7d] hover:bg-[#e8eaed] px-[5px] py-[3px] w-max rounded-[4px]">
                                        <svg xmlns="http://www.w3.org/2000/svg" width="14" height="14" fill="currentColor" className="bi bi-search" viewBox="0 0 16 16">
                                            <path d="M11.742 10.344a6.5 6.5 0 1 0-1.397 1.398h-.001q.044.06.098.115l3.85 3.85a1 1 0 0 0 1.415-1.414l-3.85-3.85a1 1 0 0 0-.115-.1zM12 6.5a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0" />
                                        </svg>
                                        <span className="text-[14px]">Search</span>
                                    </div>
                                </li>
                                <li className="me-2" role="presentation">
                                    <div onClick={() => setfilopt(!filopt)} className="flex items-center gap-1 bg-[#e7f5f5] px-[5px] py-[3px] w-max rounded-[4px] cursor-pointer">
                                        <svg width="14" height="14" viewBox="0 0 48 48" className="rotate-90" fill="#19898c" xmlns="http://www.w3.org/2000/svg">
                                            <rect width="48" height="48" fill="none" />
                                            <path d="M8 6.2V26.3a6.2 6.2 0 0 0-4 5.7 6 6 0 0 0 4 5.6v4.2a2.1 2.1 0 0 0 2 2.2 2.1 2.1 0 0 0 2-2.2V37.6a6 6 0 0 0 4-5.7 6.2 6.2 0 0 0-4-5.6V6.2a2.1 2.1 0 0 0-2-2.2 2.1 2.1 0 0 0-2 2.2zM22 6.2v4.1a6.2 6.2 0 0 0-4 5.7 6 6 0 0 0 4 5.6V41.8a2 2 0 1 0 4 0V21.6a6 6 0 0 0 4-5.7 6.2 6.2 0 0 0-4-5.6V6.2a2 2 0 1 0-4 0zM36 6.2V23.3a6.2 6.2 0 0 0-4 5.7 6 6 0 0 0 4 5.6v7.2a2 2 0 1 0 4 0V34.6a6 6 0 0 0 4-5.7 6.2 6.2 0 0 0-4-5.6V6.2a2 2 0 1 0-4 0z" />
                                        </svg>
                                        {filopt ? <span className="text-[#19898c]" >Filter</span> : <span className="text-[#19898c]" >Hide</span>}
                                    </div>
                                </li>
                                <li className="me-2" role="presentation">
                                    <div className="flex items-center gap-1 bg-[#0f9d9f] rounded-[4px] w-max px-2">
                                        <span className="text-[12px] text-white px-[5px] py-[3px] border-r border-[#6669] cursor-pointer">Add Task</span>
                                        <svg xmlns="http://www.w3.org/2000/svg" width="12" height="12" fill="#fff" className="bi bi-chevron-down p-[1px]  cursor-pointer" viewBox="0 0 16 16">
                                            <path fill-rule="evenodd" d="M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708" />
                                        </svg>
                                    </div>
                                </li>
                            </div>
                        </ul>
                    </div>

                    <div className={` ${filopt ? 'h-0' : 'h-12'} overflow-hidden w-full flex gap-2 items-center justify-between pl-1 px-4 transition-all`}>
                        <div className="h-12 w-full flex gap-2 items-center px-4 w-max">
                            <div className="relative">
                                <div onClick={() => setAssig(!Assig)} className="flex items-center gap-1 px-2 py-[3px] border border-[#e9ebee] text-[#656f7d] rounded-full cursor-pointer">
                                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" className="bi bi-people-fill" viewBox="0 0 16 16">
                                        <path d="M7 14s-1 0-1-1 1-4 5-4 5 3 5 4-1 1-1 1zm4-6a3 3 0 1 0 0-6 3 3 0 0 0 0 6m-5.784 6A2.24 2.24 0 0 1 5 13c0-1.355.68-2.75 1.936-3.72A6.3 6.3 0 0 0 5 9c-4 0-5 3-5 4s1 1 1 1zM4.5 8a2.5 2.5 0 1 0 0-5 2.5 2.5 0 0 0 0 5" />
                                    </svg>
                                    <span className="text-[12px]">Assignees</span>
                                </div>
                                {Assig && <ul role="menu" data-popover="menu" data-popover-placement="bottom"
                                    class="fixed z-10 min-w-[180px] overflow-auto rounded-md border border-blue-gray-50 bg-white p-3 font-sans text-sm font-normal text-blue-gray-500 shadow-lg shadow-blue-gray-500/10 focus:outline-none">
                                    <li role="menuitem" onClick={() => { setAssigfill('Admin1'); setAssig(false); }}
                                        class="block w-full cursor-pointer select-none rounded-md px-3 pt-[9px] pb-2 text-start leading-tight transition-all hover:bg-blue-gray-50 hover:bg-opacity-80 hover:text-blue-gray-900 focus:bg-blue-gray-50 focus:bg-opacity-80 focus:text-blue-gray-900 active:bg-blue-gray-50 active:bg-opacity-80 active:text-blue-gray-900">
                                        <div className="flex items-center gap-2">
                                            <div className={`w-8 h-8 rounded-full bg-[#be185d] flex items-center justify-center text-[11px] text-white`}><NameInitials fullName={"Admin1"} /></div>
                                            <span>Admin1</span>
                                        </div>
                                    </li>
                                    <li role="menuitem" onClick={() => { setAssigfill('Admin2'); setAssig(false); }}
                                        class="block w-full cursor-pointer select-none rounded-md px-3 pt-[9px] pb-2 text-start leading-tight transition-all hover:bg-blue-gray-50 hover:bg-opacity-80 hover:text-blue-gray-900 focus:bg-blue-gray-50 focus:bg-opacity-80 focus:text-blue-gray-900 active:bg-blue-gray-50 active:bg-opacity-80 active:text-blue-gray-900">
                                        <div className="flex items-center gap-2">
                                        <div className={`w-8 h-8 rounded-full bg-[#4338ca] flex items-center justify-center text-[11px] text-white`}><NameInitials fullName={"Admin2"} /></div>
                                            <span>Admin2</span>
                                        </div>
                                    </li>
                                    <li role="menuitem" onClick={() => { setAssigfill('maxi'); setAssig(false); }}
                                        class="block w-full cursor-pointer select-none rounded-md px-3 pt-[9px] pb-2 text-start leading-tight transition-all hover:bg-blue-gray-50 hover:bg-opacity-80 hover:text-blue-gray-900 focus:bg-blue-gray-50 focus:bg-opacity-80 focus:text-blue-gray-900 active:bg-blue-gray-50 active:bg-opacity-80 active:text-blue-gray-900">
                                        <div className="flex items-center gap-2">
                                        <div className={`w-8 h-8 rounded-full bg-[#0f766e] flex items-center justify-center text-[11px] text-white`}><NameInitials fullName={"maxi"} /></div>
                                            <span>maxi</span>
                                        </div>
                                    </li>
                                    <li role="menuitem" onClick={() => { setAssigfill('sellerr'); setAssig(false); }}
                                        class="block w-full cursor-pointer select-none rounded-md px-3 pt-[9px] pb-2 text-start leading-tight transition-all hover:bg-blue-gray-50 hover:bg-opacity-80 hover:text-blue-gray-900 focus:bg-blue-gray-50 focus:bg-opacity-80 focus:text-blue-gray-900 active:bg-blue-gray-50 active:bg-opacity-80 active:text-blue-gray-900">
                                        <div className="flex items-center gap-2">
                                        <div className={`w-8 h-8 rounded-full bg-[#1d4ed8] flex items-center justify-center text-[11px] text-white`}><NameInitials fullName={"sellerr"} /></div>
                                            <span>sellerr</span>
                                        </div>
                                    </li>
                                </ul>}
                            </div>
                            <div className="relative">
                                <div onClick={() => { setlowlogg(!lowlogg); }} className="flex items-center gap-1 px-2 py-[3px] border border-[#e9ebee] text-[#656f7d] rounded-full cursor-pointer">
                                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="currentColor"><path d="M19 4H6V2H4v18H3v2h4v-2H6v-5h13a1 1 0 0 0 1-1V5a1 1 0 0 0-1-1z"></path></svg>
                                    <span className="text-[12px]">Priority</span>
                                </div>
                                {lowlogg && <ul role="menu" data-popover="menu" data-popover-placement="bottom"
                                    class="fixed z-10 min-w-[180px] overflow-auto rounded-md border border-blue-gray-50 bg-white p-3 font-sans text-sm font-normal text-blue-gray-500 shadow-lg shadow-blue-gray-500/10 focus:outline-none">
                                    <li role="menuitem" onClick={() => { setlowfill('Urgent'); setlowlogg(false); }}
                                        class="block w-full cursor-pointer select-none rounded-md px-3 pt-[9px] pb-2 text-start leading-tight transition-all hover:bg-blue-gray-50 hover:bg-opacity-80 hover:text-blue-gray-900 focus:bg-blue-gray-50 focus:bg-opacity-80 focus:text-blue-gray-900 active:bg-blue-gray-50 active:bg-opacity-80 active:text-blue-gray-900">
                                        <div className="flex items-center gap-2">
                                            <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="#B13A41" className="w-5 h-5" viewBox="0 0 24 24">
                                                <path d="M19 4H6V2H4v18H3v2h4v-2H6v-5h13a1 1 0 0 0 1-1V5a1 1 0 0 0-1-1z"></path>
                                            </svg>
                                            <span>Urgent</span>
                                        </div>
                                    </li>
                                    <li role="menuitem" onClick={() => { setlowfill('High'); setlowlogg(false); }}
                                        class="block w-full cursor-pointer select-none rounded-md px-3 pt-[9px] pb-2 text-start leading-tight transition-all hover:bg-blue-gray-50 hover:bg-opacity-80 hover:text-blue-gray-900 focus:bg-blue-gray-50 focus:bg-opacity-80 focus:text-blue-gray-900 active:bg-blue-gray-50 active:bg-opacity-80 active:text-blue-gray-900">
                                        <div className="flex items-center gap-2">
                                            <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="#cf940a" className="w-5 h-5" viewBox="0 0 24 24">
                                                <path d="M19 4H6V2H4v18H3v2h4v-2H6v-5h13a1 1 0 0 0 1-1V5a1 1 0 0 0-1-1z"></path>
                                            </svg>
                                            <span>High</span>
                                        </div>
                                    </li>
                                    <li role="menuitem" onClick={() => { setlowfill('Normal'); setlowlogg(false); }}
                                        class="block w-full cursor-pointer select-none rounded-md px-3 pt-[9px] pb-2 text-start leading-tight transition-all hover:bg-blue-gray-50 hover:bg-opacity-80 hover:text-blue-gray-900 focus:bg-blue-gray-50 focus:bg-opacity-80 focus:text-blue-gray-900 active:bg-blue-gray-50 active:bg-opacity-80 active:text-blue-gray-900">
                                        <div className="flex items-center gap-2">
                                            <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="#46f" className="w-5 h-5" viewBox="0 0 24 24">
                                                <path d="M19 4H6V2H4v18H3v2h4v-2H6v-5h13a1 1 0 0 0 1-1V5a1 1 0 0 0-1-1z"></path>
                                            </svg>
                                            <span>Normal</span>
                                        </div>
                                    </li>
                                    <li role="menuitem" onClick={() => { setlowfill('Low'); setlowlogg(false); }}
                                        class="block w-full cursor-pointer select-none rounded-md px-3 pt-[9px] pb-2 text-start leading-tight transition-all hover:bg-blue-gray-50 hover:bg-opacity-80 hover:text-blue-gray-900 focus:bg-blue-gray-50 focus:bg-opacity-80 focus:text-blue-gray-900 active:bg-blue-gray-50 active:bg-opacity-80 active:text-blue-gray-900">
                                        <div className="flex items-center gap-2">
                                            <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="#87909e" className="w-5 h-5" viewBox="0 0 24 24">
                                                <path d="M19 4H6V2H4v18H3v2h4v-2H6v-5h13a1 1 0 0 0 1-1V5a1 1 0 0 0-1-1z"></path>
                                            </svg>
                                            <span>Low</span>
                                        </div>
                                    </li>
                                </ul>}
                            </div>
                        </div>
                        <div className="w-52">
                            <div className="relative h-8 w-full min-w-[100px] ">
                                <input type="search" ref={inputRef} placeholder="Search tasks..." onChange={(e) => setsrfrrfrt(e.target.value)}
                                    className="peer h-full w-full rounded-[7px]  !border pr-8  !border-gray-300 border-t-transparent bg-transparent bg-white px-3 py-2.5 font-sans text-sm font-normal text-blue-gray-700  shadow-lg shadow-gray-900/5 outline outline-0 ring-4 ring-transparent transition-all placeholder:text-gray-500 placeholder-shown:border placeholder-shown:border-blue-gray-100 placeholder-shown:border-t-blue-gray-200 focus:border-2  focus:!border-[#0f9d9f] focus:border-t-transparent focus:!border-t-[#0f9d9f] focus:outline-0 focus:ring-[#d8eff0] disabled:border-0 disabled:bg-blue-gray-50" />
                                {/* <label className="absolute right-1 top-1 hover:bg-zinc-200 p-1 rounded-[4px] cursor-pointer" onClick={() => setsearchlist(!searchlist)}>
                                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" className="bi bi-three-dots" viewBox="0 0 16 16">
                                        <path d="M3 9.5a1.5 1.5 0 1 1 0-3 1.5 1.5 0 0 1 0 3m5 0a1.5 1.5 0 1 1 0-3 1.5 1.5 0 0 1 0 3m5 0a1.5 1.5 0 1 1 0-3 1.5 1.5 0 0 1 0 3" />
                                    </svg>
                                </label> */}
                            </div>
                            <Modelview visiable={searchlist} />
                        </div>
                    </div>
                    {/* style={{'transform': 'rotate(90deg)','transformOrigin': 'left bottom'}} */}
                    <div id="default-tab-content w-full">
                        {profile && <div className="w-auto p-4 rounded-lg flex gap-2 transition-all" id="profile" role="tabpanel" aria-labelledby="profile-tab">
                            {/* {Jsondata.map((items, i) => <Createtaskview  id={items.id} name={items.name} bg={items.bg} color={items.color} flag={items.flag} taskicon={items.taskicon} />)} */}
                            <CardView lowfill={lowfill} Assigfill={Assigfill} srfrrfrt={srfrrfrt} json={data1} tag={id || null} maintask={data[0].Maintask} subtask={data[0].Subtask} />

                            {/* {data1.map((item, i) => (
                                    <CardView key={item.id} list={i} tag={id || null} ids={item.id} name={item.name} bg={item.bg} color={item.color} flag={item.flag} taskicon={item.taskicon} maintask={data[0].Maintask} subtask={data[0].Subtask} />
                                ))} */}
                        </div>}
                        {dashboard && <div className="p-4 rounded-lg h-[30rem] overflow-y-auto" id="dashboard" role="tabpanel" aria-labelledby="dashboard-tab">
                            <Listview id={id} />
                        </div>}
                        {settings && <div className="p-4 rounded-lg h-[30rem] overflow-y-auto" id="settings" role="tabpanel" aria-labelledby="settings-tab">
                            <Tableview id={id} />
                        </div>}
                    </div>
                </div>
            </div>

        </>
    )
}