import { useEffect, useState } from "react";
import NameInitials, { FormatDate } from "./utils/NameInitials";
import { TaskLog, jsonvalues } from "./utils/getjson";
import { List } from "antd";

export const Listview = ({ id }) => {

    const [getdata, setgetdata] = useState([{
        "id": '',
        "Maintask": "",
        "Subtask": "",
        "Status": '',
        "Taskname": "",
        "Assignee": "",
        "Datetime": "",
        "Priority": ""
    }]);

    useEffect(() => {
        const fetchin = async (tag) => {
            try {
                const response = await jsonvalues(tag);
                setgetdata(response.data1);
            } catch (error) {
                console.error('Error:', error);
            }
        }
        fetchin(id);

    }, [id])


    const data1 = [
        {
            "name": "New",
            "bg": "#f3f4f5",
            "color": "#282929",
            "flag": "#e8eaed",
            "taskicon": "#d1d5db",
            "users": "#be185d",
            id: 1
        },
        {
            "name": "IN progress",
            "bg": "#5f55ee",
            "color": "#fff",
            "flag": "#1090e0",
            "taskicon": "#fff",
            "users": "#4338ca",
            id: 2
        },
        {
            "name": "High Profile",
            "bg": "#1090e0",
            "color": "#fff",
            "flag": "#1090e0",
            "taskicon": "#fff",
            "users": "#0f766e",
            id: 3
        },
        {
            "name": "Resolved",
            "bg": "#084",
            "color": "#fff",
            "flag": "#084",
            "taskicon": "#fff",
            "users": "#1d4ed8",
            id: 4
        },

    ];

    const [procStates, setProcStates] = useState(data1.map(() => false));


    console.log('getdata', getdata.filter(g => g.Status == 0) > 0 ? 1 : 0)

    useEffect(() => {
        const newProcStates = [...procStates];
        newProcStates[0] = !newProcStates[0];
        setProcStates(newProcStates);
    }, [])


    return (
        <>
            {data1.map((val, index) =>
                <div className="p-3">
                    <div className="flex items-center gap-4">
                        <div className="hover:bg-zinc-200 h-8 w-8 flex items-center justify-center rounded-lg cursor-pointer" onClick={() => {
                            const newProcStates = [...procStates];
                            newProcStates[index] = !newProcStates[index];
                            setProcStates(newProcStates);
                        }}>
                            <svg xmlns="http://www.w3.org/2000/svg" width="14" height="14" fill="#3a4556" className={`bi bi-caret-right-fill ${procStates[index] && 'rotate-90'}`} viewBox="0 0 16 16">
                                <path d="m12.14 8.753-5.482 4.796c-.646.566-1.658.106-1.658-.753V3.204a1 1 0 0 1 1.659-.753l5.48 4.796a1 1 0 0 1 0 1.506z" />
                            </svg>
                        </div>
                        <div className={`uppercase h-max py-1 text-[13.5px] w-max px-2 rounded-lg text-[${val.color}] bg-[${val.bg}] flex items-center gap-1`}>
                            {val.name == 'New' ?
                                <div class="h-4 w-4 rounded-full bg-[#fff] flex items-center justify-center">
                                    <div class="h-3 w-3 rounded-full bg-[#fff] border"></div>
                                </div>
                                : val.name == 'IN progress' ?
                                    <svg xmlns="http://www.w3.org/2000/svg" width="20" fill="currentColor" height="20" viewBox="0 0 24 24" >
                                        <path d="M12 22c5.514 0 10-4.486 10-10S17.514 2 12 2 2 6.486 2 12s4.486 10 10 10zm0-18c4.411 0 8 3.589 8 8s-3.589 8-8 8-8-3.589-8-8 3.589-8 8-8z"></path>
                                        <path d="M19 12a7 7 0 0 0-7-7v14a7 7 0 0 0 7-7z"></path>
                                    </svg> :
                                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="#fff" class="bi bi-check-circle-fill" viewBox="0 0 16 16">
                                        <path d="M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0m-3.97-3.03a.75.75 0 0 0-1.08.022L7.477 9.417 5.384 7.323a.75.75 0 0 0-1.06 1.06L6.97 11.03a.75.75 0 0 0 1.079-.02l3.992-4.99a.75.75 0 0 0-.01-1.05z"></path>
                                    </svg>}
                            <span>{val.name}</span>
                        </div>
                    </div>
                    {procStates[index] &&
                        <div className="px-6">
                            <table className="w-full text-left table-auto mt-4 min-w-max">
                                <thead>
                                    <tr>
                                        <th class="px-4 py-2 border-b border-blue-gray-100 text-xs font-normal border-b border-blue-gray-100 bg-blue-gray-50 text-[#656f7d]">Name</th>
                                        <th class="px-4 py-2 border-b border-blue-gray-100 text-xs font-normal border-b border-blue-gray-100 bg-blue-gray-50 text-[#656f7d]">Assignee</th>
                                        <th class="px-4 py-2 border-b border-blue-gray-100 text-xs font-normal border-b border-blue-gray-100 bg-blue-gray-50 text-[#656f7d]">Due date</th>
                                        <th class="px-4 py-2 border-b border-blue-gray-100 text-xs font-normal border-b border-blue-gray-100 bg-blue-gray-50 text-[#656f7d]">Priority</th>
                                        <th class="px-4 py-2 border-b border-blue-gray-100 text-xs font-normal border-b border-blue-gray-100 bg-blue-gray-50 text-[#656f7d]">Comments</th>
                                    </tr>
                                </thead>
                                <tbody className="text-[#2a2e34] text-[12px]">
                                    {getdata.filter(g => g.Status == val.id - 1).length > 0 ? getdata.filter(g => g.Status == val.id - 1).map((item, i) =>
                                        <tr key={item.id} className={i % 2 === 0 ? "even:bg-blue-gray-50/50 border-b" : ""}>
                                            <td class="px-4 py-1 flex items-center gap-1 w-40 ">
                                                {val.name == 'New' ?
                                                    <div class="h-4 w-4 rounded-full bg-[#ddd] flex items-center justify-center">
                                                        <div class="h-3 w-3 rounded-full bg-[#ddd] border border-[#fff]"></div>
                                                    </div>
                                                    : val.name == 'IN progress' ?
                                                        <svg xmlns="http://www.w3.org/2000/svg" width="20" fill="#5f55ee" height="20" viewBox="0 0 24 24" >
                                                            <path d="M12 22c5.514 0 10-4.486 10-10S17.514 2 12 2 2 6.486 2 12s4.486 10 10 10zm0-18c4.411 0 8 3.589 8 8s-3.589 8-8 8-8-3.589-8-8 3.589-8 8-8z"></path>
                                                            <path d="M19 12a7 7 0 0 0-7-7v14a7 7 0 0 0 7-7z"></path>
                                                        </svg> : val.name == 'Resolved' ?
                                                            <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="#084" class="bi bi-check-circle-fill" viewBox="0 0 16 16">
                                                                <path d="M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0m-3.97-3.03a.75.75 0 0 0-1.08.022L7.477 9.417 5.384 7.323a.75.75 0 0 0-1.06 1.06L6.97 11.03a.75.75 0 0 0 1.079-.02l3.992-4.99a.75.75 0 0 0-.01-1.05z"></path>
                                                            </svg>
                                                            : <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="#1090e0" viewBox="0 0 24 24"><path d="M19 4H6V2H4v18H3v2h4v-2H6v-5h13a1 1 0 0 0 1-1V5a1 1 0 0 0-1-1z"></path></svg>}
                                                <p class="block text-sm antialiased font-normal leading-normal">
                                                    {item.Taskname}
                                                </p>
                                            </td>
                                            <td class="px-4 py-1 w-40">
                                                <p class="block font-sans text-sm antialiased font-normal leading-normal text-[#2a2e34]">
                                                    <div class={`w-6 h-6 rounded-full bg-[${val.users}] flex items-center justify-center text-[10px] text-white`}>
                                                        <div><NameInitials fullName={item.Assignee} /></div>
                                                    </div>
                                                </p>
                                            </td>
                                            <td class="px-4 py-1 w-40">
                                                <p class="block font-sans text-sm antialiased font-normal leading-normal text-[#2a2e34]">
                                                    <FormatDate dateString={item.Datetime} />
                                                </p>
                                            </td>
                                            <td class="px-4 py-1 w-40">
                                                <div className="flex items-center gap-1 font-sans antialiased font-normal leading-relaxed">
                                                    <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" fill="#B13A41" className="w-5 h-5" viewBox="0 0 24 24">
                                                        <path d="M19 4H6V2H4v18H3v2h4v-2H6v-5h13a1 1 0 0 0 1-1V5a1 1 0 0 0-1-1z"></path>
                                                    </svg>
                                                    <span>{item.Priority}</span>
                                                </div>
                                            </td>
                                            <td class="px-4 py-1 w-40">
                                                <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-chat-right" viewBox="0 0 16 16">
                                                    <path d="M2 1a1 1 0 0 0-1 1v8a1 1 0 0 0 1 1h9.586a2 2 0 0 1 1.414.586l2 2V2a1 1 0 0 0-1-1zm12-1a2 2 0 0 1 2 2v12.793a.5.5 0 0 1-.854.353l-2.853-2.853a1 1 0 0 0-.707-.293H2a2 2 0 0 1-2-2V2a2 2 0 0 1 2-2z" />
                                                </svg>
                                            </td>
                                        </tr>) :
                                        <tr>
                                            <td colSpan={5} class="px-6 py-2 text-center text-[15px] font-normal text-[#78818d]">
                                                <div className="flex flex-col items-center justify-center">
                                                    <svg width="64" height="41" viewBox="0 0 64 41" xmlns="http://www.w3.org/2000/svg">
                                                        <g transform="translate(0 1)" fill="none" fill-rule="evenodd">
                                                            <ellipse fill="#f5f5f5" cx="32" cy="33" rx="32" ry="7"></ellipse>
                                                            <g fill-rule="nonzero" stroke="#d9d9d9">
                                                                <path d="M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z"></path>
                                                                <path d="M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z" fill="#fafafa"></path>
                                                            </g>
                                                        </g>
                                                    </svg>
                                                    <span>No Data Found!</span>
                                                </div>
                                            </td>
                                        </tr>}
                                </tbody>
                            </table>
                        </div>}
                </div>
            )}
        </>
    );
}