import { useEffect, useState } from "react";
import { TaskLog } from "./utils/getjson";
import { FormatDate } from "./utils/NameInitials";

export const Moderationageing = () => {

    const [takedata, settakedata] = useState([{
        "id": '',
        "Maintask": "",
        "Subtask": "",
        "Status": '',
        "Taskname": "",
        "Assignee": "",
        "Datetime": "",
        "Priority": "",
        "Thread": ""
    }]);

    useEffect(() => {
        const fetchin = async () => {
            try {
                const response = await TaskLog();
                settakedata(response);
            } catch (error) {
                console.error('Error:', error);
            }
        }
        fetchin();
    }, [])

    return (
        <>
            <div className="p-4 py-6">
                <div>
                    <h1 className="font-bold text-gray-900 text-2xl">Moderation Ageing Report</h1>
                </div>
                <br />
                <div class="relative overflow-x-auto shadow-md sm:rounded-lg">
                    <table class="w-full text-sm text-left rtl:text-right text-gray-500 dark:text-gray-400">
                        <thead class="text-xs text-gray-700 uppercase bg-gray-50 dark:bg-gray-700 dark:text-gray-400 sticky top-0">
                            <tr>
                                <th scope="col" class="px-6 py-3">
                                    Maintask
                                </th>
                                <th scope="col" class="px-6 py-3">
                                    Subtask
                                </th>
                                <th scope="col" class="px-6 py-3">
                                    Taskname
                                </th>
                                <th scope="col" class="px-6 py-3">
                                    Status
                                </th>
                                <th scope="col" class="px-6 py-3">
                                    Assignee
                                </th>
                                <th scope="col" class="px-6 py-3">
                                    Datetime
                                </th>
                                <th scope="col" class="px-6 py-3">
                                    Priority
                                </th>
                            </tr>
                        </thead>
                        <tbody class="overflow-y-auto">
                            {takedata.map(item =>
                                <tr key={item.id} class="odd:bg-white odd:dark:bg-gray-900 even:bg-gray-50 even:dark:bg-gray-800 border-b dark:border-gray-700">
                                    <th scope="row" class="px-6 py-3 font-medium text-gray-900 whitespace-nowrap dark:text-white">
                                        {item.Maintask}
                                    </th>
                                    <td class="px-6 py-3">
                                        {item.Subtask == null ? '-' : item.Subtask}
                                    </td>
                                    <td class="px-6 py-3 cursor-pointer" Onclick="window.onbeforeunload = null;window.location.href = '/autonomous-level'">
                                        {item.Taskname}
                                    </td>
                                    <td class="px-6 py-3">
                                        {item.Assignee}
                                    </td>
                                    <td class="px-6 py-3 cursor-pointer" Onclick="window.onbeforeunload = null;window.location.href = '/autonomous-level'">
                                        {item.Status == 0 ?
                                            <div className="h-4 w-4 bg-slate-300 rounded-full"></div>
                                            : item.Status == 1 ?
                                                <div className="h-4 w-4 bg-violet-600 rounded-full"></div>
                                                : item.Status == 2 ?
                                                    <div className="h-4 w-4 bg-sky-600 rounded-full"></div>
                                                    : item.Status == 3 &&
                                                    <div className="h-4 w-4 bg-green-800 rounded-full"></div>}
                                    </td>
                                    <td class="px-6 py-3 cursor-pointer" Onclick="window.onbeforeunload = null;window.location.href = '/autonomous-level'">
                                        <FormatDate dateString={item.Datetime} />
                                    </td>
                                    <td class="px-6 py-3">
                                        {item.Priority}
                                    </td>
                                </tr>
                            )}
                        </tbody>
                    </table>
                </div>
            </div>
        </>
    );
}