import { List } from "antd";
import { FormatDate } from "./utils/NameInitials";
import { jsonvalues } from "./utils/getjson";
import { useEffect, useState } from "react";

export const Tableview = ({ id }) => {

    const [getdata, setgetdata] = useState([{
        "id": '',
        "Maintask": "",
        "Subtask": "",
        "Status": '',
        "Taskname": "",
        "Assignee": "",
        "Datetime": "",
        "Priority": ""
    }]);

    useEffect(() => {
        const fetchin = async (tag) => {
            try {
                const response = await jsonvalues(tag);
                console.log('response',response)
                setgetdata(response.data1);
            } catch (error) {
                console.error('Error:', error);
            }
        }
        fetchin(id);
    }, [id])


    return (
        <>
            <div class="relative overflow-x-auto">
                <table class="w-full text-sm text-left rtl:text-right text-gray-500">
                    <thead class="text-xs text-gray-700 uppercase bg-gray-50 dark:bg-gray-700">
                        <tr>
                            <th scope="col" class="px-6 py-2">
                                #
                            </th>
                            <th scope="col" class="px-6 py-2">
                                Name
                            </th>
                            <th scope="col" class="px-6 py-2">
                                Assignee
                            </th>
                            <th scope="col" class="px-6 py-2">
                                Status
                            </th>
                            <th scope="col" class="px-6 py-2">
                                Due date
                            </th>
                            <th scope="col" class="px-6 py-2">
                                Priority
                            </th>
                        </tr>
                    </thead>
                    <tbody>
                        {getdata.length > 0 && getdata[0].Taskname != '' ? getdata.map((item, i) =>
                            <tr key={item.id} class="bg-white border-b">
                                <td class="px-6 py-2">
                                    {i + 1}
                                </td>
                                <th scope="row" class="capitalize px-6 py-2 font-medium text-gray-900 whitespace-nowrap">
                                    {item.Taskname}
                                </th>
                                <td class="px-6 py-2">
                                    {item.Assignee}
                                </td>
                                <td class="px-6 py-2">
                                    {
                                        item.Status == 0 ?
                                         <div className="w-max h-6 px-3 pt-[1px] bg-gray-400 text-white rounded-[4px]">New</div>
                                          : item.Status == 1 ? 
                                          <div className="w-max h-6 px-3 pt-[1px] bg-indigo-600 text-white rounded-[4px]">IN progress</div>
                                          : item.Status == 2 ? 
                                          <div className="w-max h-6 px-3 pt-[1px] bg-[#1090e0] text-white rounded-[4px]">High Profile</div>
                                          : item.Status == 3 &&
                                          <div className="w-max h-6 px-3 pt-[1px] bg-[#084] text-white rounded-[4px]">Resolved</div>
                                          
                                    }
                                </td>
                                <td class="px-6 py-2">
                                    {item.Datetime != null ? <FormatDate dateString={item.Datetime} /> : '-'}
                                </td>
                                <td class="px-6 py-2 flex items-center gap-1">
                                    {
                                        item.Priority == 'Urgent' ?
                                            <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="#B13A41" className="w-5 h-5" viewBox="0 0 24 24">
                                                <path d="M19 4H6V2H4v18H3v2h4v-2H6v-5h13a1 1 0 0 0 1-1V5a1 1 0 0 0-1-1z"></path>
                                            </svg> : item.Priority == 'High' ?
                                                <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="#cf940a" className="w-5 h-5" viewBox="0 0 24 24">
                                                    <path d="M19 4H6V2H4v18H3v2h4v-2H6v-5h13a1 1 0 0 0 1-1V5a1 1 0 0 0-1-1z"></path>
                                                </svg> : item.Priority == 'Normal' ?
                                                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="#46f" className="w-5 h-5" viewBox="0 0 24 24">
                                                        <path d="M19 4H6V2H4v18H3v2h4v-2H6v-5h13a1 1 0 0 0 1-1V5a1 1 0 0 0-1-1z"></path>
                                                    </svg> : item.Priority == 'Low' ?
                                                        <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="#87909e" className="w-5 h-5" viewBox="0 0 24 24">
                                                            <path d="M19 4H6V2H4v18H3v2h4v-2H6v-5h13a1 1 0 0 0 1-1V5a1 1 0 0 0-1-1z"></path>
                                                        </svg> : <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-flag" viewBox="0 0 16 16">
                                                            <path d="M14.778.085A.5.5 0 0 1 15 .5V8a.5.5 0 0 1-.314.464L14.5 8l.186.464-.003.001-.006.003-.023.009a12 12 0 0 1-.397.15c-.264.095-.631.223-1.047.35-.816.252-1.879.523-2.71.523-.847 0-1.548-.28-2.158-.525l-.028-.01C7.68 8.71 7.14 8.5 6.5 8.5c-.7 0-1.638.23-2.437.477A20 20 0 0 0 3 9.342V15.5a.5.5 0 0 1-1 0V.5a.5.5 0 0 1 1 0v.282c.226-.079.496-.17.79-.26C4.606.272 5.67 0 6.5 0c.84 0 1.524.277 2.121.519l.043.018C9.286.788 9.828 1 10.5 1c.7 0 1.638-.23 2.437-.477a20 20 0 0 0 1.349-.476l.019-.007.004-.002h.001M14 1.221c-.22.078-.48.167-.766.255-.81.252-1.872.523-2.734.523-.886 0-1.592-.286-2.203-.534l-.008-.003C7.662 1.21 7.139 1 6.5 1c-.669 0-1.606.229-2.415.478A21 21 0 0 0 3 1.845v6.433c.22-.078.48-.167.766-.255C4.576 7.77 5.638 7.5 6.5 7.5c.847 0 1.548.28 2.158.525l.028.01C9.32 8.29 9.86 8.5 10.5 8.5c.668 0 1.606-.229 2.415-.478A21 21 0 0 0 14 7.655V1.222z" />
                                                        </svg>
                                    }
                                    <span>{item.Priority}</span>
                                </td>
                            </tr>) :
                            <tr>
                                <td colSpan={6} class="px-6 py-2 text-center">
                                    <List />
                                </td>
                            </tr>
                        }
                    </tbody>
                </table>
            </div>
        </>
    );
}