import { useEffect, useState } from "react";

export const Modelview = ({ show }) => {

    const [Comments, setComments] = useState(true);
    const [commentdata, setcommentdata] = useState(null);

    return (
        <>
            {show &&
                <div
                    className="fixed inset-0 z-[999] grid h-screen w-screen place-items-center bg-black bg-opacity-60 opacity-1 backdrop-blur-sm transition-opacity duration-300">
                    <div data-dialog="dialog-xl"
                        className="relative m-4 w-3/4 min-w-[75%] max-w-[75%] overflow-hidden h-[36rem] rounded-lg bg-white font-sans text-base font-light leading-relaxed text-blue-gray-500 antialiased shadow-2xl">
                        <div className="flex items-center justify-between p-4 border-b font-sans text-2xl antialiased font-semibold leading-snug shrink-0 text-blue-gray-900">
                            <ul className="text-[14px] flex items-center gap-2 font-normal tracking-[.8px]">
                                <li>
                                    <div className="text-xs bg-pink-200 h-6 w-6 rounded-[4px] flex items-center justify-center">S</div>
                                </li>
                                <li>Smart-Hub</li>
                                <li>/</li>
                                <li>Commentary</li>
                            </ul>
                            <svg onClick={handleClose} xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-x-lg cursor-pointer " viewBox="0 0 16 16">
                                <path d="M2.146 2.854a.5.5 0 1 1 .708-.708L8 7.293l5.146-5.147a.5.5 0 0 1 .708.708L8.707 8l5.147 5.146a.5.5 0 0 1-.708.708L8 8.707l-5.146 5.147a.5.5 0 0 1-.708-.708L7.293 8z" />
                            </svg>
                        </div>
                        <div className="flex items-start h-[32rem]">
                            <div className="w-[60%] border-r h-full">
                                <div
                                    className="flex items-center p-4 w-full font-sans text-2xl antialiased font-semibold leading-snug shrink-0 text-blue-gray-900">
                                    Commentary
                                </div>
                                <div
                                    className="relative p-4  font-sans text-base text-[#656f7d] antialiased font-light leading-relaxed border-t-blue-gray-100 border-b-blue-gray-100 text-blue-gray-500">
                                    <ul className="w-1/2 space-y-4 font-normal tracking-[1px]">
                                        <li className="flex items-center justify-between">
                                            <div className="flex items-center gap-1">
                                                <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 24 24" fill="#656f7d"><path d="M12 2a10 10 0 1 0 10 10A10 10 0 0 0 12 2zm0 18a8 8 0 1 1 8-8 8 8 0 0 1-8 8z"></path><path d="M12 8a4 4 0 1 0 4 4 4 4 0 0 0-4-4zm0 6a2 2 0 1 1 2-2 2 2 0 0 1-2 2z"></path></svg>
                                                <span className="text-[14px]">Status</span>
                                            </div>
                                            <div className="uppercase text-sm w-max px-2 py-1 rounded-lg bg-[#5f55ee] text-white font-normal">in progress</div>
                                        </li>
                                        <li className="flex items-center justify-between">
                                            <div className="flex items-center gap-1">
                                                <svg xmlns="http://www.w3.org/2000/svg" width="20" fill="currentColor" height="20" viewBox="0 0 24 24">
                                                    <path d="M3 6v14a2 2 0 0 0 2 2h14a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2h-2V2h-2v2H9V2H7v2H5a2 2 0 0 0-2 2zm16 14H5V8h14z"></path>
                                                </svg>
                                                <span className="text-[14px]">Dates</span>
                                            </div>
                                            <span>Empty</span>
                                        </li>
                                        <li className="flex items-center justify-between">
                                            <div className="flex items-center gap-1">
                                                <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" fill="currentColor" class="bi bi-person" viewBox="0 0 16 16">
                                                    <path d="M8 8a3 3 0 1 0 0-6 3 3 0 0 0 0 6m2-3a2 2 0 1 1-4 0 2 2 0 0 1 4 0m4 8c0 1-1 1-1 1H3s-1 0-1-1 1-4 6-4 6 3 6 4m-1-.004c-.001-.246-.154-.986-.832-1.664C11.516 10.68 10.289 10 8 10s-3.516.68-4.168 1.332c-.678.678-.83 1.418-.832 1.664z" />
                                                </svg>
                                                <span className="text-[14px]">Assignee</span>
                                            </div>
                                            <span>Empty</span>
                                        </li>
                                        <li className="flex items-center justify-between">
                                            <div className="flex items-center gap-1">
                                                <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 24 24" fill="currentColor"><path d="M19 4H6V2H4v18H3v2h4v-2H6v-5h13a1 1 0 0 0 1-1V5a1 1 0 0 0-1-1zm-1 9H6V6h12v7z"></path></svg>
                                                <span className="text-[14px]">Priority</span>
                                            </div>
                                            <span>Empty</span>
                                        </li>
                                    </ul>
                                    <div className="w-1/4"></div>
                                </div>
                            </div>
                            <div className="w-[40%] h-full relative">
                                <div className="border-b flex items-center justify-between px-4">
                                    <div className="tracking-[.8px] flex items-center p-4 font-sans text-xl antialiased font-medium leading-snug shrink-0 text-blue-gray-900">
                                        Activity
                                    </div>
                                    <div className="flex items-center gap-3 text-[#656f7d]">
                                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-search cursor-pointer" viewBox="0 0 16 16">
                                            <path d="M11.742 10.344a6.5 6.5 0 1 0-1.397 1.398h-.001q.044.06.098.115l3.85 3.85a1 1 0 0 0 1.415-1.414l-3.85-3.85a1 1 0 0 0-.115-.1zM12 6.5a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0" />
                                        </svg>
                                        <svg xmlns="http://www.w3.org/2000/svg" width="18" height="18" fill="currentColor" class="bi bi-filter cursor-pointer" viewBox="0 0 16 16">
                                            <path d="M6 10.5a.5.5 0 0 1 .5-.5h3a.5.5 0 0 1 0 1h-3a.5.5 0 0 1-.5-.5m-2-3a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5m-2-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5" />
                                        </svg>
                                    </div>
                                </div>
                                <div className="h-96 overflow-y-auto p-2">
                                    <div className="relative">
                                        <div className="border w-full h-auto rounded-lg p-4 space-y-2">
                                            <div className="flex items-center justify-between">
                                                <div className="flex items-center gap-2">
                                                    <div className="h-8 w-8 rounded-full bg-yellow-500 uppercase flex items-center justify-center text-white">j</div>
                                                    <span className="font-normal">You</span>
                                                </div>
                                                <span className="text-sm font-normal">59 min</span>
                                            </div>
                                            <p className="font-normal">Utilities for controlling how an element is positioned in the DOM.</p>
                                        </div>
                                        <div className="absolute -bottom-4 left-3 h-8 w-max px-2 gap-2 rounded-full bg-white border flex items-center justify-center cursor-pointer">
                                            <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-hand-thumbs-up" viewBox="0 0 16 16">
                                                <path d="M8.864.046C7.908-.193 7.02.53 6.956 1.466c-.072 1.051-.23 2.016-.428 2.59-.125.36-.479 1.013-1.04 1.639-.557.623-1.282 1.178-2.131 1.41C2.685 7.288 2 7.87 2 8.72v4.001c0 .845.682 1.464 1.448 1.545 1.07.114 1.564.415 2.068.723l.048.03c.272.165.578.348.97.484.397.136.861.217 1.466.217h3.5c.937 0 1.599-.477 1.934-1.064a1.86 1.86 0 0 0 .254-.912c0-.152-.023-.312-.077-.464.201-.263.38-.578.488-.901.11-.33.172-.762.004-1.149.069-.13.12-.269.159-.403.077-.27.113-.568.113-.857 0-.288-.036-.585-.113-.856a2 2 0 0 0-.138-.362 1.9 1.9 0 0 0 .234-1.734c-.206-.592-.682-1.1-1.2-1.272-.847-.282-1.803-.276-2.516-.211a10 10 0 0 0-.443.05 9.4 9.4 0 0 0-.062-4.509A1.38 1.38 0 0 0 9.125.111zM11.5 14.721H8c-.51 0-.863-.069-1.14-.164-.281-.097-.506-.228-.776-.393l-.04-.024c-.555-.339-1.198-.731-2.49-.868-.333-.036-.554-.29-.554-.55V8.72c0-.254.226-.543.62-.65 1.095-.3 1.977-.996 2.614-1.708.635-.71 1.064-1.475 1.238-1.978.243-.7.407-1.768.482-2.85.025-.362.36-.594.667-.518l.262.066c.16.04.258.143.288.255a8.34 8.34 0 0 1-.145 4.725.5.5 0 0 0 .595.644l.003-.001.014-.003.058-.014a9 9 0 0 1 1.036-.157c.663-.06 1.457-.054 2.11.164.175.058.45.3.57.65.107.308.087.67-.266 1.022l-.353.353.353.354c.043.043.105.141.154.315.048.167.075.37.075.581 0 .212-.027.414-.075.582-.05.174-.111.272-.154.315l-.353.353.353.354c.047.047.109.177.005.488a2.2 2.2 0 0 1-.505.805l-.353.353.353.354c.006.005.041.05.041.17a.9.9 0 0 1-.121.416c-.165.288-.503.56-1.066.56z" />
                                            </svg>
                                            <span>1</span>
                                        </div>
                                    </div>
                                </div>
                                <div className="w-full p-2 absolute bottom-0">
                                    <div className="w-full border border flex justify-between p-1 rounded-lg relative">
                                        <input type="text" className="outline-none px-4 w-full tracking-[.6px] font-normal" onChange={(e) => setcommentdata(e.target.value)} onFocus={() => setComments(!Comments)} placeholder="Commnet or type ..." />
                                        <button className="px-4 py-1.5 rounded-lg bg-emerald-600 text-white font-normal" disabled={Comments} onClick={hundlemy}>Send</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>}
        </>
    );
}