export const getNameInitials = (fullName) => {
    const nameArray = fullName.split(" ");
    const firstNameInitial = nameArray[0]?.charAt(0) || '';
    const lastNameInitial = nameArray[nameArray.length - 1]?.charAt(0) || '';
    return { firstNameInitial, lastNameInitial };
  };
  
  export default function NameInitials({ fullName }) {
    const { firstNameInitial, lastNameInitial } = getNameInitials(fullName);
  
    return (
      <div>
        {firstNameInitial}{lastNameInitial}
      </div>
    );
  }

export const TruncateEmail = ({email}) => {
  if (email.length <= 20) {
    return email;
  } else {
    return email.substring(0, 20) + "...";
  }
};


export const GetRandomColor = () => {
  // Generate random hex value
  const color = Math.floor(Math.random() * 16777215).toString(16);
  // Pad with zeros to ensure 6 digits
  return "#" + "0".repeat(6 - color.length) + color;
}

export const FormatDate = ({dateString}) => {
  const date = new Date(dateString);
  const formattedDate = new Intl.DateTimeFormat('en-US', { month: 'short', day: 'numeric' }).format(date);
  const formattedTime = date.toTimeString().split(' ')[0];
  return (<>{formattedDate} <br /> {formattedTime}</>);
};


