<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="https://code.jquery.com/jquery-3.6.4.min.js"></script>
    <link rel="stylesheet" href="{{ asset('header/header.css') }}">
    <script src="https://cdn.tailwindcss.com"></script>
    <link rel="shortcut icon" href="{{ asset('images/favicon.png') }}">
    <title>Smarthub - RN</title>

    <style>
        body {
            font-family: Roboto, RobotoDraft, Helvetica, Arial, sans-serif !important;
            background-color: #efebf8;
        }

        .pad {
            padding: 5px 20px;
        }

        a {
            // text-decoration: none;
        }

        p {
            text-align: justify;
            font-size: 15px;
            font-family: system-ui
        }

        input:focus-visible {
            border: none;
            outline: none;
        }

        input[type="radio"] {
            width: 18px;
            height: 18px;
            filter: hue-rotate(45deg);
            cursor: pointer;
        }

        .uncheck_btn {
            float: right;
            margin: 20px 0;
            background: none;
            border: none;
            padding: 10px;
            border-radius: 7px;
            display: none;
        }

        .uncheck_btn:hover {
            background: #f0f0f0;
        }

        .success {
            background-color: #5a39b6;
            color: #fff;
            padding: 10px 25px;
            border-radius: 5px;
            border: none;
            filter: drop-shadow(0px 2px 2px black);
        }

        .top_bg {
            background-image: url('https://lh3.googleusercontent.com/Jg3rln27XCF4HGH6FhtZIPAk_nD5F_3s8gH4XUX0JhpUYvWOsBlfQ3XrK00MwXQz7mj8KcwdveGiPIkXbniwaeY6zhfyJ6dyAxtsENyeeYNFWNHWUB1XEO2iO_80AIohKA=w2496');
            background-size: cover;
            max-height: 23vw;
            max-width: 90vw;
            height: 160px;
            width: 640px;
            border-radius: 8px;
        }

        .cont1 {
            background-color: #fff;
            border: 1px solid #dfdfdf;
            border-radius: 10px;
            margin-top: 12px;
            border-top: 11px solid rgb(90, 57, 182);
        }

        .cont2 {
            background-color: #fff;
            border: 1px solid #dfdfdf;
            border-radius: 10px;
            margin-top: 12px;
            overflow: hidden;
        }

        .btn {
            background: #f0eaf8;
            color: rgb(90, 57, 182);
            padding: 10px 25px;
            border-radius: 5px;
            border: none;
            filter: drop-shadow(0px 2px 2px black);
            cursor: pointer;
        }

        select {
            cursor: pointer !important;
        }

        #form3,
        #form2,
        #form2nd,
        #form3rd,
        #success {
            display: none;
        }

        .headings p {
            margin: auto 0;
            font-weight: 400;
        }

        .headings div {
            height: 40px;
        }


        .badge_right_menu {
            color: white;
            transform: scale(1.8);
            line-height: normal;
            width: 6rem;
            margin-left: 34px;
        }

        .badge_right_menu ion-icon {
            cursor: pointer;
        }

        .top_user_inert {
            display: none;
            position: fixed;
            background-color: #fff;
            border: 1px solid #ccc;
            padding: 22px;
            /* max-width: 400px; */
            box-shadow: 0px 5px 10px rgba(0, 0, 0, 0.2);
            z-index: 99;
            /* width: max-content; */
            width: 25rem;
            border-radius: 8px;
            right: 2.5rem;
            top: 4.5rem;
        }

        .top_user_open {
            display: block;
            animation: slideDown 0.3s ease-in-out;
        }

        .top_user_inert .user_head {
            display: flex;
        }

        .top_user_inert .user_head .logout_head {
            width: 20%;
            display: flex;
            justify-content: end;
        }

        .top_user_inert .user_head .logout_head ion-icon {
            height: 24px;
            width: 24px;
            cursor: pointer;
        }

        .top_user_inert .split_head {
            // width: 80%;
            width: 100%;
            display: flex;
            height: 70px;
        }

        .top_user_inert .user_head .split_head div {
            /*            width: 19%;*/
            margin-right: 14px;
            position: relative;
        }

        .top_user_inert .user_head .split_head div img {
            width: 100% !important;
        }

        .top_user_inert .user_head .split_head div p {
            margin: 1px;
            font-weight: 700;
            margin-bottom: 0;
        }

        .top_user_inert .user_head .split_head div .unqiue {
            font-size: 11px;
            color: #7e7e7e;
        }

        .top_user_inert .user_head .split_head div .sub_time {
            font-size: 11px;
            background: #0080002e;
            padding: 2px 9px;
            border-radius: 31px;
            color: green;
            width: max-content;
        }

        .top_user_inert .user_body {
            padding: 1.5rem 0rem 1rem 0;
            position: relative;
            /* height: 200px;
            overflow-x: auto; */
        }

        .top_user_inert .user_body .out_of_card_first {
            padding: 1rem;
            border: 1px solid #dfdfdf;
            border-radius: 8px;
            display: flex;
            justify-content: space-between;
        }

        .top_user_inert .user_body .out_of_card_first ion-icon {
            /*            transform: scale(2);*/
        }

        .top_user_inert .user_head .split_head div .status_res {
            height: 14px;
            width: 14px;
            background: green;
            border: 2px solid #fff;
            border-radius: 50%;
            position: absolute;
            right: -8px;
            bottom: 5px;
            /* cursor: pointer; */
        }

        /* .top_user_inert .user_head .split_head div .status_res:hover {
        background-color: #bbb !important;
    } */

        /* .top_user_inert .user_head .split_head div .status_res:hover::before {
        content: "^";
        display: flex;
        align-items: center;
        justify-content: center;
        margin: -10px 0 0;
        transform: rotate(180deg);
    } */

        .top_user_inert .user_head .split_head .popup_status {
            position: absolute;
            height: max-content;
            width: 5rem;
            background: #fff;
            border-radius: 4px;
            top: 74px;
            left: 71px;
            z-index: 9999;
            border: 1px solid #ddd;
            display: none;
            box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
        }

        .top_user_inert .user_head .split_head .popup_status p {
            font-size: small;
            font-weight: 400;
            text-align: center;
            display: flex;
            justify-content: space-around;
            padding: 4px;
            margin: 0;
            cursor: pointer;
        }

        .top_user_inert .user_head .split_head .popup_status p:hover {
            background-color: #ddd;
        }

        .top_user_inert .user_head .split_head div .status_res div {
            border: 3px solid #fff;
            border-radius: 50%;
            position: relative;
            right: -2px;
            bottom: -2px;
            display: none;
        }

        .top_user_inert .user_body .dont_dis_card_sec {
            padding: 1rem;
            border: 1px solid #dfdfdf;
            border-radius: 8px;
            display: flex;
            justify-content: space-between;
            margin-top: 8px;
        }

        .top_user_inert .user_body .dont_dis_card_sec .moon_circle_in {
            background: #ff9a03;
            padding: 2px;
            border: 2px solid #ff9a03;
            display: flex;
            align-items: center;
            border-radius: 50%;
            height: 26px;
            width: 26px;
            position: relative;
        }

        /*    .top_user_inert .user_body .dont_dis_card_sec .moon_circle_in div {
            border-right: 2px solid;
            height: 1.3rem;
            transform: rotate(-45deg);
            position: absolute;
            left: 10px;
            border-color: #000000;
            top: 1px;
        }*/
        .top_user_inert .user_body .dont_dis_card_sec .moon_circle_in span {
            background: white;
            width: 2px;
            height: 21px;
            transform: rotate(-45deg);
            position: absolute;
            left: 9px;
            top: 1px;
            border: 1px solid #ff9a03;
            padding-right: 2px;
            display: none;
            border-bottom: none;
            border-top: none;
            border-radius: 11px;
        }

        .top_user_inert .option_out {
            display: flex;
            justify-content: end;
        }

        .top_user_inert .option_out .logout_outline {
            display: flex;
            align-items: center;
            gap: 2px;
            cursor: pointer;
        }

        .top_user_inert .option_out .logout_outline ion-icon {
            color: black;
            transform: scale(1.2);
        }

        .top_user_inert .option_out .logout_outline span {
            color: black;
        }

        .top_user_inert .user_body .schedule_timeset {
            padding: 1rem;
            border: 1px solid #dfdfdf;
            border-radius: 8px;
            display: flex;
            justify-content: space-between;
            margin-top: 8px;
        }

        .top_user_inert .user_body .schedule_timeset .moon_circle_in {
            background: #ff9a03;
            padding: 3px;
            border: 2px solid #ff9a03;
            display: flex;
            align-items: center;
            border-radius: 50%;
            height: 26px;
            width: 26px;
            justify-content: center;
            position: relative;
        }

        .top_user_inert .user_body .schedule_timeset .moon_circle_in #jUF221fvd {
            height: 8px;
            width: 8px;
            position: absolute;
            background: #ff9a03;
            display: flex;
            justify-content: center;
            border-radius: 50%;
            align-items: center;
            color: white;
            top: 1px;
            left: 13px;
            font-size: 8px;
        }

        .top_user_inert .user_body .schedule_timeset .moon_circle_in img {
            width: 18px;
            height: 24px;
        }

        .top_user_inert .user_body .schedule_timeset input {
            background: #cfcfcf47;
            border: none;
            border-radius: 7px;
            width: 44%;
            color: #212121;
            font-size: small;
            padding: 3px;
            font-size: 12px;
        }

        .top_user_inert .user_body .schedule_timeset span {
            font-size: 12px;
            padding: 0 2px;
        }

        /* switch */
        .user_head_uni_switch .bell_switch {
            position: relative;
            display: inline-block;
            width: 36px;
            /*            height: 22px;*/
            height: 29px;
        }

        .user_head_uni_switch .bell_switch input {
            display: none;
        }

        .user_head_uni_switch .bell_switch label {
            position: absolute;
            top: 0;
            left: 0;
            right: 0;
            bottom: 0;
            background-color: #ccc;
            border-radius: 34px;
            cursor: pointer;
            transition: background-color 0.3s;
            margin-bottom: 0.5rem;
        }

        .user_head_uni_switch .bell_switch input:checked+label {
            background-color: #2196F3;
        }

        .user_head_uni_switch .bell_switch label:before {
            position: absolute;
            content: "";
            height: 13px;
            width: 13px;
            left: 4px;
            bottom: 4px;
            background-color: white;
            border-radius: 50%;
            transition: transform 0.3s;
        }

        .user_head_uni_switch .bell_switch input:checked+label:before {
            transform: translateX(16px);
        }

        .top_user_inert .user_head .split_head div .sub_time {
            display: block;
        }

        .top_user_inert .user_head .split_head div .sub_time_do {
            // padding: 2px 9px;
            // border-radius: 31px;
            // font-size: 11px;
            // background: #ff9a033d;
            // color: #ff9a03;
            // width: max-content;
            display: none;
        }

        .top_user_inert .user_head .split_head div .sub_time_out {
            // padding: 2px 9px;
            // border-radius: 31px;
            // font-size: 11px;
            // background: #ffc4c4;
            // color: #ff4e4e;
            // width: max-content;
            display: none;
        }

        .admin_box {
            display: none;
        }

        .shareUPCDropdown {
            display: block;
            background: #f0eeee;
            padding: 0 10px;
            border-radius: 0 0 10px 0;
        }

        .shareUPCDropdown .dropdown-item {
            padding: 2px;
            border-bottom: 1px solid #ccc;
        }

        .shareUPCDropdown .dropdown-item:last-child {
            padding: 2px;
            border-bottom: 0;
        }
    </style>
    <style>
        .error-message {
            color: red;
            font-size: 14px;
        }
    </style>
    <script src="https://code.jquery.com/jquery-3.6.4.min.js"></script>
    <script>
        function success() {
            let valid = true;
            const userIdInputs = document.querySelectorAll('input[name="shareUPC[]"]');
            const userNameInputs = document.querySelectorAll('input[name="sharename[]"]');
            const percentageInputs = document.querySelectorAll('input[name="percentage[]"]');
            const upcSelect = document.getElementById('upcInput');
            const isrcSelect = document.getElementById('isrc');

            // Check if UPC is selected
            if (upcSelect.value === '') {
                alert('Please select a UPC.');
                valid = false;
            }

            // Check if ISRC is selected
            // if (isrcSelect.value === '') {
            //     alert('Please select an ISRC.');
            //     valid = false;
            // }
            /* if($('#click1').val() != '1'){
                alert(`Click add and choose userid,usernameand percentage`);
                        valid = false;
            } */
            // Validate UserID and UserName fields
            userIdInputs.forEach((input, index) => {
                if (input.value.trim() === '') {
                    alert(`UserID field ${index + 1} is required.`);
                    valid = false;
                }
                if (userNameInputs[index].value.trim() === '') {
                    alert(`UserName field ${index + 1} is required.`);
                    valid = false;
                }
            });

            // Validate Percentage fields
            percentageInputs.forEach((input) => {
                if (input.value.trim() === '' || isNaN(input.value) || parseFloat(input.value) <= 0) {
                    alert('Percentage field is required.');
                    valid = false;
                }
            });


            return valid;
        }
    </script>

</head>

<body>
    <div class="main_container">
        <div class="header_container">
            <div>
                <div
                    style="display:none;position: fixed;right: 4%;bottom: 12%;z-index: 11;height:70%;width:18%;background-color:#fff;border-radius: 12px;box-shadow: 0px 0px 9px 3px #dddddd42;">
                    <div
                        style="height: 4rem;background-color:#124dfe;border-radius: 12px 12px 0 0;display: flex;padding-left: 12px;align-items: center;justify-content: space-between;">
                        <div style="background: #fff;padding: 10px;display: flex;border-radius: 50%;">
                            <img src="{{ asset('images/robot.svg') }}" alt="logo"
                                style="height: 24px;width: 24px;" />
                        </div>
                    </div>
                    <div>
                        bottom
                    </div>
                </div>

                <div class="s_navigation">
                    <div class="select-none p-4">
                        <a href="/dashboard" id="max-logo" class="flex items-center gap-2">
                            <img src="https://smarthub.rn-test.com/images/rn-logo-white.svg" alt="routenote-logo">
                            <div class="w-full flex flex-col items-end">
                                <h3 class="font-medium text-xl font-sans !text-white">Smart Hub</h3>
                                <span class="font-sans text-[9px] font-medium text-red-500">Powered by AI</span>
                            </div>
                        </a>
                        <div class="headflex hidden" id="min-logo">
                            <a href="/dashboard">
                                <img src="https://smarthub.rn-test.com/images/rn-logo-white.svg" alt="routenote-logo" style="height: 52px;">
                            </a>
                        </div>
                    </div>

                    <div class="flex notification">
                        <div class="notification2">
                            <i class="fa fa-bell bell-img" style="font-size:24px;color:white;" id="bellon_1"></i>
                            <i class="fa fa-bell-slash fa-ban" id="belloff_1"
                                style="font-size:24px;color:white; display:none;"></i>
                            <!--span class="badge" id="badge"><?php //echo count(json_decode($fetc_value));
                            ?></span-->

                            <div class="dropdown-content1 notificationflow" id="dropdownContent">
                                <div class="notify_head">
                                    <h5 class="noti_title" id="noti_title" style="display:none;">Notifications</h5>
                                    <h5 class="noti_title" id="noti_title_" style="display:none;">No notification
                                        found..!</h5>
                                    <div class="close-icon"></div>
                                </div>
                            </div>
                        </div>

                        <div class="top_user_inert" id="user_dropdownContent">
                            <div class="user_head">
                                <div class="split_head">
                                    <div style="width: 22%;"><img src="{{ asset('images/user.svg') }}"
                                            style="width: 18%;">
                                        <div class="status_res" id="status_res" onclick="status_mal_change()">
                                            <div id="offline_status"></div>
                                        </div>
                                    </div>

                                    <div class="popup_status">
                                        <p onclick="getstatus(this)" data-value="0"><span>
                                                <ion-icon name="checkmark-outline" id="Active0"></ion-icon>
                                            </span>Active</p>
                                        <p onclick="getstatus(this)" data-value="1"><span>
                                                <ion-icon name="checkmark-outline" id="Away1"
                                                    style="visibility: hidden;">
                                                </ion-icon>
                                            </span>Away</p>
                                    </div>
                                    <div>
                                        <p><?php //echo ucfirst($_SESSION["User"]);
                                        ?></p>
                                        <div class="unqiue">@<?php //echo ucfirst($_SESSION["Username"]);
                                        ?></div>
                                        <div style="display:flex;">

                                            <div class="sub_time">Available until <span id="user_time_zon"></span></div>
                                            <div class="sub_time_out"><img
                                                    src="{{ asset('images/notifications-off-circle-outline.svg') }}"
                                                    style="width: 24px !important;height: 32px;margin-right: -10px;">
                                            </div>
                                            <div class="sub_time_do"><img
                                                    src="{{ asset('images/dash-circle-fill.svg') }}"
                                                    style="width: 20.3px!important;height: 26px;margin-top: 2.5px;">
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="logout_head">
                                    <ion-icon name="log-out-outline"
                                        Onclick="window.onbeforeunload = null;window.location.href = '<?php //echo $site_url;
                                        ?>/login?action=login&user=<?php //echo $_SESSION["User_id"];
                                        ?>'">
                                    </ion-icon>
                                </div>
                            </div>
                            <div class="user_body">
                                <div class="out_of_card_first">
                                    <!-- <ion-icon id="notify_on_outline" name="notifications-circle-outline" style="display: none;"></ion-icon> -->
                                    <!-- <ion-icon id="notify_off_outline" name="notifications-off-circle-outline" ></ion-icon> -->
                                    <img src="{{ asset('images/notifications-circle-outline.svg') }}"
                                        id="notify_on_outline" style="width: 32px;height: 32px;">

                                    <img src="{{ asset('images/notifications-off-circle-outline.svg') }}"
                                        id="notify_off_outline" style="display: none;width: 32px;height: 32px;">
                                    <div style="width: 71%;margin-top: -7px;">
                                        <div style="font-weight: 600;">Out of office</div>
                                        <div style="font-size: small;">Mute notifications and unassign new messages
                                        </div>
                                    </div>
                                    <div class="user_head_uni_switch">
                                        <div class="bell_switch">
                                            <input type="checkbox" id="autosuggest_0" onclick="bell_circle(this)"
                                                <?php //if( $sql_status_check_result['schedule_act'] == 1) {echo "disabled";}
                                                ?>>
                                            <label for="autosuggest_0"></label>
                                        </div>
                                    </div>
                                </div>
                                <div class="dont_dis_card_sec">
                                    <div style="display: flex;gap: 17px;">
                                        <div class="moon_circle_in">
                                            <!-- <box-icon name='moon' style="display: none;"></box-icon> -->
                                            <box-icon name='moon' type='solid' color="#fff"
                                                id="JHTVhfgd56"></box-icon>
                                            <span id="vgFCTUT34"></span>
                                            <!-- <div><span></span></div> -->
                                        </div>
                                        <div style="margin-top: -7px;">
                                            <div style="font-weight: 600;">Do not disturb</div>
                                            <div style="font-size: small;">Mute notifications</div>
                                        </div>
                                    </div>
                                    <div class="user_head_uni_switch">
                                        <div class="bell_switch">
                                            <input type="checkbox" id="autosuggest_1" onclick="moon_circle(this)"
                                                <?php //if( $sql_status_check_result['schedule_act'] == 1) {echo "disabled";}
                                                ?>>
                                            <label for="autosuggest_1"></label>
                                        </div>
                                    </div>
                                </div>
                                <div class="schedule_timeset">
                                    <div style="display: flex;justify-content: space-between;width: 100%;">
                                        <div style="display: flex;gap: 17px;width: 80%;">
                                            <div class="moon_circle_in"><img
                                                    src="{{ asset('images/time-outline.svg') }}" /><span
                                                    id="jUF221fvd">z</span></div>
                                            <div style="width: inherit;">
                                                <div style="font-weight: 600;">Schedule</div>
                                                <div style="width: max-content;display: initial;">
                                                    <input type="time" id="starttime_sche" name="time"
                                                        value="<?php //echo $sche_HJjk2[0];
                                                        ?>">
                                                    <span> to </span>
                                                    <input type="time" id="endtime_sche" name="time"
                                                        value="<?php //echo $sche_HJjk2[1];
                                                        ?>">
                                                </div>
                                            </div>
                                        </div>
                                        <div class="user_head_uni_switch">
                                            <div class="bell_switch">
                                                <input type="checkbox" id="autosuggest_2"
                                                    onclick="sche_circle(this)">
                                                <label for="autosuggest_2"></label>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                        </div>
                        <div class="badge_right_menu flex items-center justify-center" id="badge_right_menu" style="position: relative;"><span
                                style="font-size: 7px;">
                                {{ $users->name }}
                            </span>
                            <a href="{{ route('formlogout', ['key' => $key, 'name' => 'revenueshareforms']) }}"><img
                                    onclick="toggleAdminBox()" class="user_admin"
                                    src="{{ asset('images/PNG Login Logout White Icon.jpeg') }}"
                                    name="person-circle-outline"
                                    style=" color:#fff;width: 16px;position: relative;left: 1px;"></a>
                        </div>

                    </div>


                </div>

            </div>
        </div>

    </div>

    <div class="full_container_start" style="width: 100%;padding: 20px;overflow: scroll;height: 80vh;">
        <div style="justify-content: center;display: grid;">
            <div style="width: 640px;">
                @if (session('success'))
                    <div class="top_bg">
                    </div>

                    <div>
                        <br>
                        <div style="left: 287px;position: relative;">
                            <img src="{{ asset('images/tick.png') }}" style="width: 81px; height: 81px;">
                        </div>

                        <h2 style="font-weight: 600;left: 59px;position: relative;font-size: x-large;"> {{ session('success') }}</h2>
                        <div>
                            <br>
                        @elseif($data == '0')
                            <div class="top_bg">
                            </div>

                            <div>
                                <br>
                                <div style="left: 287px;position: relative;">
                                    <img src="{{ asset('images/tick.png') }}" style="width: 81px; height: 81px;">
                                </div>

                                <h2 class="" style="font-weight: 600;left: 59px;position: relative;font-size: x-large;"> Thanks for submitting your revenue sharing request! This has been received successfully and you will be contacted via email soon with any updates.
                                </h2>
                                <div>
                                    <br>
                                @else
                                    <div class="top_bg">
                                    </div>
                                    <form id="myForm" action="{{ route('revenueformsubmit') }}" method="GET"
                                        onsubmit="return success()">
                                        @csrf
                                        <div id="form1">
                                            <div class="cont1 space-y-2">
                                                <div class="pad space-y-4">
                                                    <h1 class="text-2xl font-semibold mt-3">Revenue Share Request Form
                                                    </h1>
                                                    <p>The percentage share of your release will depend on the distribution plan you have selected. For free releases, the account holder will automatically get 85% of total earnings, while Premium releases will get 100%. Account holders are able to split their percentages between multiple parties using this revenue share request form.
                                                        The 20th of the month cut-off for when revenue shares will be applied to the the following months received earnings to earnings.</p>


                                                </div>


                                                <hr>
                                                <div class="pad">
                                                    <span style="color: red">* Indicates required question</span>
                                                </div>
                                            </div>

                                            <div class="cont2" style="padding: 25px;">

                                                <div>
                                                    <p>Email <span style="color: red">*</span></p>
                                                    <input type="hidden" name="email1"
                                                        value="{{$users->mail}}"> <input type="hidden" name="key"
                                                        value="{{$key}}">
                                                    <input type="text" disabled name="email" id="email"
                                                        class="" placeholder=" Your Answer"
                                                        style="border: none; border-bottom: 1px solid #c7bebe;padding: 10px;"
                                                        value="{{ $users->mail }}">
                                                </div>
                                                <div id="email-error"></div>
<br>
                                                <div>
                                                    <p>User ID <span style="color: red">*</span></p><input
                                                        type="hidden" name="userid" value="{{ $users->uid }}">

                                                    <input type="text" disabled class=""
                                                        placeholder=" Your Answer"
                                                        style="border: none; border-bottom: 1px solid #c7bebe;padding: 10px;"
                                                        value="{{ $users->uid }}">
                                                </div>
                                                <div id="email-error"></div>
                                                <br>
                                                <div>
                                                    <p>User Name
                                                        <span style="color: red">*</span>
                                                    </p>

                                                    <input type="hidden" name="username1"
                                                        value="{{$users->name}}">
                                                    <input type="text" disabled name="username" id="username"
                                                        class="" placeholder=" Your Answer"
                                                        style="border: none; border-bottom: 1px solid #c7bebe;padding: 10px;"
                                                        value=" {{$users->name}}">
                                                </div>
                                                <div id="username-error"></div>
                                                <br>
                                                <div class="cont2" style="padding: 25px 10px 0 0;border: none;"
                                                    id="input_fields_container">

                                                    <input type="hidden" id="click">
                                                    <input type="hidden" name="addupcdetails" value="">

                                                    <div id="input_fields_container">
                                                        <input type="hidden" name="hid-vls" id="hid-vls" value="">

                                                        {{-- <div class="space-y-8">
                                                            <div class="flex items-center gap-4">
                                                                <div class="flex items-center">
                                                                    <span>Add UPC</span>
                                                                    <span style="color: red">*</span>
                                                                    <img src="{{ asset('images/add_circle_outline.svg') }}"
                                                                        onclick="addTextField()" alt="add"
                                                                        class="add_img">
                                                                </div>
                                                                <div class="flex flex-col relative">
                                                                    <label>UPC</label>
                                                                    <input type="text" id="upcInput0"
                                                                        placeholder="Start typing UPC" onchange="generateJSON(0)"
                                                                        oninput="filterOptions(0)" autocomplete="off"
                                                                        class="select_btn input-field0">
                                                                        <div id="optionsContainer0" class="options-container top-16"></div>
                                                                </div>
                                                                <div class="flex flex-col">
                                                                    <label>ISRC</label>
                                                                    <select name="isrc" id="isrc0" onchange="generateJSON(0)"
                                                                        class="select_btn input-field0"></select>
                                                                </div>
                                                            </div>
                                                            <div class="space-y-4">
                                                                <div class="flex items-center">
                                                                    <span>Revenue Share To </span>
                                                                    <span style="color: red">*</span>
                                                                    <img src="{{ asset('images/add_circle_outline.svg') }}"
                                                                        onclick="addMoreFields(0)" alt="add"
                                                                        class="add_img">
                                                                </div>
                                                                <div class="input-group mb-3">
                                                                    <div class="user_detailss" style="">
                                                                        <span>UserID: <strong>72567 </strong></span>
                                                                        <span>UserName: <strong>sellerrnn </strong></span>
                                                                        <span>Percentage: <strong id="remaining-percentage">100%</strong></span>
                                                                    </div>
                                                                </div>
                                                                <div id="input_more_add0"></div>
                                                            </div>
                                                        </div> --}}
                                                        {{-- <button type="button" id="add-container">Add New Container</button> --}}
                                                        <div style="display:flex"> <label for="">Add Another UPC: &nbsp;&nbsp;</label> 
                                                       
                                                        <img src="{{ asset('images/add_circle_outline.svg') }}" alt="add" id="add-container" class="add_img w-6 h-6"></div>
                                                        <div id="main-container"></div>
                                                        
                                                        <script>
                                                            let totalPercentageLeft = 100;
                                                            let defaultTotalValue1 = 100;
                                                            document.addEventListener('DOMContentLoaded', () => {
                                                                let containerIdCounter = 0;

                                                                let rowCount = 0;
                                                                let defaultTotalValue2 = 100;

                                                                function getSumOfPreviousPercentages2(cnt) {
                                                                    const percentages = document.querySelectorAll(`.coverform_input${containerIdCounter}  input[name="percentage${cnt}[]"]`);
                                                                    console.log('input', percentages);
                                                                    return Array.from(percentages).reduce((acc, input) => acc + parseFloat(input.value || 0), 0);
                                                                }

                                                                function updateRemainingPercentage2(input, cnt) {
                                                                    const remainingPercentage = defaultTotalValue2 - getSumOfPreviousPercentages2(cnt);
                                                                    document.getElementById(`remaining-percentage${cnt}`).innerText = remainingPercentage + '%'; 
                                                                    // input.value = remainingPercentage + '%';
                                                                    console.log('input', input, remainingPercentage, defaultTotalValue2);
                                                                }

                                                                function createContainer() {
                                                                    containerIdCounter++;

                                                                    // Create container elements
                                                                    const container = document.createElement('div');
                                                                    container.classList.add('container', 'p-2');
                                                                    container.innerHTML = `
                                                                    ${containerIdCounter == 1 ? '' : '<img src="/images/remove_circle_outline.svg" class="remove-container-btn remove-btn w-6 h-6">'}
                                                                        <div class="mt-8 space-y-5">
                                                                            <div class="flex gap-5">
                                                                                <!--div class="flex items-center">
                                                                                    <span>Add UPC</span>
                                                                                    <span style="color: red">*</span>
                                                                                    
                                                                                </div-->
                                                                                <div class="flex flex-col relative">
                                                                                    <label for="upcInput-${containerIdCounter}">UPC:<span style="color: red">*</span></label>
                                                                                    <input type="text"  id="upcInput-${containerIdCounter}" oninput="filterOptions(${containerIdCounter})" placeholder="Start typing UPC" autocomplete="off" class="select_btn text-sm border border-gray-900 px-1.5 py-1 rounded-md ">
                                                                                    <div id="optionsContainer${containerIdCounter}" class="options-container top-16"></div>
                                                                                </div>
                                                                                <div class="flex flex-col">
                                                                                    <label for="isrc-${containerIdCounter}">ISRC:</label>
                                                                                    <select name="isrc" id="isrc-${containerIdCounter}" class="select_btn border border-gray-900 px-1.5 py-1 rounded-md">
                                                                                    
                                                                                    </select>
                                                                                </div>
                                                                            </div>
                                                                            <div class="space-y-4">
                                                                                <div class="flex items-center">
                                                                                    <span>Revenue Share To </span>
                                                                                    
                                                                                </div>
                                                                                <h4 class="ml-4 font-medium text-gray-600">Existing Share :</h4>
                                                                                <div class="input-group mb-3">
                                                                                    <div class="user_detailss" style="">
                                                                                        <span>UserID: <strong>72567 </strong></span>
                                                                                        <span>UserName: <strong>sellerrnn </strong></span>
                                                                                        <span>Percentage: <strong id="remaining-percentage${containerIdCounter}">100%</strong></span>
                                                                                    </div>
                                                                                </div>
																				 <div class="flex items-center">
                                                                                <h4 class="ml-4 font-medium text-gray-600">New Share :</h4>
																				<span style="color: red">*</span>
                                                                                    <img src="{{ asset('images/add_circle_outline.svg') }}" data-container-id="${containerIdCounter}" alt="add" class="add-inputs add_img w-6 h-6"></div>
                                                                                <div id="additional-inputs-${containerIdCounter}" class="additional-inputs space-y-2"></div>
                                                                            </div>
                                                                        </div>
                                                                        <input type="hidden" id="json-input-${containerIdCounter}" name="json-input-${containerIdCounter}">
                                                                    `;

                                                                    document.getElementById('main-container').appendChild(container);

                                                                    const nameInput = document.getElementById(`upcInput-${containerIdCounter}`);
                                                                    const genderSelect = document.getElementById(`isrc-${containerIdCounter}`);
                                                                    const additionalInputsContainer = document.getElementById(`additional-inputs-${containerIdCounter}`);
                                                                    const jsonInput = document.getElementById(`json-input-${containerIdCounter}`);
                                                                    const addInputsButton = container.querySelector('.add-inputs');
                                                                    const removeContainerButton = container.querySelector('.remove-container-btn');
                                                                    const RnRevenname = ["Userid", "Username", "Percentage"];
                                                                    const RnRevenname1 = ["Username", "%"];
                                                                    function updateJson() {
                                                                        const jsonData = {
                                                                            UPCid: nameInput.value,
                                                                            ISRC: genderSelect.value,
                                                                            RevenueShareTo: [] // Initialize as empty
                                                                        };
                                                                        

                                                                        const currentInputs = Array.from(additionalInputsContainer.querySelectorAll('input'));
                                                                        for (let i = 0; i < currentInputs.length; i += 3) {
                                                                            const group = {};
                                                                            for (let j = 0; j < 3; j++) {
                                                                                if (currentInputs[i + j]) {
                                                                                    group[RnRevenname[j] + `${i + j + 1}`] = currentInputs[i + j].value;
                                                                                };
                                                                            };
                                                                            jsonData.RevenueShareTo.push(group);
                                                                        };
                                                                        // console.log('jsonData', jsonData)
                                                                        jsonInput.value = JSON.stringify(jsonData);
                                                                        document.getElementById('hid-vls').value = document.querySelectorAll('#main-container .container').length;
                                                                    };

                                                                    function updateAllShares() {
                                                                        const percentages = document.querySelectorAll(`coverform_input${containerIdCounter} input[name="percentage${cnt}[]"`);
                                                                        percentages.forEach(input => {
                                                                            updatePercentage(input, defaultTotalValue1 - getSumOfPreviousPercentages());
                                                                        });
                                                                    }
                                                                    
                                                                    function updatePercentage1(input, maxPercentage, cnt) {
                                                                        const percentage = parseFloat(input.value || 0);
                                                                        if (percentage > maxPercentage) {
                                                                            input.value = maxPercentage;
                                                                        }
                                                                        updateRemainingPercentage2(input, cnt);
                                                                        // updateAllShares();
                                                                    }
                                                                    let droplist = 0;
                                                                    function addAdditionalInputs() {
                                                                        droplist++;
                                                                        const inputGroup = document.createElement('div');
                                                                        inputGroup.classList.add(`coverform_input${containerIdCounter}`, 'input-group', 'flex', 'items-center', 'gap-4');

                                                                        const mainnn = document.createElement('div');

                                                                        const UsernewInput = document.createElement('input');
                                                                        UsernewInput.type = 'text';
                                                                        UsernewInput.placeholder = "Userid";
                                                                        UsernewInput.addEventListener('input', updateJson);
                                                                        UsernewInput.classList.add('select_btn', `list${droplist}`);
                                                                        UsernewInput.setAttribute('name', "shareUPC[]");
                                                                        UsernewInput.setAttribute('autocomplete', "off");
                                                                        UsernewInput.setAttribute('oninput', `RevenupdateNameField(this, ${droplist}, ${containerIdCounter})`);
                                                                        mainnn.appendChild(UsernewInput);

                                                                        // autocomplete="off" oninput="RevenupdateNameField(this, ${rowcntss})"

                                                                        const mainspan = document.createElement('span');
                                                                        mainspan.classList.add('dropdown-menu', 'shareUPCDropdown', 'w-max');
                                                                        mainspan.style.display = 'none';
                                                                        mainspan.setAttribute('id', `shareUPCDropdown${droplist}`);
                                                                        mainnn.appendChild(mainspan);
                                                                        inputGroup.appendChild(mainnn);
                                                                        // shareUPCDropdown
                                                                        
                                                                        // if(RnRevenname1[i] == "Userid") {
                                                                        //     UsernewInput.classList.add(`list${droplist}`)
                                                                        // }
                                                                       

                                                                        for (let i = 0; i < 2; i++) {
                                                                            const newInput = document.createElement('input');
                                                                            newInput.type = 'text';
                                                                            newInput.placeholder = RnRevenname1[i];
                                                                            newInput.addEventListener('input', updateJson);
                                                                            newInput.classList.add('select_btn');
                                                                            if(RnRevenname1[i] == "Username") {
                                                                                newInput.setAttribute('name', "sharename[]");
                                                                            } 
                                                                            
                                                                            if(RnRevenname1[i] == "%") {
                                                                                newInput.setAttribute('name', `percentage${containerIdCounter}[]`);
                                                                                newInput.addEventListener('input', function() {
                                                                                    updatePercentage1(this, totalPercentageLeft, containerIdCounter);
                                                                                });
                                                                            }
                                                                            inputGroup.appendChild(newInput);
                                                                        };
                                                                        const removeButton = document.createElement('img');
                                                                        removeButton.src = "/images/remove_circle_outline.svg";
                                                                        removeButton.classList.add('remove-btn', 'w-6', 'h-6');
                                                                        removeButton.addEventListener('click', () => {
                                                                            inputGroup.remove();
                                                                            updateJson();
                                                                        });

                                                                        inputGroup.appendChild(removeButton);
                                                                        additionalInputsContainer.appendChild(inputGroup);
                                                                        updateJson();
                                                                    };
                                                                    nameInput.addEventListener('input', updateJson);
                                                                    genderSelect.addEventListener('change', updateJson);
                                                                    addInputsButton.addEventListener('click', addAdditionalInputs);

                                                                    $(removeContainerButton).click(function() {
                                                                        container.remove();
                                                                        document.getElementById('hid-vls').value = document.querySelectorAll('#main-container .container').length;
                                                                    });
                                                                    updateJson(); // Initial JSON update
                                                                };
                                                                document.getElementById('add-container').addEventListener('click', createContainer);
                                                                createContainer();
                                                            });












                                                            // ---------------------------------------- New Last ---------------------
                                                            let rowcntss = 0;

                                                            function addMoreFields(id) {
                                                                const container = document.getElementById('input_more_add' + id);
                                                                container.classList.add('space-y-2');
                                                                const inputfeilddiv = document.createElement('div');
                                                                inputfeilddiv.classList.add('coverform_input', 'input-fields', 'grid', 'grid-cols-4', 'grid-flow-col', 'gap-32',
                                                                    'items-center');

                                                                const input = `
                                                                
                                                                    <div class="">
                                                                        <input type="text" onchange="generateJSON(${id})" name="shareUPC[]" onkeyup="checkInput()" placeholder="Enter value" class=" input-field${id} shareUPC border px-1.5 py-1 select_btn" autocomplete="off" oninput="RevenupdateNameField(this, ${rowcntss})">
                                                                        <span class="dropdown-menu shareUPCDropdown w-max " id="shareUPCDropdown${rowcntss}" style="display: none;"></span>    
                                                                    </div>
                                                                    <input type="text" placeholder="Enter value" name="sharename[]" required autocomplete="off" class="form-control select-field input-field${id} border px-1.5 py-1 select_btn" readonly>
                                                                    <input type="text" placeholder="%" onchange="generateJSON(${id})" name="percentage[]" class="input-field${id} border px-1.5 py-1 select_btn form-control percentageinput">
                                                                `;
                                                                inputfeilddiv.insertAdjacentHTML('beforeend', input);
                                                                const image = document.createElement("img");
                                                                image.src = "{{ asset('images/remove_circle_outline.svg') }}";
                                                                image.alt = "remove";
                                                                image.classList.add('h-6', 'w-6', 'cursor-pointer')
                                                                image.onclick = function() {
                                                                    removeInputFields(this);
                                                                };
                                                                inputfeilddiv.appendChild(image);
                                                                container.appendChild(inputfeilddiv);
                                                                rowcntss++;
                                                            };

                                                            function removeInputFields(button) {
                                                                const wrapper = button.parentElement;
                                                                wrapper.remove();
                                                            }

                                                           const upcToIsrcMap = @json($upcToIsrcMap);
                                                            function updateIsrcOptions(selectedUpc, id) {
                                                               console.log('selectedUpc', selectedUpc)
															   console.log('upcToIsrcMap', upcToIsrcMap)
															   
                                                                var isrcSelect = document.getElementById("isrc-" + id);
                                                                isrcSelect.innerHTML = "";
																
																
																
																// Assuming `id` is defined somewhere in your code to identify the specific dropdown
var isrcList = upcToIsrcMap[selectedUpc];

// Get the specific dropdown element by dynamically constructing the ID
var isrcSelect = document.getElementById("isrc-" + id);

// Clear existing options
isrcSelect.innerHTML = "";

// Add the "Apply to all tracks" option as the first dropdown option
var applyToAllOption = document.createElement("option");
applyToAllOption.text = "Apply to all tracks";
applyToAllOption.value = "all"; // Empty value
isrcSelect.appendChild(applyToAllOption);

// Dynamically add ISRC options
if (isrcList) {
    isrcList.forEach(isrc => {
        var option = document.createElement("option");
        option.text = isrc; // Set the display text
        option.value = isrc; // Set the value
        isrcSelect.appendChild(option); // Add to the dropdown
    });
} else {
    var option = document.createElement("option");
        option.text = ''; // Set the display text
        option.value = ''; // Set the value
        isrcSelect.appendChild(option); // Add to the dropdown
}
         if (selectedUpc === "5054316798316") {
                                                                    var option1 = document.createElement("option");
                                                                    option1.text = "";
                                                                    option1.value = "";
                                                                    isrcSelect.add(option1);

                                                                    var option2 = document.createElement("option");
                                                                    option2.text = "GX38U2405519";
                                                                    option2.value = "GX38U2405519";

                                                                    var option3 = document.createElement("option");
                                                                    option3.text = "Apply to all tracks";
                                                                    option3.value = "Apply to all tracks";

                                                                    isrcSelect.add(option2);
                                                                    isrcSelect.add(option3);
                                                                } else if (selectedUpc === "5054316798312") {
                                                                    var option3 = document.createElement("option");
                                                                    option3.text = "";
                                                                    option3.value = "";
                                                                    isrcSelect.add(option3);

                                                                    var option4 = document.createElement("option");
                                                                    option4.text = "GX38U2405629";
                                                                    option4.value = "GX38U2405629";
                                                                    isrcSelect.add(option4);

                                                                    var option5 = document.createElement("option");
                                                                    option5.text = "Apply to all tracks";
                                                                    option5.value = "Apply to all tracks";
                                                                    isrcSelect.add(option5);
                                                                }
                                                            }

                                                            function handleInputSelection(selectedText, events) {
																
                                                               
                                                                    updateIsrcOptions(selectedText, events);
                                                                
                                                            }
                                                            const options1 = @json($data2);

  
const options = options1.map(item => ({
    value: item.upc,
    text: item.upc
}));

                                                            function filterOptions(events) {
                                                                
                                                                const input = document.getElementById('upcInput-' + events).value.toLowerCase();
                                            
                                                                const container = document.getElementById('optionsContainer' + events);
                                                                const filteredOptions = options.filter(option => {
                // Convert option.text to string before calling toLowerCase
                const optionText = String(option.text);
                return optionText.toLowerCase().includes(input);
            });
                                                              //  const filteredOptions = options.filter(option => option.text.toLowerCase().includes(input));

                                                                

                                                                container.innerHTML = '';
                                                                if (filteredOptions.length > 0 && input) {
                                                                    filteredOptions.forEach(option => {
                                                                        const listelement = document.createElement('div');
                                                                        listelement.textContent = option.text;
                                                                        listelement.onclick = function() {
                                                                            document.getElementById('upcInput-' + events).value = this.textContent;
                                                                            document.getElementById('upcInput-' + events).setAttribute('data-id', this.textContent)
                                                                            container.style.display = 'none';
                                                                            handleInputSelection(this.textContent, events);
                                                                        };
                                                                        container.appendChild(listelement);
                                                                    });
                                                                    container.style.display = 'block';
                                                                } else {
                                                                    container.style.display = 'none';
                                                                }
                                                            };
															

    


    //console.log(formattedOptions); 
                                                            let $data = @json($data1);
                                                            let debounceTimer;
                                                            const MAX_RESULTS = 10; // Limit to 10 items

function RevenupdateNameField(inputElement, id, mid) {
    clearTimeout(debounceTimer);
    debounceTimer = setTimeout(function () {
        const inputValue = inputElement.value.trim().toLowerCase();
        const dropdownMenu = document.querySelector(`.coverform_input${mid} #shareUPCDropdown${id}`);
        dropdownMenu.innerHTML = '';

        if (inputValue.length > 0) {
            let count = 0;

            $data.some(function (user) {
                if (user.uid.toString().toLowerCase().includes(inputValue)) {
                    var option = document.createElement('div');
                    option.classList.add('dropdown-item');
                    option.textContent = user.uid;
                    option.onclick = function () {
                        inputElement.value = user.uid;

                        // Set the corresponding name in the sharename input field
                        var sharenameInput = inputElement.closest(`.coverform_input${mid}`).querySelector('[name="sharename[]"]');
                        sharenameInput.value = user.name;
                        dropdownMenu.style.display = 'none';
                    };
                    dropdownMenu.appendChild(option);
                    count++;

                    if (count >= MAX_RESULTS) {
                        return true; // Stop when 10 items are displayed
                    }
                }
                return false;
            });

            dropdownMenu.style.display = 'block';
        } else {
            dropdownMenu.style.display = 'none';
        }

        if (inputElement.value == '') {
            var sharenameInput = inputElement.closest(`.coverform_input${mid}`).querySelector('[name="sharename[]"]');
            sharenameInput.value = '';
        }
    }, 300); // Debouncing with a 300ms delay
}



                                                            // function RevenupdateNameField(inputElement, id, mid) {

                                                            //     console.log('Input changed - 1'); // Debug statement
                                                            //     const inputValue = inputElement.value.trim().toLowerCase();
                                                            //     const dropdownMenu = document.querySelector(`.coverform_input${mid} #shareUPCDropdown${id}`); 
                                                            //     dropdownMenu.innerHTML = '';
                                                            //     $data.forEach(function(user) {
                                                            //         if (user.uid.toString().toLowerCase().includes(inputValue)) {
                                                            //             var option = document.createElement('div');
                                                            //             option.classList.add('dropdown-item');
                                                            //             option.textContent = user.uid;
                                                            //             option.onclick = function() {
                                                            //                 inputElement.value = user.uid;

                                                            //                 // Set the corresponding name in the sharename input field
                                                            //                 var sharenameInput = inputElement.closest(`.coverform_input${mid}`).querySelector('[name="sharename[]"]');
                                                            //                 // console.log('inputValue', sharenameInput, user)
                                                            //                 sharenameInput.value = user.name;
                                                            //                 dropdownMenu.style.display = 'none';

                                                            //             };
                                                            //             dropdownMenu.appendChild(option);
                                                            //         }
                                                            //     });
                                                            //     if (inputElement.value == '') {
                                                            //         var sharenameInput = inputElement.closest(`.coverform_input${mid}`).querySelector('[name="sharename[]"]');
                                                            //         sharenameInput.value = '';
                                                            //     }

                                                            //     // Display the dropdown menu
                                                            //     if (inputValue.length > 0) {
                                                            //         dropdownMenu.style.display = 'block';
                                                            //     } else {
                                                            //         dropdownMenu.style.display = 'none';
                                                            //     }
                                                            // }

                                                            function generateJSON(id) {
                                                                // Select all input fields related to the given ID
                                                                const inputs = document.querySelectorAll(".input-field" + id);
                                                                const data = [{}];
                                                                // const data = {};

                                                                // Iterate through inputs in pairs
                                                                for (let i = 0; i < inputs.length; i += 3) {
                                                                    if (i + 2 < inputs.length) { // Ensure there are enough elements in the pair
                                                                        const uniqueId = Math.floor(i / 3);
                                                                        // data.push({
                                                                        // value1: inputs[i].value,
                                                                        // value2: inputs[i + 1].value,
                                                                        // Revenue: [
                                                                        //     {
                                                                        //         uid: inputs[i + 2].value,
                                                                        //         user: inputs[i + 3].value,
                                                                        //         percentage: inputs[i + 4].value,
                                                                        //     }
                                                                        // ]
                                                                        // });
                                                                        data[`text${uniqueId}`] = {
                                                                            value1: inputs[i].value,
                                                                            value2: inputs[i + 1].value,
                                                                            Revenue: [{
                                                                                uid: inputs[i + 2].value,
                                                                                user: inputs[i + 3].value,
                                                                                percentage: inputs[i + 4].value,
                                                                            }]
                                                                        };
                                                                    }
                                                                }

                                                                // Convert to JSON format and log it
                                                                const json = JSON.stringify(data, null, 2);
                                                                // console.log('json', data);
                                                            }
                                                        </script>
                                                    </div>
                                                </div>
                                            </div>
                                            <div>




                                                <div
                                                    style="padding: 20px;display: flex;justify-content: space-between;">

                                                    <button class="btn" id="submit3">Submit</button>

                                                    <style>
                                                        .enabled {
                                                            cursor: pointer !important;
                                                        }
                                                    </style>

                                                    <script>
                                                        function checkInput() {
                                                            var inputValue = document.getElementById('form_value').value.trim();
                                                            var submitButton = document.getElementById('submit3');
                                                            if (inputValue !== '') {
                                                                submitButton.removeAttribute('disabled');
                                                                submitButton.classList.add('enabled');
                                                            } else {
                                                                submitButton.setAttribute('disabled', 'disabled');
                                                                submitButton.classList.remove('enabled');
                                                            }
                                                        }
                                                    </script>
                                                    <a
                                                        style="cursor:pointer;text-decoration: none;margin: auto 0;float: right;">Clear
                                                        Form</a>
                                                </div>
                                            </div>

                                        </div>
                                </div>
                            </div>
                        </div>
                        </form>
                    </div>
                @endif
                <style>
                    .form_input input {
                        width: 95%;
                        border: 1px solid #ccc;
                        padding: 5px;
                        border-radius: 6px;
                        margin-top: 5px;
                    }

                    .verify_btn {
                        background: #f0eaf8;
                        padding: 3px 10px;
                        border-radius: 5px;
                        border: none;
                        color: #5a39b6;
                        box-shadow: 1px 1px 4px #000;
                    }

                    .select_btn {
                        padding: 10px;
                        border: 1px solid #ccc;
                        border-radius: 6px;
                        background: #fff;
                        color: #000;
                        width: 150px;
                        cursor: pointer;
                        box-sizing: border-box;
                        transition: border-color 0.3s ease;
                    }

                    .select_btn:focus {
                        outline: none;
                        border-color: #ccc;
                    }


                    .select_btn:focus {
                        box-shadow: 0 0 3px rgba(0, 0, 0, 0.3);
                    }

                    .user_detailss {
                        display: flex;
                        justify-content: space-evenly;
                        background: #f7f7f7;
                        border-radius: 10px;
                        padding: 10px;
                    }

                    .user_detailss span {
                        margin: auto 0;
                    }

                    @keyframes blink {
                        0% {
                            outline: 2px solid red;
                        }

                        50% {
                            outline: 2px solid rgba(228, 228, 228, 0);
                        }

                        100% {
                            outline: 2px solid red;
                        }
                    }

                    .blinking {
                        animation: blink 1.5s infinite;
                    }
                </style>

</html>

<script>
    let array = [];

    function getarray(val, event, name) {

        // console.log('event', val, event);
        if (array.length == event + 1) {

        }
        if (array.length > 0) {
            if (name == 'isrc') {
                array[0]['isrc'] = val.value;
                console.log('event', val.value, event, array)
            }
        } else {
            if (name == 'upc') {
                array.push({
                    "upc": val.value
                });
                console.log('event', val.value, event, array)
            }
        }

    }


    //populateOptions();
</script>
<style>
    .options-container {
        display: none;
        border: 1px solid #ccc;
        max-height: 150px;
        overflow-y: auto;
        position: absolute;
        background: white;
        z-index: 1000;
    }

    .options-container div {
        padding: 8px;
        cursor: pointer;
    }

    .options-container div:hover {
        background: #f0f0f0;
    }
</style>
<script>
    let totalPercentageLefta = 100; // Initial total percentage
    let rowcnt = 0;

    function addTextField1() {
        const container = document.getElementById('input_fields_containerr0');
        // const rowcnt = container.children.length + 1;
        // for (let i = 0; i < 1; i++) {
        const newDiv = document.createElement('div');
        // newDiv.className = 'form_input';
        newDiv.classList.add('form_wrappers')
        // <input type="text" class="form-control percentageinput" name="percentage[]" placeholder="%" oninput="updatePercentage(this, ${totalPercentageLefta})">
        newDiv.innerHTML = `
				<br>
                    <div style="width: 100%; gap:20px; display:flex; font-size: 12px" class="form_input">
                        <div style="">UserID:<br>
                            <input type="text" class="form_input form-control shareUPC input-field" onkeyup="checkInput()" name="shareUPC[]" required autocomplete="off" oninput="updateNameField(this, ${rowcnt})">
                            <span class="dropdown-menu shareUPCDropdown" id="shareUPCDropdown${rowcnt}" style="display: none;"></span>
                        </div>
                        <div>
                            UserName:<br>
                            <input type="text" class="form-control select-field" name="sharename[]" required autocomplete="off" readonly>
                        </div>
                        <div>
                            Enter Percentage:<br>
                            <input type="text" class="form-control percentageinput" name="percentage[]" placeholder="%" >
                        </div>
                        <div style="margin: auto; width: 5%">
                            <br>
                            <img src="{{ asset('images/remove_circle_outline.svg') }}" alt="remove" onclick="removeTextField(this)" class="remove_img">
                        </div>
                    </div>
                `;

        container.appendChild(newDiv);

        // newDiv.addEventListener("input", generateJSON);
        const inputFields = newDiv.querySelectorAll('.input-field');
        const percentageFields = newDiv.querySelectorAll('.percentageinput');

        inputFields.forEach(input => input.addEventListener('input', generateJSON));
        percentageFields.forEach(input => input.addEventListener('input', generateJSON));
        rowcnt++;

        // }
    }

    function generateJSON_() {
        const inputFields = document.querySelectorAll(".input-field");
        const selectFields = document.querySelectorAll(".select-field");
        const percentageFields = document.querySelectorAll(".percentageinput");
        const inputPairs = [];

        inputFields.forEach((input, index) => {
            const select = index < selectFields.length ? selectFields[index] : null;
            const percentage = index < percentageFields.length ? percentageFields[index].value : '';

            if (input instanceof HTMLInputElement && select instanceof HTMLInputElement) {
                inputPairs.push({
                    userID: input.value,
                    userName: select ? select.value : '',
                    percentage: percentage
                });
            }
        });

        const json = JSON.stringify(inputPairs, null, 2);
        console.log('inputPairs', json)
    }

    function removeTextField(element) {
        const fieldContainer = element.closest('.form_input');
        if (fieldContainer) {
            const percentageInput = fieldContainer.querySelector('input[name="percentage[]"]');
            if (percentageInput) {
                totalPercentageLeft += parseFloat(percentageInput.value) || 0; // Restore the removed percentage
            }
            fieldContainer.remove();
        }
    }

    function checkInput() {
        // Add your implementation here
    }



    function updateNameField(inputElement, id) {

        console.log('Input changed - 1', inputElement, id); // Debug statement
        const inputValue = inputElement.value.trim().toLowerCase();
        const dropdownMenu = document.getElementById('shareUPCDropdown' + id);
        console.log('dropdownMenu', dropdownMenu)
        // Clear the dropdown menu
        dropdownMenu.innerHTML = '';

        // Filter and display similar values from $data
        $data.forEach(function(user) {
            if (user.uid.toString().toLowerCase().includes(inputValue)) {
                var option = document.createElement('div');
                option.classList.add('dropdown-item');
                option.textContent = user.uid;
                option.onclick = function() {
                    inputElement.value = user.uid;
                    // Set the corresponding name in the sharename input field
                    var sharenameInput = inputElement.closest(
                        '.form_input').querySelector(
                        '[name="sharename[]"]');
                    sharenameInput.value = user.name;
                    dropdownMenu.style.display = 'none';
                };
                dropdownMenu.appendChild(option);
            }
        });
        if (inputElement.value == '') {
            var sharenameInput = inputElement.closest(
                '.form_input').querySelector(
                '[name="sharename[]"]');
            sharenameInput.value = '';
        }
        // Display the dropdown menu
        if (inputValue.length > 0) {
            dropdownMenu.style.display = 'block';
        } else {
            dropdownMenu.style.display = 'none';
        }
    }

    function updatePercentage(input, totalPercentageLeft) {
        console.log('totalPercentageLeft', input)
        const percentage = parseFloat(input.value || 0);
        if (percentage > maxPercentage) {
            input.value = maxPercentage;
        }
        updateRemainingPercentage();
        updateAllShares();
    }
</script>



<script>
    function getSumOfPreviousPercentages() {
        const percentages = document.querySelectorAll('input[name="percentage[]"]');
        return Array.from(percentages).reduce((acc, input) => acc + parseFloat(input.value || 0), 0);
    }

    function updateRemainingPercentage() {
   
        const remainingPercentage = defaultTotalValue1 - getSumOfPreviousPercentages();
        document.getElementById('remaining-percentage').innerText = remainingPercentage + '%';
    }
    let rowcnt2 = 0;
    // let totalPercentageLeft = 100; // Example total percentage left
    // function addTextField2(number) {
    //     const container = document.getElementById('input_fields_container' + number);

    //     // Ensure totalPercentageLeft is valid and non-negative
    //     if (totalPercentageLefta <= 0) {
    //         alert('No percentage left to allocate.');
    //         return;
    //     }

    //     const newDiv = document.createElement('div');
    //     newDiv.className = 'form_input';
    //     // <div style=""> Enter Percentage:<br><input type="text" class="form-control" name="percentage[]" placeholder="%" oninput="updatePercentage(this, ${totalPercentageLeft})"> </div>
    //     newDiv.innerHTML = `
    //             <div style="width: 100%; gap:20px; display:flex; font-size: 12px">
    //                 <div>
    //                     UserID:<br>
    //                    <input type="text" class="form-control shareUPC input-field" onkeyup="checkInput()" name="shareUPC[]" required autocomplete="off" oninput="updateNameField(this, ${rowcnt2})">
    //             <span class="dropdown-menu" id="shareUPCDropdown" style="display: none;"></span>
    //                 </div>
    //                 <div>
    //                     UserName:<br>
    //                     <input type="text" class="form-control select-field" name="sharename[]" required autocomplete="off" readonly>
    //                 </div>
    //                  <div style=""> Enter Percentage:<br><input type="text" class="form-control percentageinput" name="percentage[]" placeholder="%" oninput="updatePercentage(this, ${totalPercentageLeft})"> </div>
    //                 <div style="margin: auto; width: 5%">
    //                     <br>
    //                     <img src="{{ asset('images/remove_circle_outline.svg') }}" alt="remove" onclick="removeTextField(this)" class="remove_img">
    //                 </div>
    //             </div>
    //         `;

    //     container.appendChild(newDiv);
    //     rowcnt2++;
    //     const inputFields = newDiv.querySelectorAll('.input-field');
    //         const percentageFields = newDiv.querySelectorAll('.percentageinput');

    //         inputFields.forEach(input => input.addEventListener('input', generateJSON));
    //         percentageFields.forEach(input => input.addEventListener('input', generateJSON));
    // }


    function addTextField2(rowCount) {
        const inputFieldsDiv = document.getElementById('input_fields_containerr' + rowCount);
        console.log('inputFieldsDiv', inputFieldsDiv, rowCount)

        // Create a wrapper for the input fields and remove button using HTML string
        const htmlString = `
            <div class="input-wrapper">
                <input type="text" placeholder="Enter value" class="input-field">
                <input type="text" placeholder="Enter value" class="input-field">
                <button class="remove-button" onclick="removeInputFields(this)">Remove</button>
            </div>
        `;

        // Insert the HTML string into the input fields container
        inputFieldsDiv.insertAdjacentHTML('beforeend', htmlString);
    }

    function removeTextField(element) {
        const fieldContainer = element.closest('.form_input');
        if (fieldContainer) {
            const percentageInput = fieldContainer.querySelector('input[name="percentage[]"]');
            if (percentageInput) {
                totalPercentageLeft += parseFloat(percentageInput.value) || 0; // Restore the removed percentage
            }
            fieldContainer.remove();
        }
    }

    function removeTextField1(element) {
        document.getElementById('input_fields_container').removeChild(element.closest('.input-group'));
        rowCount--;
        updateRemainingPercentage();
        updateAllShares();
    }



    function updatePercentage(input, maxPercentage) {
        const percentage = parseFloat(input.value || 0);
        if (percentage > maxPercentage) {
            input.value = maxPercentage;
        }
        updateRemainingPercentage();
        updateAllShares();
    }

   
</script>


<style>
    .form_input {
        margin-bottom: 10px;
    }

    .remove_img {
        cursor: pointer;
        width: 25px;
        height: 25px;
    }

    .add_img {
        cursor: pointer;
        width: 40px;
        height: 25px;
    }
</style>
