<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <meta name="csrf-token" content="<?php echo e(csrf_token()); ?>">
    <link rel="icon" type="image/png" href="<?php echo e(asset('images/favicon.png')); ?>" id="favicon">
    <title>Smarthub - RN</title>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <style>
        #demo {
            display: flex;
            flex-direction: column;
            gap: 1rem;
        }
    </style>
</head>

<body>
    <div id="demo"></div>
    <script>
        const TaskLog1 = () => {
            return $.ajax({
                url: '/gettasks',
                type: 'GET',
                success: function(response) {
                    return response;
                },
                error: function(error) {
                    console.error('Error:', error);
                }
            });
        };

        TaskLog1().then(data => {
            // console.log('Tasks:', data);

            const createcalling = (id, name, upc, email, type) => {
                $.ajax({
                    url: '/slackcreate',
                    type: 'POST',
                    headers: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                    },
                    data: {
                        id: JSON.stringify(id),
                        name: JSON.stringify(name),
                        email: JSON.stringify(email),
                        upc: JSON.stringify(upc),
                        type: JSON.stringify(type),
                        message: `List of Moderation which are all going to be Overdue in next 48 hours
                            Username: ${name}
                            UPC: ${upc}
                            Email: ${email}
                            Type: ${type}
                        `
                    },
                    success: function(response) {
                        $('#demo').append(`<p>${response.slack == "expired" ? "asana & slack --- expired" : "slack --- created"}</p>`);
                        if (response.slack.ok) {
                            // ReportlistCl();
                        }
                    },
                    error: function(error) {
                        console.error('Error:', error);
                    }
                });
            }

            const subcreatecalling = (id, name, upc, email, type) => {
                $.ajax({
                    url: '/asanacreate',
                    type: 'POST',
                    headers: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                    },
                    data: {
                        id: id,
                        name: name,
                        email: email,
                        message: `Over Due Moderation List
                        Username: ${name}
                        UPC: ${upc}
                        Email: ${email} 
                        Type: ${type}`
                    },
                    success: function(response) {
                        $('#demo').append(`<p>${response.asana == "expired" ? "asana & slack --- expired" : "asana --- created"}</p>`);
                        // console.log('response:', response);
                    },
                    error: function(error) {
                        console.error('Error:', error);
                    }
                });
            }

            function removeDuplicates(data2345) {
                const uniqueData = [];
                const seen = new Set();
            
                data2345.forEach((item) => {
                const key = `${item.id}-${item.User}-${item.Email}-${item.usertype}`;
                if (!seen.has(key)) {
                    seen.add(key);
                    uniqueData.push(item);
                }
                });
            
                return uniqueData;
            }

            const calculateEscalationTime = (createdTime, moderationTime, usertype, upctype, elapsetime1, elapsetime2) => {
                const createdDate = new Date(createdTime);
                const currentDate = new Date();
                const moderationDays = parseInt(moderationTime, 10);

                // Calculate elapsed days and total seconds
                const timeDiff = (currentDate - createdDate) / (1000 * 60 * 60 * 24);
                const daysElapsed = timeDiff;
                const totalSeconds = timeDiff * 24 * 60 * 60;

                // Determine status
                let status = "grey"; // Default status
                if (daysElapsed > 25) {
                    status = "red";
                } else if (
                    (daysElapsed >= elapsetime1 && usertype === 'Enterprise') ||
                    (daysElapsed > elapsetime2 && usertype === 'Priority' && upctype !== 'Premium') ||
                    (daysElapsed > elapsetime1 && usertype === 'Normal') ||
                    (daysElapsed > elapsetime1 && usertype === 'Priority' && upctype === 'Premium') ||
                    (daysElapsed > elapsetime2 && usertype === 'Priority' && upctype === 'Normal')
                ) {
                    status = "orange";
                } else if (
                    (daysElapsed >= 4 && usertype === 'Enterprise') ||
                    (daysElapsed >= 6 && usertype === 'Priority' && upctype !== 'Premium') ||
                    (daysElapsed >= 6 && usertype === 'Priority' && upctype === 'Normal') ||
                    (daysElapsed >= 4 && usertype === 'Priority' && upctype === 'Premium') ||
                    (daysElapsed >= 11 && usertype === 'Normal')
                ) {
                    status = "yellow";
                }

                return {
                    daysElapsed,
                    status,
                    totalSeconds
                };
            };

            const convertSecondsToTime = (totalSeconds) => {
                const days = Math.floor(totalSeconds / (24 * 60 * 60));
                const hours = Math.floor((totalSeconds % (24 * 60 * 60)) / (60 * 60));
                const minutes = Math.floor((totalSeconds % (60 * 60)) / 60);
                const seconds = Math.floor(totalSeconds % 60);

                const adjustedDays = days + Math.floor(hours / 24);
                const adjustedHours = hours % 24;

                return {
                    days: adjustedDays.toString().padStart(2, '0'),
                    hours: adjustedHours.toString().padStart(2, '0'),
                    minutes: minutes.toString().padStart(2, '0'),
                    seconds: seconds.toString().padStart(2, '0')
                };
            };

            async function clll(response) {
                const updatedData = await response.map(item => {
                    const {
                        daysElapsed,
                        status,
                        totalSeconds
                    } = calculateEscalationTime(
                        item.Created_Time,
                        item.moderation_time,
                        item.usertype,
                        item.upctype,
                        item.elapsetime1,
                        item.elapsetime2
                    );

                    const daysRema = convertSecondsToTime(totalSeconds);
                    const daysRemaining =
                        `${daysRema.days} days ${daysRema.hours}:${daysRema.minutes}:${daysRema.seconds}`;

                    return {
                        ...item,
                        daysRemaining,
                        status,
                        totalSeconds
                    };
                });
                const createCallingData = {
                    ids: [],
                    users: [],
                    upc: [],
                    emails: [],
                    type: []
                };

                const subCreateCallingData = {
                    ids: [],
                    users: [],
                    upc: [],
                    emails: [],
                    type: []
                };

                // Process each item and accumulate data based on conditions
                removeDuplicates(updatedData).forEach(item => {
                    const daysslice = item.daysRemaining.split(' ');
                    const dayss = daysslice[2].split(':')[0];

                    console.log('item', item)

                    // console.log('dayss', Number(daysslice[0]));

                    // Collect data
                    const id = item.id;
                    const user = item.User;
                    const upc = item.upc;
                    const email = item.Email;
                    const type = item.usertype
                    if(Number(daysslice[0]) >= item.elapsetime1) {
                        // Accumulate data for subcreatecalling
                        subCreateCallingData.ids.push(id);
                        subCreateCallingData.users.push(user);
                        subCreateCallingData.upc.push(upc);
                        subCreateCallingData.emails.push(email);
                        subCreateCallingData.type.push(type);
                    }
                    if (Number(daysslice[0]) >= item.elapsetime2) {
                        createCallingData.ids.push(id);
                        createCallingData.users.push(user);
                        createCallingData.upc.push(upc);
                        createCallingData.emails.push(email);
                        createCallingData.type.push(type);
                        // console.log('createCallingData', createCallingData)
                    }
                    // console.log('Number', Number(daysslice[0]), item.elapsetime1, item.elapsetime2)
                   
                    if(Number(daysslice[0]) >= item.elapsetime1) {
                        if(Number(daysslice[0]) >= item.elapsetime2) {
                            if (createCallingData.ids.length > 0) {
                                // console.log('llllllll', createCallingData.ids, createCallingData.users, createCallingData.upc, createCallingData.emails, createCallingData.type)
                                // createcalling(createCallingData.ids, createCallingData.users, createCallingData.upc, createCallingData.emails, createCallingData.type);
                                if(item.Level2 == "0") {
                                    subcreatecalling(subCreateCallingData.ids, subCreateCallingData.users, subCreateCallingData.upc, subCreateCallingData.emails, subCreateCallingData.type);
                                    createcalling(createCallingData.ids, createCallingData.users, createCallingData.upc, createCallingData.emails, createCallingData.type);
                                }else {
                                    createcalling(createCallingData.ids, createCallingData.users, createCallingData.upc, createCallingData.emails, createCallingData.type); 
                                }
                            }
                        } else {
                            if (subCreateCallingData.ids.length > 0) {
                                subcreatecalling(subCreateCallingData.ids, subCreateCallingData.users, subCreateCallingData.upc, subCreateCallingData.emails, subCreateCallingData.type);
                            }
                        }
                    }
                });

                // console.log('updatedData', removeDuplicates(updatedData));
            }

            clll(data);
        }).catch(error => {
            console.error('Error fetching tasks:', error);
        });
    </script>
</body>

</html>
<?php /**PATH /var/www/html/smart-hub/resources/views//escalation_mod_cron.blade.php ENDPATH**/ ?>